package com.alibaba.fastjson.parser;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONPObject;
import com.alibaba.fastjson.JSONPath;
import com.alibaba.fastjson.PropertyNamingStrategy;
import com.alibaba.fastjson.parser.deserializer.JSONPDeserializer;
import com.alibaba.fastjson.parser.deserializer.JavaObjectDeserializer;
import com.alibaba.fastjson.parser.deserializer.Jdk8DateCodec;
import com.alibaba.fastjson.parser.deserializer.MapDeserializer;
import com.alibaba.fastjson.parser.deserializer.NumberDeserializer;
import com.alibaba.fastjson.parser.deserializer.OptionalCodec;
import com.alibaba.fastjson.parser.deserializer.SqlDateDeserializer;
import com.alibaba.fastjson.parser.deserializer.StackTraceElementDeserializer;
import com.alibaba.fastjson.parser.deserializer.TimeDeserializer;
import com.alibaba.fastjson.serializer.AtomicCodec;
import com.alibaba.fastjson.serializer.AwtCodec;
import com.alibaba.fastjson.serializer.BigDecimalCodec;
import com.alibaba.fastjson.serializer.BigIntegerCodec;
import com.alibaba.fastjson.serializer.BooleanCodec;
import com.alibaba.fastjson.serializer.CalendarCodec;
import com.alibaba.fastjson.serializer.CharArrayCodec;
import com.alibaba.fastjson.serializer.CharacterCodec;
import com.alibaba.fastjson.serializer.CollectionCodec;
import com.alibaba.fastjson.serializer.DateCodec;
import com.alibaba.fastjson.serializer.FloatCodec;
import com.alibaba.fastjson.serializer.IntegerCodec;
import com.alibaba.fastjson.serializer.LongCodec;
import com.alibaba.fastjson.serializer.MiscCodec;
import com.alibaba.fastjson.serializer.ObjectArrayCodec;
import com.alibaba.fastjson.serializer.ReferenceCodec;
import com.alibaba.fastjson.serializer.StringCodec;
import com.alibaba.fastjson.util.ASMClassLoader;
import com.alibaba.fastjson.util.ASMUtils;
import com.alibaba.fastjson.util.IOUtils;
import com.alibaba.fastjson.util.IdentityHashMap;
import com.alibaba.fastjson.util.ServiceLoader;
import com.alibaba.fastjson.util.TypeUtils;
import com.google.protobuf.CodedOutputStream;
import com.google.zxing.oned.rss.expanded.decoders.DecodedChar;
import j1.g;
import java.io.Closeable;
import java.io.File;
import java.io.Serializable;
import java.lang.ref.SoftReference;
import java.lang.ref.WeakReference;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import java.lang.reflect.WildcardType;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.Inet4Address;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.URI;
import java.net.URL;
import java.nio.charset.Charset;
import java.security.AccessControlException;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Currency;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.TimeZone;
import java.util.TreeMap;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicIntegerArray;
import java.util.concurrent.atomic.AtomicLong;
import java.util.concurrent.atomic.AtomicLongArray;
import java.util.concurrent.atomic.AtomicReference;
import java.util.regex.Pattern;
import javax.sql.DataSource;
import javax.xml.datatype.XMLGregorianCalendar;
import k1.a;
import k1.c;
import k1.d;
import k1.e;
import k1.i;
import k1.k;
import k1.l;
import k1.n;
import k1.o;
import k1.q;
import m1.b;
/* loaded from: classes.dex */
public class ParserConfig {
    public static final String[] n;
    public static ParserConfig p;
    public static boolean q;
    public static boolean r;
    public final IdentityHashMap<Type, l> a;
    public boolean b;
    public final g c;
    public PropertyNamingStrategy d;
    public ClassLoader e;
    public a f;
    public boolean g;
    public String[] h;
    public String[] i;
    public int j;
    public final boolean k;
    public boolean l;
    public static final String[] m = q(IOUtils.k("fastjson.parser.deny"));
    public static final boolean o = "true".equals(IOUtils.k("fastjson.parser.autoTypeSupport"));

    static {
        String[] q2 = q(IOUtils.k("fastjson.parser.autoTypeAccept"));
        if (q2 == null) {
            q2 = new String[0];
        }
        n = q2;
        p = new ParserConfig();
        q = false;
        r = false;
    }

    public ParserConfig() {
        this(false);
    }

    public static Field l(String str, Map<String, Field> map) {
        char charAt;
        Field field = map.get(str);
        if (field == null) {
            field = map.get("_" + str);
        }
        if (field == null) {
            field = map.get("m_" + str);
        }
        if (field != null || (charAt = str.charAt(0)) < 'a' || charAt > 'z') {
            return field;
        }
        char[] charArray = str.toCharArray();
        charArray[0] = (char) (charArray[0] - ' ');
        return map.get(new String(charArray));
    }

    public static ParserConfig m() {
        return p;
    }

    public static boolean n(Class<?> cls) {
        return cls.isPrimitive() || cls == Boolean.class || cls == Character.class || cls == Byte.class || cls == Short.class || cls == Integer.class || cls == Long.class || cls == Float.class || cls == Double.class || cls == BigInteger.class || cls == BigDecimal.class || cls == String.class || cls == Date.class || cls == java.sql.Date.class || cls == Time.class || cls == Timestamp.class || cls.isEnum();
    }

    public static void o(Class<?> cls, Map<String, Field> map) {
        Field[] declaredFields;
        for (Field field : cls.getDeclaredFields()) {
            String name = field.getName();
            if (!map.containsKey(name)) {
                map.put(name, field);
            }
        }
        if (cls.getSuperclass() == null || cls.getSuperclass() == Object.class) {
            return;
        }
        o(cls.getSuperclass(), map);
    }

    public static String[] q(String str) {
        if (str == null || str.length() <= 0) {
            return null;
        }
        return str.split(",");
    }

    public void a(String str) {
        if (str == null || str.length() == 0) {
            return;
        }
        for (String str2 : this.i) {
            if (str.equals(str2)) {
                return;
            }
        }
        String[] strArr = this.i;
        int length = strArr.length + 1;
        String[] strArr2 = new String[length];
        System.arraycopy(strArr, 0, strArr2, 0, strArr.length);
        strArr2[length - 1] = str;
        this.i = strArr2;
    }

    public void b(String str) {
        if (str == null || str.length() == 0) {
            return;
        }
        for (String str2 : this.h) {
            if (str.equals(str2)) {
                return;
            }
        }
        String[] strArr = this.h;
        int length = strArr.length + 1;
        String[] strArr2 = new String[length];
        System.arraycopy(strArr, 0, strArr2, 0, strArr.length);
        strArr2[length - 1] = str;
        this.h = strArr2;
    }

    public final void c(String[] strArr) {
        if (strArr == null) {
            return;
        }
        for (String str : strArr) {
            a(str);
        }
    }

    public final void d(String[] strArr) {
        if (strArr == null) {
            return;
        }
        for (String str : strArr) {
            b(str);
        }
    }

    public Class<?> e(String str, Class<?> cls) {
        if (str == null) {
            return null;
        }
        if (str.length() < this.j) {
            String replace = str.replace(DecodedChar.FNC1, '.');
            int i = 0;
            if (this.g || cls != null) {
                int i2 = 0;
                while (true) {
                    String[] strArr = this.i;
                    if (i2 >= strArr.length) {
                        int i3 = 0;
                        while (true) {
                            String[] strArr2 = this.h;
                            if (i3 >= strArr2.length) {
                                break;
                            } else if (replace.startsWith(strArr2[i3]) && TypeUtils.E(str) == null) {
                                throw new JSONException("autoType is not support. " + str);
                            } else {
                                i3++;
                            }
                        }
                    } else if (replace.startsWith(strArr[i2])) {
                        return TypeUtils.X(str, this.e);
                    } else {
                        i2++;
                    }
                }
            }
            Class<?> E = TypeUtils.E(str);
            if (E == null) {
                E = this.a.a(str);
            }
            if (E != null) {
                if (cls == null || cls.isAssignableFrom(E)) {
                    return E;
                }
                throw new JSONException("type not match. " + str + " -> " + cls.getName());
            }
            if (!this.g) {
                int i4 = 0;
                while (true) {
                    String[] strArr3 = this.h;
                    if (i4 >= strArr3.length) {
                        while (true) {
                            String[] strArr4 = this.i;
                            if (i >= strArr4.length) {
                                break;
                            } else if (replace.startsWith(strArr4[i])) {
                                Class<?> X = TypeUtils.X(str, this.e);
                                if (cls == null || !cls.isAssignableFrom(X)) {
                                    return X;
                                }
                                throw new JSONException("type not match. " + str + " -> " + cls.getName());
                            } else {
                                i++;
                            }
                        }
                    } else if (replace.startsWith(strArr3[i4])) {
                        throw new JSONException("autoType is not support. " + str);
                    } else {
                        i4++;
                    }
                }
            }
            if (this.g || cls != null) {
                E = TypeUtils.X(str, this.e);
            }
            if (E != null) {
                if (ClassLoader.class.isAssignableFrom(E) || DataSource.class.isAssignableFrom(E)) {
                    throw new JSONException("autoType is not support. " + str);
                } else if (cls != null) {
                    if (cls.isAssignableFrom(E)) {
                        return E;
                    }
                    throw new JSONException("type not match. " + str + " -> " + cls.getName());
                }
            }
            if (this.g) {
                return E;
            }
            throw new JSONException("autoType is not support. " + str);
        }
        throw new JSONException("autoType is not support. " + str);
    }

    public i f(ParserConfig parserConfig, b bVar, m1.a aVar) {
        Class deserializeUsing;
        Class cls = bVar.a;
        Class cls2 = aVar.f;
        h1.b e = aVar.e();
        Class cls3 = null;
        if (e != null && (deserializeUsing = e.deserializeUsing()) != Void.class) {
            cls3 = deserializeUsing;
        }
        if (cls3 == null && (cls2 == List.class || cls2 == ArrayList.class)) {
            return new k1.b(parserConfig, cls, aVar);
        }
        return new d(parserConfig, cls, aVar);
    }

    public l g(Class<?> cls, Type type) {
        m1.a[] aVarArr;
        h1.b e;
        a aVar;
        boolean z = this.b & (!this.k);
        boolean z2 = false;
        if (z) {
            h1.d annotation = cls.getAnnotation(h1.d.class);
            if (annotation != null) {
                Class deserializer = annotation.deserializer();
                if (deserializer != Void.class) {
                    try {
                        Object newInstance = deserializer.newInstance();
                        if (newInstance instanceof l) {
                            return (l) newInstance;
                        }
                    } catch (Throwable unused) {
                    }
                }
                z = annotation.asm();
            }
            if (z) {
                Class<?> e2 = b.e(annotation);
                if (e2 == null) {
                    e2 = cls;
                }
                while (true) {
                    if (!Modifier.isPublic(e2.getModifiers())) {
                        z = false;
                        break;
                    }
                    e2 = e2.getSuperclass();
                    if (e2 != Object.class) {
                        if (e2 == null) {
                            break;
                        }
                    } else {
                        break;
                    }
                }
            }
        }
        if (cls.getTypeParameters().length != 0) {
            z = false;
        }
        if (z && (aVar = this.f) != null && aVar.a.c(cls)) {
            z = false;
        }
        if (z) {
            z = ASMUtils.a(cls.getSimpleName());
        }
        if (z) {
            if (cls.isInterface()) {
                z = false;
            }
            b b = b.b(cls, type, this.d);
            if (z && b.h.length > 200) {
                z = false;
            }
            Constructor constructor = b.c;
            if (z && constructor == null && !cls.isInterface()) {
                z = false;
            }
            for (m1.a aVar2 : b.h) {
                if (!aVar2.i) {
                    Class cls2 = aVar2.f;
                    if (Modifier.isPublic(cls2.getModifiers()) && ((!cls2.isMemberClass() || Modifier.isStatic(cls2.getModifiers())) && ((aVar2.k() == null || ASMUtils.a(aVar2.k().getName())) && (((e = aVar2.e()) == null || (ASMUtils.a(e.name()) && e.format().length() == 0 && e.deserializeUsing() == Void.class && !e.unwrapped())) && (!cls2.isEnum() || (j(cls2) instanceof e)))))) {
                    }
                }
                z = false;
                break;
            }
        }
        if (!z || !cls.isMemberClass() || Modifier.isStatic(cls.getModifiers())) {
            z2 = z;
        }
        if (!z2) {
            return new k(this, cls, type);
        }
        b b2 = b.b(cls, type, this.d);
        try {
            return this.f.v(this, b2);
        } catch (JSONException unused2) {
            return new k(this, b2);
        } catch (NoSuchMethodException unused3) {
            return new k(this, cls, type);
        } catch (Exception e3) {
            throw new JSONException("create asm deserializer error, " + cls.getName(), e3);
        }
    }

    public ClassLoader h() {
        return this.e;
    }

    public l i(Class<?> cls, Type type) {
        l b;
        l lVar;
        Class<?> mappingTo;
        l b2 = this.a.b(type);
        if (b2 != null) {
            return b2;
        }
        if (type == null) {
            type = cls;
        }
        l b3 = this.a.b(type);
        if (b3 != null) {
            return b3;
        }
        h1.d annotation = cls.getAnnotation(h1.d.class);
        if (annotation != null && (mappingTo = annotation.mappingTo()) != Void.class) {
            return i(mappingTo, mappingTo);
        }
        if ((type instanceof WildcardType) || (type instanceof TypeVariable) || (type instanceof ParameterizedType)) {
            b3 = this.a.b(cls);
        }
        if (b3 != null) {
            return b3;
        }
        String replace = cls.getName().replace(DecodedChar.FNC1, '.');
        if (replace.startsWith("java.awt.") && AwtCodec.k(cls) && !q) {
            try {
                IdentityHashMap<Type, l> identityHashMap = this.a;
                Class<?> cls2 = Class.forName("java.awt.Point");
                AwtCodec awtCodec = AwtCodec.a;
                identityHashMap.c(cls2, awtCodec);
                this.a.c(Class.forName("java.awt.Font"), awtCodec);
                this.a.c(Class.forName("java.awt.Rectangle"), awtCodec);
                this.a.c(Class.forName("java.awt.Color"), awtCodec);
            } catch (Throwable unused) {
                q = true;
            }
            b3 = AwtCodec.a;
        }
        if (!r) {
            try {
                if (replace.startsWith("java.time.")) {
                    IdentityHashMap<Type, l> identityHashMap2 = this.a;
                    Class<?> cls3 = Class.forName("java.time.LocalDateTime");
                    Jdk8DateCodec jdk8DateCodec = Jdk8DateCodec.a;
                    identityHashMap2.c(cls3, jdk8DateCodec);
                    this.a.c(Class.forName("java.time.LocalDate"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.LocalTime"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.ZonedDateTime"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.OffsetDateTime"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.OffsetTime"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.ZoneOffset"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.ZoneRegion"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.ZoneId"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.Period"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.Duration"), jdk8DateCodec);
                    this.a.c(Class.forName("java.time.Instant"), jdk8DateCodec);
                    b = this.a.b(cls);
                } else if (replace.startsWith("java.util.Optional")) {
                    this.a.c(Class.forName("java.util.Optional"), OptionalCodec.a);
                    this.a.c(Class.forName("java.util.OptionalDouble"), OptionalCodec.a);
                    this.a.c(Class.forName("java.util.OptionalInt"), OptionalCodec.a);
                    this.a.c(Class.forName("java.util.OptionalLong"), OptionalCodec.a);
                    b = this.a.b(cls);
                }
                b3 = b;
            } catch (Throwable unused2) {
                r = true;
            }
        }
        if (replace.equals("java.nio.file.Path")) {
            this.a.c(cls, MiscCodec.a);
        }
        if (cls == Map.Entry.class) {
            this.a.c(cls, MiscCodec.a);
        }
        try {
            for (l lVar2 : ServiceLoader.a(c.class, Thread.currentThread().getContextClassLoader())) {
                for (Type type2 : lVar2.a()) {
                    this.a.c(type2, lVar2);
                }
            }
        } catch (Exception unused3) {
        }
        if (b3 == null) {
            b3 = this.a.b(type);
        }
        if (b3 != null) {
            return b3;
        }
        if (cls.isEnum()) {
            lVar = new e(cls);
        } else if (cls.isArray()) {
            lVar = ObjectArrayCodec.a;
        } else if (cls != Set.class && cls != HashSet.class && cls != Collection.class && cls != List.class && cls != ArrayList.class) {
            if (Collection.class.isAssignableFrom(cls)) {
                lVar = CollectionCodec.a;
            } else if (Map.class.isAssignableFrom(cls)) {
                lVar = MapDeserializer.a;
            } else if (Throwable.class.isAssignableFrom(cls)) {
                lVar = new q(this, cls);
            } else if (n.class.isAssignableFrom(cls)) {
                lVar = new o(cls);
            } else {
                lVar = g(cls, type);
            }
        } else {
            lVar = CollectionCodec.a;
        }
        p(type, lVar);
        return lVar;
    }

    public l j(Type type) {
        l b = this.a.b(type);
        if (b != null) {
            return b;
        }
        if (type instanceof Class) {
            return i((Class) type, type);
        }
        if (type instanceof ParameterizedType) {
            Type rawType = ((ParameterizedType) type).getRawType();
            if (rawType instanceof Class) {
                return i((Class) rawType, type);
            }
            return j(rawType);
        }
        return JavaObjectDeserializer.a;
    }

    public IdentityHashMap<Type, l> k() {
        return this.a;
    }

    public void p(Type type, l lVar) {
        this.a.c(type, lVar);
    }

    public ParserConfig(boolean z) {
        this(null, null, z);
    }

    public ParserConfig(a aVar, ClassLoader classLoader, boolean z) {
        this.a = new IdentityHashMap<>();
        boolean z2 = ASMUtils.b;
        this.b = !z2;
        this.c = new g((int) CodedOutputStream.DEFAULT_BUFFER_SIZE);
        this.g = o;
        this.h = "bsh,com.mchange,com.sun.,java.lang.Thread,java.net.Socket,java.rmi,javax.xml,org.apache.bcel,org.apache.commons.beanutils,org.apache.commons.collections.Transformer,org.apache.commons.collections.functors,org.apache.commons.collections4.comparators,org.apache.commons.fileupload,org.apache.myfaces.context.servlet,org.apache.tomcat,org.apache.wicket.util,org.apache.xalan,org.codehaus.groovy.runtime,org.hibernate,org.jboss,org.mozilla.javascript,org.python.core,org.springframework".split(",");
        this.i = n;
        this.j = 256;
        this.l = TypeUtils.a;
        this.k = z;
        if (aVar == null && !z2) {
            try {
                if (classLoader == null) {
                    aVar = new a(new ASMClassLoader());
                } else {
                    aVar = new a(classLoader);
                }
            } catch (ExceptionInInitializerError | NoClassDefFoundError | AccessControlException unused) {
            }
        }
        this.f = aVar;
        if (aVar == null) {
            this.b = false;
        }
        IdentityHashMap<Type, l> identityHashMap = this.a;
        MiscCodec miscCodec = MiscCodec.a;
        identityHashMap.c(SimpleDateFormat.class, miscCodec);
        this.a.c(Timestamp.class, SqlDateDeserializer.c);
        this.a.c(java.sql.Date.class, SqlDateDeserializer.b);
        this.a.c(Time.class, TimeDeserializer.a);
        this.a.c(Date.class, DateCodec.a);
        IdentityHashMap<Type, l> identityHashMap2 = this.a;
        CalendarCodec calendarCodec = CalendarCodec.b;
        identityHashMap2.c(Calendar.class, calendarCodec);
        this.a.c(XMLGregorianCalendar.class, calendarCodec);
        this.a.c(JSONObject.class, MapDeserializer.a);
        IdentityHashMap<Type, l> identityHashMap3 = this.a;
        CollectionCodec collectionCodec = CollectionCodec.a;
        identityHashMap3.c(JSONArray.class, collectionCodec);
        this.a.c(Map.class, MapDeserializer.a);
        this.a.c(HashMap.class, MapDeserializer.a);
        this.a.c(LinkedHashMap.class, MapDeserializer.a);
        this.a.c(TreeMap.class, MapDeserializer.a);
        this.a.c(ConcurrentMap.class, MapDeserializer.a);
        this.a.c(ConcurrentHashMap.class, MapDeserializer.a);
        this.a.c(Collection.class, collectionCodec);
        this.a.c(List.class, collectionCodec);
        this.a.c(ArrayList.class, collectionCodec);
        IdentityHashMap<Type, l> identityHashMap4 = this.a;
        JavaObjectDeserializer javaObjectDeserializer = JavaObjectDeserializer.a;
        identityHashMap4.c(Object.class, javaObjectDeserializer);
        this.a.c(String.class, StringCodec.a);
        this.a.c(StringBuffer.class, StringCodec.a);
        this.a.c(StringBuilder.class, StringCodec.a);
        IdentityHashMap<Type, l> identityHashMap5 = this.a;
        Class cls = Character.TYPE;
        CharacterCodec characterCodec = CharacterCodec.a;
        identityHashMap5.c(cls, characterCodec);
        this.a.c(Character.class, characterCodec);
        IdentityHashMap<Type, l> identityHashMap6 = this.a;
        Class cls2 = Byte.TYPE;
        NumberDeserializer numberDeserializer = NumberDeserializer.a;
        identityHashMap6.c(cls2, numberDeserializer);
        this.a.c(Byte.class, numberDeserializer);
        this.a.c(Short.TYPE, numberDeserializer);
        this.a.c(Short.class, numberDeserializer);
        this.a.c(Integer.TYPE, IntegerCodec.a);
        this.a.c(Integer.class, IntegerCodec.a);
        this.a.c(Long.TYPE, LongCodec.a);
        this.a.c(Long.class, LongCodec.a);
        this.a.c(BigInteger.class, BigIntegerCodec.a);
        this.a.c(BigDecimal.class, BigDecimalCodec.a);
        this.a.c(Float.TYPE, FloatCodec.b);
        this.a.c(Float.class, FloatCodec.b);
        this.a.c(Double.TYPE, numberDeserializer);
        this.a.c(Double.class, numberDeserializer);
        IdentityHashMap<Type, l> identityHashMap7 = this.a;
        Class cls3 = Boolean.TYPE;
        BooleanCodec booleanCodec = BooleanCodec.a;
        identityHashMap7.c(cls3, booleanCodec);
        this.a.c(Boolean.class, booleanCodec);
        this.a.c(Class.class, miscCodec);
        this.a.c(char[].class, new CharArrayCodec());
        this.a.c(AtomicBoolean.class, booleanCodec);
        this.a.c(AtomicInteger.class, IntegerCodec.a);
        this.a.c(AtomicLong.class, LongCodec.a);
        IdentityHashMap<Type, l> identityHashMap8 = this.a;
        ReferenceCodec referenceCodec = ReferenceCodec.a;
        identityHashMap8.c(AtomicReference.class, referenceCodec);
        this.a.c(WeakReference.class, referenceCodec);
        this.a.c(SoftReference.class, referenceCodec);
        this.a.c(UUID.class, miscCodec);
        this.a.c(TimeZone.class, miscCodec);
        this.a.c(Locale.class, miscCodec);
        this.a.c(Currency.class, miscCodec);
        this.a.c(InetAddress.class, miscCodec);
        this.a.c(Inet4Address.class, miscCodec);
        this.a.c(Inet6Address.class, miscCodec);
        this.a.c(InetSocketAddress.class, miscCodec);
        this.a.c(File.class, miscCodec);
        this.a.c(URI.class, miscCodec);
        this.a.c(URL.class, miscCodec);
        this.a.c(Pattern.class, miscCodec);
        this.a.c(Charset.class, miscCodec);
        this.a.c(JSONPath.class, miscCodec);
        this.a.c(Number.class, numberDeserializer);
        IdentityHashMap<Type, l> identityHashMap9 = this.a;
        AtomicCodec atomicCodec = AtomicCodec.a;
        identityHashMap9.c(AtomicIntegerArray.class, atomicCodec);
        this.a.c(AtomicLongArray.class, atomicCodec);
        this.a.c(StackTraceElement.class, StackTraceElementDeserializer.a);
        this.a.c(Serializable.class, javaObjectDeserializer);
        this.a.c(Cloneable.class, javaObjectDeserializer);
        this.a.c(Comparable.class, javaObjectDeserializer);
        this.a.c(Closeable.class, javaObjectDeserializer);
        this.a.c(JSONPObject.class, new JSONPDeserializer());
        d(m);
        c(n);
    }
}
