package com.alibaba.android.arouter.core;

import android.content.Context;
import android.net.Uri;
import com.alibaba.android.arouter.exception.HandlerException;
import com.alibaba.android.arouter.exception.NoRouteFoundException;
import com.alibaba.android.arouter.facade.Postcard;
import com.alibaba.android.arouter.facade.enums.RouteType;
import com.alibaba.android.arouter.facade.enums.TypeKind;
import com.alibaba.android.arouter.facade.model.RouteMeta;
import com.alibaba.android.arouter.facade.template.IInterceptorGroup;
import com.alibaba.android.arouter.facade.template.ILogger;
import com.alibaba.android.arouter.facade.template.IProvider;
import com.alibaba.android.arouter.facade.template.IProviderGroup;
import com.alibaba.android.arouter.facade.template.IRouteGroup;
import com.alibaba.android.arouter.facade.template.IRouteRoot;
import com.alibaba.android.arouter.utils.ClassUtils;
import com.alibaba.android.arouter.utils.MapUtils;
import com.alibaba.android.arouter.utils.PackageUtils;
import com.alibaba.android.arouter.utils.TextUtils;
import java.util.HashSet;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ThreadPoolExecutor;
/* loaded from: classes.dex */
public class LogisticsCenter {
    public static Context a;
    public static ThreadPoolExecutor b;
    public static boolean c;

    /* loaded from: classes.dex */
    public static /* synthetic */ class a {
        public static final /* synthetic */ int[] a;

        static {
            int[] iArr = new int[RouteType.values().length];
            a = iArr;
            try {
                iArr[RouteType.PROVIDER.ordinal()] = 1;
            } catch (NoSuchFieldError unused) {
            }
            try {
                a[RouteType.FRAGMENT.ordinal()] = 2;
            } catch (NoSuchFieldError unused2) {
            }
        }
    }

    public static Postcard a(String str) {
        RouteMeta routeMeta = (RouteMeta) e1.a.d.get(str);
        if (routeMeta == null) {
            return null;
        }
        return new Postcard(routeMeta.getPath(), routeMeta.getGroup());
    }

    public static synchronized void b(Postcard postcard) {
        synchronized (LogisticsCenter.class) {
            if (postcard != null) {
                RouteMeta routeMeta = (RouteMeta) e1.a.b.get(postcard.getPath());
                if (routeMeta == null) {
                    Class cls = (Class) e1.a.a.get(postcard.getGroup());
                    if (cls != null) {
                        try {
                            if (f1.a.c()) {
                                f1.a.c.debug(ILogger.defaultTag, String.format(Locale.getDefault(), "The group [%s] starts loading, trigger by [%s]", postcard.getGroup(), postcard.getPath()));
                            }
                            ((IRouteGroup) cls.getConstructor(new Class[0]).newInstance(new Object[0])).loadInto(e1.a.b);
                            e1.a.a.remove(postcard.getGroup());
                            if (f1.a.c()) {
                                f1.a.c.debug(ILogger.defaultTag, String.format(Locale.getDefault(), "The group [%s] has already been loaded, trigger by [%s]", postcard.getGroup(), postcard.getPath()));
                            }
                            b(postcard);
                        } catch (Exception e) {
                            throw new HandlerException("ARouter::Fatal exception when loading group meta. [" + e.getMessage() + "]");
                        }
                    } else {
                        throw new NoRouteFoundException("ARouter::There is no route match the path [" + postcard.getPath() + "], in group [" + postcard.getGroup() + "]");
                    }
                } else {
                    postcard.setDestination(routeMeta.getDestination());
                    postcard.setType(routeMeta.getType());
                    postcard.setPriority(routeMeta.getPriority());
                    postcard.setExtra(routeMeta.getExtra());
                    Uri uri = postcard.getUri();
                    if (uri != null) {
                        Map<String, String> d = TextUtils.d(uri);
                        Map<String, Integer> paramsType = routeMeta.getParamsType();
                        if (MapUtils.b(paramsType)) {
                            for (Map.Entry<String, Integer> entry : paramsType.entrySet()) {
                                j(postcard, entry.getValue(), entry.getKey(), d.get(entry.getKey()));
                            }
                            postcard.getExtras().putStringArray("wmHzgD4lOj5o4241", (String[]) paramsType.keySet().toArray(new String[0]));
                        }
                        postcard.withString("NTeRQWvye18AkPd6G", uri.toString());
                    }
                    int i = a.a[routeMeta.getType().ordinal()];
                    if (i == 1) {
                        Class<?> destination = routeMeta.getDestination();
                        IProvider iProvider = (IProvider) e1.a.c.get(destination);
                        if (iProvider == null) {
                            try {
                                iProvider = (IProvider) destination.getConstructor(new Class[0]).newInstance(new Object[0]);
                                iProvider.init(a);
                                e1.a.c.put(destination, iProvider);
                            } catch (Exception e2) {
                                throw new HandlerException("Init provider failed! " + e2.getMessage());
                            }
                        }
                        postcard.setProvider(iProvider);
                        postcard.greenChannel();
                    } else if (i == 2) {
                        postcard.greenChannel();
                    }
                }
            } else {
                throw new NoRouteFoundException("ARouter::No postcard!");
            }
        }
    }

    /* JADX WARN: Removed duplicated region for block: B:21:0x00b4 A[Catch: Exception -> 0x018f, all -> 0x01b0, TryCatch #1 {Exception -> 0x018f, blocks: (B:5:0x0007, B:7:0x0013, B:30:0x011a, B:32:0x0144, B:33:0x014d, B:35:0x0153, B:8:0x001e, B:10:0x0024, B:13:0x002b, B:18:0x0078, B:19:0x00ae, B:21:0x00b4, B:23:0x00c2, B:24:0x00da, B:26:0x00e2, B:27:0x00fa, B:29:0x0102, B:14:0x004b, B:16:0x0062, B:17:0x0075), top: B:45:0x0007, outer: #0 }] */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static synchronized void c(Context context, ThreadPoolExecutor threadPoolExecutor) throws HandlerException {
        Set<String> a2;
        synchronized (LogisticsCenter.class) {
            a = context;
            b = threadPoolExecutor;
            try {
                long currentTimeMillis = System.currentTimeMillis();
                d();
                if (c) {
                    f1.a.c.info(ILogger.defaultTag, "Load router map by arouter-auto-register plugin.");
                } else {
                    if (!f1.a.c() && !PackageUtils.b(context)) {
                        f1.a.c.info(ILogger.defaultTag, "Load router map from cache.");
                        a2 = new HashSet<>(context.getSharedPreferences("SP_AROUTER_CACHE", 0).getStringSet("ROUTER_MAP", new HashSet()));
                        ILogger iLogger = f1.a.c;
                        iLogger.info(ILogger.defaultTag, "Find router map finished, map size = " + a2.size() + ", cost " + (System.currentTimeMillis() - currentTimeMillis) + " ms.");
                        currentTimeMillis = System.currentTimeMillis();
                        for (String str : a2) {
                            if (str.startsWith("com.alibaba.android.arouter.routes.ARouter$$Root")) {
                                ((IRouteRoot) Class.forName(str).getConstructor(new Class[0]).newInstance(new Object[0])).loadInto(e1.a.a);
                            } else if (str.startsWith("com.alibaba.android.arouter.routes.ARouter$$Interceptors")) {
                                ((IInterceptorGroup) Class.forName(str).getConstructor(new Class[0]).newInstance(new Object[0])).loadInto(e1.a.e);
                            } else if (str.startsWith("com.alibaba.android.arouter.routes.ARouter$$Providers")) {
                                ((IProviderGroup) Class.forName(str).getConstructor(new Class[0]).newInstance(new Object[0])).loadInto(e1.a.d);
                            }
                        }
                    }
                    f1.a.c.info(ILogger.defaultTag, "Run with debug mode or new install, rebuild router map.");
                    a2 = ClassUtils.a(a, "com.alibaba.android.arouter.routes");
                    if (!a2.isEmpty()) {
                        context.getSharedPreferences("SP_AROUTER_CACHE", 0).edit().putStringSet("ROUTER_MAP", a2).apply();
                    }
                    PackageUtils.c(context);
                    ILogger iLogger2 = f1.a.c;
                    iLogger2.info(ILogger.defaultTag, "Find router map finished, map size = " + a2.size() + ", cost " + (System.currentTimeMillis() - currentTimeMillis) + " ms.");
                    currentTimeMillis = System.currentTimeMillis();
                    while (r8.hasNext()) {
                    }
                }
                ILogger iLogger3 = f1.a.c;
                iLogger3.info(ILogger.defaultTag, "Load root element finished, cost " + (System.currentTimeMillis() - currentTimeMillis) + " ms.");
                if (e1.a.a.size() == 0) {
                    f1.a.c.error(ILogger.defaultTag, "No mapping files were found, check your configuration please!");
                }
                if (f1.a.c()) {
                    f1.a.c.debug(ILogger.defaultTag, String.format(Locale.getDefault(), "LogisticsCenter has already been loaded, GroupIndex[%d], InterceptorIndex[%d], ProviderIndex[%d]", Integer.valueOf(e1.a.a.size()), Integer.valueOf(e1.a.e.size()), Integer.valueOf(e1.a.d.size())));
                }
            } catch (Exception e) {
                throw new HandlerException("ARouter::ARouter init logistics center exception! [" + e.getMessage() + "]");
            }
        }
    }

    public static void d() {
        c = false;
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$app");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$arouterapi");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_module_market");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_kline_module");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_content");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_account");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_module_otc");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_share");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_huobi_im");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbc_community");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_module_exchange");
        f("com.alibaba.android.arouter.routes.ARouter$$Root$$hbg_core");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$app");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$arouterapi");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_module_market");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_kline_module");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_content");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_account");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_module_otc");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_share");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_huobi_im");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbc_community");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_module_exchange");
        f("com.alibaba.android.arouter.routes.ARouter$$Providers$$hbg_core");
    }

    public static void e() {
        if (c) {
            return;
        }
        c = true;
    }

    public static void f(String str) {
        if (TextUtils.c(str)) {
            return;
        }
        try {
            Object newInstance = Class.forName(str).getConstructor(new Class[0]).newInstance(new Object[0]);
            if (newInstance instanceof IRouteRoot) {
                i((IRouteRoot) newInstance);
            } else if (newInstance instanceof IProviderGroup) {
                h((IProviderGroup) newInstance);
            } else if (newInstance instanceof IInterceptorGroup) {
                g((IInterceptorGroup) newInstance);
            } else {
                ILogger iLogger = f1.a.c;
                iLogger.info(ILogger.defaultTag, "register failed, class name: " + str + " should implements one of IRouteRoot/IProviderGroup/IInterceptorGroup.");
            }
        } catch (Exception unused) {
            ILogger iLogger2 = f1.a.c;
            iLogger2.error(ILogger.defaultTag, "register class error:" + str);
        }
    }

    public static void g(IInterceptorGroup iInterceptorGroup) {
        e();
        if (iInterceptorGroup != null) {
            iInterceptorGroup.loadInto(e1.a.e);
        }
    }

    public static void h(IProviderGroup iProviderGroup) {
        e();
        if (iProviderGroup != null) {
            iProviderGroup.loadInto(e1.a.d);
        }
    }

    public static void i(IRouteRoot iRouteRoot) {
        e();
        if (iRouteRoot != null) {
            iRouteRoot.loadInto(e1.a.a);
        }
    }

    public static void j(Postcard postcard, Integer num, String str, String str2) {
        if (TextUtils.c(str) || TextUtils.c(str2)) {
            return;
        }
        try {
            if (num != null) {
                if (num.intValue() == TypeKind.BOOLEAN.ordinal()) {
                    postcard.withBoolean(str, Boolean.parseBoolean(str2));
                } else if (num.intValue() == TypeKind.BYTE.ordinal()) {
                    postcard.withByte(str, Byte.valueOf(str2).byteValue());
                } else if (num.intValue() == TypeKind.SHORT.ordinal()) {
                    postcard.withShort(str, Short.valueOf(str2).shortValue());
                } else if (num.intValue() == TypeKind.INT.ordinal()) {
                    postcard.withInt(str, Integer.valueOf(str2).intValue());
                } else if (num.intValue() == TypeKind.LONG.ordinal()) {
                    postcard.withLong(str, Long.valueOf(str2).longValue());
                } else if (num.intValue() == TypeKind.FLOAT.ordinal()) {
                    postcard.withFloat(str, Float.valueOf(str2).floatValue());
                } else if (num.intValue() == TypeKind.DOUBLE.ordinal()) {
                    postcard.withDouble(str, Double.valueOf(str2).doubleValue());
                } else if (num.intValue() == TypeKind.STRING.ordinal()) {
                    postcard.withString(str, str2);
                } else if (num.intValue() != TypeKind.PARCELABLE.ordinal()) {
                    if (num.intValue() == TypeKind.OBJECT.ordinal()) {
                        postcard.withString(str, str2);
                    } else {
                        postcard.withString(str, str2);
                    }
                }
            } else {
                postcard.withString(str, str2);
            }
        } catch (Throwable th) {
            ILogger iLogger = f1.a.c;
            iLogger.warning(ILogger.defaultTag, "LogisticsCenter setValue failed! " + th.getMessage());
        }
    }
}
