package com.alibaba.android.arouter.utils;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.ApplicationInfo;
import android.content.pm.PackageManager;
import android.os.Build;
import android.util.Log;
import com.alibaba.android.arouter.facade.template.ILogger;
import dalvik.system.DexFile;
import g1.b;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.CountDownLatch;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
/* loaded from: classes.dex */
public class ClassUtils {
    public static final String a = "code_cache" + File.separator + "secondary-dexes";

    /* loaded from: classes.dex */
    public static class a implements Runnable {
        public final /* synthetic */ String b;
        public final /* synthetic */ String c;
        public final /* synthetic */ Set d;
        public final /* synthetic */ CountDownLatch e;

        public a(String str, String str2, Set set, CountDownLatch countDownLatch) {
            this.b = str;
            this.c = str2;
            this.d = set;
            this.e = countDownLatch;
        }

        @Override // java.lang.Runnable
        public void run() {
            DexFile dexFile = null;
            try {
                if (this.b.endsWith(".zip")) {
                    String str = this.b;
                    dexFile = DexFile.loadDex(str, this.b + ".tmp", 0);
                } else {
                    dexFile = new DexFile(this.b);
                }
                Enumeration<String> entries = dexFile.entries();
                while (entries.hasMoreElements()) {
                    String nextElement = entries.nextElement();
                    if (nextElement.startsWith(this.c)) {
                        this.d.add(nextElement);
                    }
                }
            } catch (Throwable th) {
                try {
                    Log.e("ARouter", "Scan map file in dex files made error.", th);
                } finally {
                    if (dexFile != null) {
                        try {
                            dexFile.close();
                        } catch (Throwable unused) {
                        }
                    }
                    this.e.countDown();
                }
            }
        }
    }

    public static Set<String> a(Context context, String str) throws PackageManager.NameNotFoundException, IOException, InterruptedException {
        HashSet hashSet = new HashSet();
        List<String> c = c(context);
        CountDownLatch countDownLatch = new CountDownLatch(c.size());
        for (String str2 : c) {
            b.a().execute(new a(str2, str, hashSet, countDownLatch));
        }
        countDownLatch.await();
        Log.d(ILogger.defaultTag, "Filter " + hashSet.size() + " classes by packageName <" + str + ">");
        return hashSet;
    }

    public static SharedPreferences b(Context context) {
        return context.getSharedPreferences("multidex.version", Build.VERSION.SDK_INT < 11 ? 0 : 4);
    }

    public static List<String> c(Context context) throws PackageManager.NameNotFoundException, IOException {
        ApplicationInfo applicationInfo = context.getPackageManager().getApplicationInfo(context.getPackageName(), 0);
        File file = new File(applicationInfo.sourceDir);
        ArrayList arrayList = new ArrayList();
        arrayList.add(applicationInfo.sourceDir);
        String str = file.getName() + ".classes";
        if (!d()) {
            int i = b(context).getInt("dex.number", 1);
            File file2 = new File(applicationInfo.dataDir, a);
            for (int i2 = 2; i2 <= i; i2++) {
                File file3 = new File(file2, str + i2 + ".zip");
                if (file3.isFile()) {
                    arrayList.add(file3.getAbsolutePath());
                } else {
                    throw new IOException("Missing extracted secondary dex file '" + file3.getPath() + "'");
                }
            }
        }
        if (f1.a.c()) {
            arrayList.addAll(f(applicationInfo));
        }
        return arrayList;
    }

    /* JADX WARN: Code restructure failed: missing block: B:15:0x004e, code lost:
        if (r2 < 1) goto L8;
     */
    /* JADX WARN: Code restructure failed: missing block: B:6:0x001b, code lost:
        if (java.lang.Integer.valueOf(java.lang.System.getProperty("ro.build.version.sdk")).intValue() >= 21) goto L7;
     */
    /* JADX WARN: Removed duplicated region for block: B:19:0x0060  */
    /* JADX WARN: Removed duplicated region for block: B:20:0x0063  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static boolean d() {
        boolean z = false;
        String str = null;
        if (!e()) {
            str = "'Android'";
            String property = System.getProperty("java.vm.version");
            if (property != null) {
                Matcher matcher = Pattern.compile("(\\d+)\\.(\\d+)(\\.\\d+)?").matcher(property);
                if (matcher.matches()) {
                    int parseInt = Integer.parseInt(matcher.group(1));
                    int parseInt2 = Integer.parseInt(matcher.group(2));
                    if (parseInt <= 2) {
                        if (parseInt == 2) {
                        }
                    }
                    z = true;
                }
            }
            StringBuilder sb = new StringBuilder();
            sb.append("VM with name ");
            sb.append(str);
            sb.append(!z ? " has multidex support" : " does not have multidex support");
            Log.i(ILogger.defaultTag, sb.toString());
            return z;
        }
        str = "'YunOS'";
        StringBuilder sb2 = new StringBuilder();
        sb2.append("VM with name ");
        sb2.append(str);
        sb2.append(!z ? " has multidex support" : " does not have multidex support");
        Log.i(ILogger.defaultTag, sb2.toString());
        return z;
    }

    public static boolean e() {
        try {
            String property = System.getProperty("ro.yunos.version");
            String property2 = System.getProperty("java.vm.name");
            if (property2 == null || !property2.toLowerCase().contains("lemur")) {
                if (property == null) {
                    return false;
                }
                if (property.trim().length() <= 0) {
                    return false;
                }
            }
            return true;
        } catch (Exception unused) {
            return false;
        }
    }

    public static List<String> f(ApplicationInfo applicationInfo) {
        File[] listFiles;
        String[] strArr;
        ArrayList arrayList = new ArrayList();
        if (Build.VERSION.SDK_INT >= 21 && (strArr = applicationInfo.splitSourceDirs) != null) {
            arrayList.addAll(Arrays.asList(strArr));
            Log.d(ILogger.defaultTag, "Found InstantRun support");
        } else {
            try {
                File file = new File((String) Class.forName("com.android.tools.fd.runtime.Paths").getMethod("getDexFileDirectory", String.class).invoke(null, applicationInfo.packageName));
                if (file.exists() && file.isDirectory()) {
                    for (File file2 : file.listFiles()) {
                        if (file2 != null && file2.exists() && file2.isFile() && file2.getName().endsWith(".dex")) {
                            arrayList.add(file2.getAbsolutePath());
                        }
                    }
                    Log.d(ILogger.defaultTag, "Found InstantRun support");
                }
            } catch (Exception e) {
                Log.e(ILogger.defaultTag, "InstantRun support error, " + e.getMessage());
            }
        }
        return arrayList;
    }
}
