package com.alibaba.fastjson;

import com.alibaba.fastjson.parser.ParserConfig;
import com.alibaba.fastjson.serializer.SerializeConfig;
import com.alibaba.fastjson.util.IOUtils;
import com.alibaba.fastjson.util.TypeUtils;
import java.lang.reflect.Array;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.regex.Pattern;
/* loaded from: classes.dex */
public class JSONPath implements com.alibaba.fastjson.a {
    public static int f = 1024;
    public static ConcurrentMap<String, JSONPath> g = new ConcurrentHashMap(128, 0.75f, 1);
    public final String b;
    public r[] c;
    public SerializeConfig d;
    public ParserConfig e;

    /* loaded from: classes.dex */
    public enum Operator {
        EQ,
        NE,
        GT,
        GE,
        LT,
        LE,
        LIKE,
        NOT_LIKE,
        RLIKE,
        NOT_RLIKE,
        IN,
        NOT_IN,
        BETWEEN,
        NOT_BETWEEN
    }

    /* loaded from: classes.dex */
    public static class a implements r {
        public final int a;

        public a(int i) {
            this.a = i;
        }

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            return jSONPath.f(obj2, this.a);
        }
    }

    /* loaded from: classes.dex */
    public static class b implements c {
        public final String a;
        public final double b;
        public final Operator c;

        public b(String str, double d, Operator operator) {
            this.a = str;
            this.b = d;
            this.c = operator;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            Object h = jSONPath.h(obj3, this.a, false);
            if (h != null && (h instanceof Number)) {
                double doubleValue = ((Number) h).doubleValue();
                Operator operator = this.c;
                return operator == Operator.EQ ? doubleValue == this.b : operator == Operator.NE ? doubleValue != this.b : operator == Operator.GE ? doubleValue >= this.b : operator == Operator.GT ? doubleValue > this.b : operator == Operator.LE ? doubleValue <= this.b : operator == Operator.LT && doubleValue < this.b;
            }
            return false;
        }
    }

    /* loaded from: classes.dex */
    public interface c {
        boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3);
    }

    /* loaded from: classes.dex */
    public static class d implements r {
        public final c a;

        public d(c cVar) {
            this.a = cVar;
        }

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            if (obj2 == null) {
                return null;
            }
            JSONArray jSONArray = new JSONArray();
            if (obj2 instanceof Iterable) {
                for (Object obj3 : (Iterable) obj2) {
                    if (this.a.a(jSONPath, obj, obj2, obj3)) {
                        jSONArray.add(obj3);
                    }
                }
                return jSONArray;
            } else if (this.a.a(jSONPath, obj, obj2, obj2)) {
                return obj2;
            } else {
                return null;
            }
        }
    }

    /* loaded from: classes.dex */
    public static class e implements c {
        public final String a;
        public final long b;
        public final long c;
        public final boolean d;

        public e(String str, long j, long j2, boolean z) {
            this.a = str;
            this.b = j;
            this.c = j2;
            this.d = z;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            Object h = jSONPath.h(obj3, this.a, false);
            if (h == null) {
                return false;
            }
            if (h instanceof Number) {
                long longValue = ((Number) h).longValue();
                if (longValue >= this.b && longValue <= this.c) {
                    return !this.d;
                }
            }
            return this.d;
        }
    }

    /* loaded from: classes.dex */
    public static class f implements c {
        public final String a;
        public final long[] b;
        public final boolean c;

        public f(String str, long[] jArr, boolean z) {
            this.a = str;
            this.b = jArr;
            this.c = z;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            Object h = jSONPath.h(obj3, this.a, false);
            if (h == null) {
                return false;
            }
            if (h instanceof Number) {
                long longValue = ((Number) h).longValue();
                for (long j : this.b) {
                    if (j == longValue) {
                        return !this.c;
                    }
                }
            }
            return this.c;
        }
    }

    /* loaded from: classes.dex */
    public static class g implements c {
        public final String a;
        public final Long[] b;
        public final boolean c;

        public g(String str, Long[] lArr, boolean z) {
            this.a = str;
            this.b = lArr;
            this.c = z;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            int i = 0;
            Object h = jSONPath.h(obj3, this.a, false);
            if (h == null) {
                Long[] lArr = this.b;
                int length = lArr.length;
                while (i < length) {
                    if (lArr[i] == null) {
                        return !this.c;
                    }
                    i++;
                }
                return this.c;
            }
            if (h instanceof Number) {
                long longValue = ((Number) h).longValue();
                Long[] lArr2 = this.b;
                int length2 = lArr2.length;
                while (i < length2) {
                    Long l = lArr2[i];
                    if (l != null && l.longValue() == longValue) {
                        return !this.c;
                    }
                    i++;
                }
            }
            return this.c;
        }
    }

    /* loaded from: classes.dex */
    public static class h implements c {
        public final String a;
        public final long b;
        public final Operator c;

        public h(String str, long j, Operator operator) {
            this.a = str;
            this.b = j;
            this.c = operator;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            Object h = jSONPath.h(obj3, this.a, false);
            if (h != null && (h instanceof Number)) {
                long longValue = ((Number) h).longValue();
                Operator operator = this.c;
                return operator == Operator.EQ ? longValue == this.b : operator == Operator.NE ? longValue != this.b : operator == Operator.GE ? longValue >= this.b : operator == Operator.GT ? longValue > this.b : operator == Operator.LE ? longValue <= this.b : operator == Operator.LT && longValue < this.b;
            }
            return false;
        }
    }

    /* loaded from: classes.dex */
    public static class i {
        public final String a;
        public int b;
        public char c;
        public int d;

        public i(String str) {
            this.a = str;
            f();
        }

        public static boolean d(char c) {
            return c == '-' || c == '+' || (c >= '0' && c <= '9');
        }

        public void a(char c) {
            if (this.c == c) {
                if (e()) {
                    return;
                }
                f();
                return;
            }
            throw new JSONPathException("expect '" + c + ", but '" + this.c + "'");
        }

        public r b(String str) {
            int length = str.length();
            int i = 0;
            char charAt = str.charAt(0);
            int i2 = length - 1;
            char charAt2 = str.charAt(i2);
            int indexOf = str.indexOf(44);
            if (str.length() > 2 && charAt == '\'' && charAt2 == '\'') {
                if (indexOf == -1) {
                    return new o(str.substring(1, i2), false);
                }
                String[] split = str.split(",");
                String[] strArr = new String[split.length];
                while (i < split.length) {
                    String str2 = split[i];
                    strArr[i] = str2.substring(1, str2.length() - 1);
                    i++;
                }
                return new l(strArr);
            }
            int indexOf2 = str.indexOf(58);
            if (indexOf == -1 && indexOf2 == -1) {
                if (TypeUtils.S(str)) {
                    try {
                        return new a(Integer.parseInt(str));
                    } catch (NumberFormatException unused) {
                        return new o(str, false);
                    }
                }
                return new o(str, false);
            } else if (indexOf != -1) {
                String[] split2 = str.split(",");
                int[] iArr = new int[split2.length];
                while (i < split2.length) {
                    iArr[i] = Integer.parseInt(split2[i]);
                    i++;
                }
                return new k(iArr);
            } else if (indexOf2 != -1) {
                String[] split3 = str.split(":");
                int length2 = split3.length;
                int[] iArr2 = new int[length2];
                for (int i3 = 0; i3 < split3.length; i3++) {
                    String str3 = split3[i3];
                    if (str3.length() != 0) {
                        iArr2[i3] = Integer.parseInt(str3);
                    } else if (i3 == 0) {
                        iArr2[i3] = 0;
                    } else {
                        throw new UnsupportedOperationException();
                    }
                }
                int i4 = iArr2[0];
                int i5 = length2 > 1 ? iArr2[1] : -1;
                int i6 = length2 == 3 ? iArr2[2] : 1;
                if (i5 < 0 || i5 >= i4) {
                    if (i6 > 0) {
                        return new p(i4, i5, i6);
                    }
                    throw new UnsupportedOperationException("step must greater than zero : " + i6);
                }
                throw new UnsupportedOperationException("end must greater than or equals start. start " + i4 + ",  end " + i5);
            } else {
                throw new UnsupportedOperationException();
            }
        }

        public r[] c() {
            String str = this.a;
            if (str != null && str.length() != 0) {
                r[] rVarArr = new r[8];
                while (true) {
                    r l = l();
                    if (l == null) {
                        break;
                    }
                    int i = this.d;
                    if (i == rVarArr.length) {
                        r[] rVarArr2 = new r[(i * 3) / 2];
                        System.arraycopy(rVarArr, 0, rVarArr2, 0, i);
                        rVarArr = rVarArr2;
                    }
                    int i2 = this.d;
                    this.d = i2 + 1;
                    rVarArr[i2] = l;
                }
                int i3 = this.d;
                if (i3 == rVarArr.length) {
                    return rVarArr;
                }
                r[] rVarArr3 = new r[i3];
                System.arraycopy(rVarArr, 0, rVarArr3, 0, i3);
                return rVarArr3;
            }
            throw new IllegalArgumentException();
        }

        public boolean e() {
            return this.b >= this.a.length();
        }

        public void f() {
            String str = this.a;
            int i = this.b;
            this.b = i + 1;
            this.c = str.charAt(i);
        }

        /* JADX WARN: Code restructure failed: missing block: B:32:0x005d, code lost:
            r0 = r14.b;
         */
        /* JADX WARN: Removed duplicated region for block: B:42:0x007c  */
        /* JADX WARN: Removed duplicated region for block: B:44:0x0088  */
        /*
            Code decompiled incorrectly, please refer to instructions dump.
        */
        public r g(boolean z) {
            boolean z2;
            String str;
            String str2;
            String str3;
            String str4;
            String[] strArr;
            int i;
            String substring;
            char c;
            if (z) {
                a('[');
            }
            int i2 = 0;
            if (this.c == '?') {
                f();
                a('(');
                if (this.c == '@') {
                    f();
                    a('.');
                }
                z2 = true;
            } else {
                z2 = false;
            }
            if (!z2 && !IOUtils.h(this.c)) {
                int i3 = this.b - 1;
                while (true) {
                    char c2 = this.c;
                    if (c2 == ']' || c2 == '/' || e() || !((c = this.c) != '.' || z2 || z2)) {
                        break;
                    }
                    if (c == '\\') {
                        f();
                    }
                    f();
                }
                char c3 = this.c;
                if (c3 != '/' && c3 != '.') {
                    i = this.b;
                    substring = this.a.substring(i3, i);
                    if (substring.indexOf("\\.") == -1) {
                    }
                } else {
                    int i4 = this.b;
                    i = i4 - 1;
                    substring = this.a.substring(i3, i);
                    if (substring.indexOf("\\.") == -1) {
                        return new o(substring.replaceAll("\\\\\\.", "\\."), false);
                    }
                    r b = b(substring);
                    if (z && !e()) {
                        a(']');
                    }
                    return b;
                }
            } else {
                String j = j();
                o();
                if (z2 && this.c == ')') {
                    f();
                    if (z) {
                        a(']');
                    }
                    return new d(new m(j));
                } else if (z && this.c == ']') {
                    f();
                    return new d(new m(j));
                } else {
                    Operator k = k();
                    o();
                    if (k != Operator.BETWEEN && k != Operator.NOT_BETWEEN) {
                        if (k != Operator.IN && k != Operator.NOT_IN) {
                            char c4 = this.c;
                            if (c4 != '\'' && c4 != '\"') {
                                if (d(c4)) {
                                    long i5 = i();
                                    double h = this.c == '.' ? h(i5) : 0.0d;
                                    if (z2) {
                                        a(')');
                                    }
                                    if (z) {
                                        a(']');
                                    }
                                    if (h == 0.0d) {
                                        return new d(new h(j, i5, k));
                                    }
                                    return new d(new b(j, h, k));
                                }
                                char c5 = this.c;
                                if (c5 == 'n') {
                                    if ("null".equals(j())) {
                                        if (z2) {
                                            a(')');
                                        }
                                        a(']');
                                        if (k == Operator.EQ) {
                                            return new d(new n(j));
                                        }
                                        if (k == Operator.NE) {
                                            return new d(new m(j));
                                        }
                                        throw new UnsupportedOperationException();
                                    }
                                } else if (c5 == 't') {
                                    if ("true".equals(j())) {
                                        if (z2) {
                                            a(')');
                                        }
                                        a(']');
                                        if (k == Operator.EQ) {
                                            return new d(new v(j, Boolean.TRUE, true));
                                        }
                                        if (k == Operator.NE) {
                                            return new d(new v(j, Boolean.TRUE, false));
                                        }
                                        throw new UnsupportedOperationException();
                                    }
                                } else if (c5 == 'f' && "false".equals(j())) {
                                    if (z2) {
                                        a(')');
                                    }
                                    a(']');
                                    if (k == Operator.EQ) {
                                        return new d(new v(j, Boolean.FALSE, true));
                                    }
                                    if (k == Operator.NE) {
                                        return new d(new v(j, Boolean.FALSE, false));
                                    }
                                    throw new UnsupportedOperationException();
                                }
                                throw new UnsupportedOperationException();
                            }
                            String m = m();
                            if (z2) {
                                a(')');
                            }
                            if (z) {
                                a(']');
                            }
                            if (k == Operator.RLIKE) {
                                return new d(new q(j, m, false));
                            }
                            if (k == Operator.NOT_RLIKE) {
                                return new d(new q(j, m, true));
                            }
                            if (k == Operator.LIKE || k == Operator.NOT_LIKE) {
                                while (m.indexOf("%%") != -1) {
                                    m = m.replaceAll("%%", "%");
                                }
                                boolean z3 = k == Operator.NOT_LIKE;
                                int indexOf = m.indexOf(37);
                                if (indexOf == -1) {
                                    if (k == Operator.LIKE) {
                                        k = Operator.EQ;
                                    } else {
                                        k = Operator.NE;
                                    }
                                } else {
                                    String[] split = m.split("%");
                                    String[] strArr2 = null;
                                    if (indexOf == 0) {
                                        if (m.charAt(m.length() - 1) == '%') {
                                            int length = split.length - 1;
                                            String[] strArr3 = new String[length];
                                            System.arraycopy(split, 1, strArr3, 0, length);
                                            strArr = strArr3;
                                            str3 = null;
                                            str4 = null;
                                            return new d(new j(j, str3, str4, strArr, z3));
                                        }
                                        String str5 = split[split.length - 1];
                                        if (split.length > 2) {
                                            int length2 = split.length - 2;
                                            String[] strArr4 = new String[length2];
                                            System.arraycopy(split, 1, strArr4, 0, length2);
                                            str4 = str5;
                                            strArr = strArr4;
                                            str3 = null;
                                        } else {
                                            str4 = str5;
                                            str3 = null;
                                            strArr = null;
                                        }
                                        return new d(new j(j, str3, str4, strArr, z3));
                                    } else if (m.charAt(m.length() - 1) != '%') {
                                        if (split.length == 1) {
                                            str3 = split[0];
                                            str4 = null;
                                            strArr = null;
                                        } else {
                                            if (split.length == 2) {
                                                str = split[0];
                                                str2 = split[1];
                                            } else {
                                                str = split[0];
                                                str2 = split[split.length - 1];
                                                int length3 = split.length - 2;
                                                strArr2 = new String[length3];
                                                System.arraycopy(split, 1, strArr2, 0, length3);
                                            }
                                            str3 = str;
                                            str4 = str2;
                                            strArr = strArr2;
                                        }
                                        return new d(new j(j, str3, str4, strArr, z3));
                                    } else {
                                        strArr = split;
                                        str3 = null;
                                        str4 = null;
                                        return new d(new j(j, str3, str4, strArr, z3));
                                    }
                                }
                            }
                            return new d(new u(j, m, k));
                        }
                        boolean z4 = k == Operator.NOT_IN;
                        a('(');
                        JSONArray jSONArray = new JSONArray();
                        jSONArray.add(n());
                        while (true) {
                            o();
                            if (this.c != ',') {
                                break;
                            }
                            f();
                            jSONArray.add(n());
                        }
                        a(')');
                        if (z2) {
                            a(')');
                        }
                        if (z) {
                            a(']');
                        }
                        boolean z5 = true;
                        boolean z6 = true;
                        boolean z7 = true;
                        for (Object obj : jSONArray) {
                            if (obj != null) {
                                Class<?> cls = obj.getClass();
                                if (z5 && cls != Byte.class && cls != Short.class && cls != Integer.class && cls != Long.class) {
                                    z5 = false;
                                    z7 = false;
                                }
                                if (z6 && cls != String.class) {
                                    z6 = false;
                                }
                            } else if (z5) {
                                z5 = false;
                            }
                        }
                        if (jSONArray.size() == 1 && jSONArray.get(0) == null) {
                            if (z4) {
                                return new d(new m(j));
                            }
                            return new d(new n(j));
                        } else if (z5) {
                            if (jSONArray.size() == 1) {
                                return new d(new h(j, ((Number) jSONArray.get(0)).longValue(), z4 ? Operator.NE : Operator.EQ));
                            }
                            int size = jSONArray.size();
                            long[] jArr = new long[size];
                            while (i2 < size) {
                                jArr[i2] = ((Number) jSONArray.get(i2)).longValue();
                                i2++;
                            }
                            return new d(new f(j, jArr, z4));
                        } else if (z6) {
                            if (jSONArray.size() == 1) {
                                return new d(new u(j, (String) jSONArray.get(0), z4 ? Operator.NE : Operator.EQ));
                            }
                            String[] strArr5 = new String[jSONArray.size()];
                            jSONArray.toArray(strArr5);
                            return new d(new t(j, strArr5, z4));
                        } else if (z7) {
                            int size2 = jSONArray.size();
                            Long[] lArr = new Long[size2];
                            while (i2 < size2) {
                                Number number = (Number) jSONArray.get(i2);
                                if (number != null) {
                                    lArr[i2] = Long.valueOf(number.longValue());
                                }
                                i2++;
                            }
                            return new d(new g(j, lArr, z4));
                        } else {
                            throw new UnsupportedOperationException();
                        }
                    }
                    boolean z8 = k == Operator.NOT_BETWEEN;
                    Object n = n();
                    if ("and".equalsIgnoreCase(j())) {
                        Object n2 = n();
                        if (n != null && n2 != null) {
                            if (JSONPath.k(n.getClass()) && JSONPath.k(n2.getClass())) {
                                return new d(new e(j, ((Number) n).longValue(), ((Number) n2).longValue(), z8));
                            }
                            throw new JSONPathException(this.a);
                        }
                        throw new JSONPathException(this.a);
                    }
                    throw new JSONPathException(this.a);
                }
            }
        }

        public double h(long j) {
            int i = this.b - 1;
            f();
            while (true) {
                char c = this.c;
                if (c < '0' || c > '9') {
                    break;
                }
                f();
            }
            return Double.parseDouble(this.a.substring(i, this.b - 1)) + j;
        }

        public long i() {
            int i = this.b - 1;
            char c = this.c;
            if (c == '+' || c == '-') {
                f();
            }
            while (true) {
                char c2 = this.c;
                if (c2 < '0' || c2 > '9') {
                    break;
                }
                f();
            }
            return Long.parseLong(this.a.substring(i, this.b - 1));
        }

        public String j() {
            o();
            char c = this.c;
            if (c != '\\' && !IOUtils.h(c)) {
                throw new JSONPathException("illeal jsonpath syntax. " + this.a);
            }
            StringBuilder sb = new StringBuilder();
            while (!e()) {
                char c2 = this.c;
                if (c2 == '\\') {
                    f();
                    sb.append(this.c);
                    if (e()) {
                        break;
                    }
                    f();
                } else if (!IOUtils.l(c2)) {
                    break;
                } else {
                    sb.append(this.c);
                    f();
                }
            }
            if (e() && IOUtils.l(this.c)) {
                sb.append(this.c);
            }
            return sb.toString();
        }

        public Operator k() {
            Operator operator;
            char c = this.c;
            if (c == '=') {
                f();
                operator = Operator.EQ;
            } else if (c == '!') {
                f();
                a('=');
                operator = Operator.NE;
            } else if (c == '<') {
                f();
                if (this.c == '=') {
                    f();
                    operator = Operator.LE;
                } else {
                    operator = Operator.LT;
                }
            } else if (c == '>') {
                f();
                if (this.c == '=') {
                    f();
                    operator = Operator.GE;
                } else {
                    operator = Operator.GT;
                }
            } else {
                operator = null;
            }
            if (operator == null) {
                String j = j();
                if ("not".equalsIgnoreCase(j)) {
                    o();
                    String j2 = j();
                    if ("like".equalsIgnoreCase(j2)) {
                        return Operator.NOT_LIKE;
                    }
                    if ("rlike".equalsIgnoreCase(j2)) {
                        return Operator.NOT_RLIKE;
                    }
                    if ("in".equalsIgnoreCase(j2)) {
                        return Operator.NOT_IN;
                    }
                    if ("between".equalsIgnoreCase(j2)) {
                        return Operator.NOT_BETWEEN;
                    }
                    throw new UnsupportedOperationException();
                } else if ("like".equalsIgnoreCase(j)) {
                    return Operator.LIKE;
                } else {
                    if ("rlike".equalsIgnoreCase(j)) {
                        return Operator.RLIKE;
                    }
                    if ("in".equalsIgnoreCase(j)) {
                        return Operator.IN;
                    }
                    if ("between".equalsIgnoreCase(j)) {
                        return Operator.BETWEEN;
                    }
                    throw new UnsupportedOperationException();
                }
            }
            return operator;
        }

        public r l() {
            boolean z = true;
            if (this.d == 0 && this.a.length() == 1) {
                if (d(this.c)) {
                    return new a(this.c - '0');
                }
                char c = this.c;
                if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z')) {
                    return new o(Character.toString(c), false);
                }
            }
            while (!e()) {
                o();
                char c2 = this.c;
                if (c2 != '$') {
                    if (c2 != '.' && c2 != '/') {
                        if (c2 == '[') {
                            return g(true);
                        }
                        if (this.d == 0) {
                            return new o(j(), false);
                        }
                        throw new UnsupportedOperationException();
                    }
                    f();
                    if (c2 == '.' && this.c == '.') {
                        f();
                    } else {
                        z = false;
                    }
                    char c3 = this.c;
                    if (c3 == '*') {
                        if (!e()) {
                            f();
                        }
                        return w.a;
                    } else if (d(c3)) {
                        return g(false);
                    } else {
                        String j = j();
                        if (this.c == '(') {
                            f();
                            if (this.c == ')') {
                                if (!e()) {
                                    f();
                                }
                                if ("size".equals(j)) {
                                    return s.a;
                                }
                                throw new UnsupportedOperationException();
                            }
                            throw new UnsupportedOperationException();
                        }
                        return new o(j, z);
                    }
                }
                f();
            }
            return null;
        }

        public String m() {
            char c = this.c;
            f();
            int i = this.b - 1;
            while (this.c != c && !e()) {
                f();
            }
            String substring = this.a.substring(i, e() ? this.b : this.b - 1);
            a(c);
            return substring;
        }

        public Object n() {
            o();
            if (d(this.c)) {
                return Long.valueOf(i());
            }
            char c = this.c;
            if (c == '\"' || c == '\'') {
                return m();
            }
            if (c == 'n') {
                if ("null".equals(j())) {
                    return null;
                }
                throw new JSONPathException(this.a);
            }
            throw new UnsupportedOperationException();
        }

        public final void o() {
            while (true) {
                char c = this.c;
                if (c > ' ') {
                    return;
                }
                if (c != ' ' && c != '\r' && c != '\n' && c != '\t' && c != '\f' && c != '\b') {
                    return;
                }
                f();
            }
        }
    }

    /* loaded from: classes.dex */
    public static class j implements c {
        public final String a;
        public final String b;
        public final String c;
        public final String[] d;
        public final int e;
        public final boolean f;

        public j(String str, String str2, String str3, String[] strArr, boolean z) {
            this.a = str;
            this.b = str2;
            this.c = str3;
            this.d = strArr;
            this.f = z;
            int length = str2 != null ? str2.length() + 0 : 0;
            length = str3 != null ? length + str3.length() : length;
            if (strArr != null) {
                for (String str4 : strArr) {
                    length += str4.length();
                }
            }
            this.e = length;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            int i;
            Object h = jSONPath.h(obj3, this.a, false);
            if (h == null) {
                return false;
            }
            String obj4 = h.toString();
            if (obj4.length() < this.e) {
                return this.f;
            }
            String str = this.b;
            if (str == null) {
                i = 0;
            } else if (!obj4.startsWith(str)) {
                return this.f;
            } else {
                i = this.b.length() + 0;
            }
            String[] strArr = this.d;
            if (strArr != null) {
                for (String str2 : strArr) {
                    int indexOf = obj4.indexOf(str2, i);
                    if (indexOf == -1) {
                        return this.f;
                    }
                    i = indexOf + str2.length();
                }
            }
            String str3 = this.c;
            if (str3 != null && !obj4.endsWith(str3)) {
                return this.f;
            }
            return !this.f;
        }
    }

    /* loaded from: classes.dex */
    public static class k implements r {
        public final int[] a;

        public k(int[] iArr) {
            this.a = iArr;
        }

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            ArrayList arrayList = new ArrayList(this.a.length);
            int i = 0;
            while (true) {
                int[] iArr = this.a;
                if (i >= iArr.length) {
                    return arrayList;
                }
                arrayList.add(jSONPath.f(obj2, iArr[i]));
                i++;
            }
        }
    }

    /* loaded from: classes.dex */
    public static class l implements r {
        public final String[] a;

        public l(String[] strArr) {
            this.a = strArr;
        }

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            ArrayList arrayList = new ArrayList(this.a.length);
            for (String str : this.a) {
                arrayList.add(jSONPath.h(obj2, str, true));
            }
            return arrayList;
        }
    }

    /* loaded from: classes.dex */
    public static class m implements c {
        public final String a;

        public m(String str) {
            this.a = str;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            return jSONPath.h(obj3, this.a, false) != null;
        }
    }

    /* loaded from: classes.dex */
    public static class n implements c {
        public final String a;

        public n(String str) {
            this.a = str;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            return jSONPath.h(obj3, this.a, false) == null;
        }
    }

    /* loaded from: classes.dex */
    public static class o implements r {
        public final String a;
        public final boolean b;

        public o(String str, boolean z) {
            this.a = str;
            this.b = z;
        }

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            if (this.b) {
                ArrayList arrayList = new ArrayList();
                jSONPath.b(obj2, this.a, arrayList);
                return arrayList;
            }
            return jSONPath.h(obj2, this.a, true);
        }
    }

    /* loaded from: classes.dex */
    public static class p implements r {
        public final int a;
        public final int b;
        public final int c;

        public p(int i, int i2, int i3) {
            this.a = i;
            this.b = i2;
            this.c = i3;
        }

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            int intValue = s.a.a(jSONPath, obj, obj2).intValue();
            int i = this.a;
            if (i < 0) {
                i += intValue;
            }
            int i2 = this.b;
            if (i2 < 0) {
                i2 += intValue;
            }
            int i3 = ((i2 - i) / this.c) + 1;
            if (i3 == -1) {
                return null;
            }
            ArrayList arrayList = new ArrayList(i3);
            while (i <= i2 && i < intValue) {
                arrayList.add(jSONPath.f(obj2, i));
                i += this.c;
            }
            return arrayList;
        }
    }

    /* loaded from: classes.dex */
    public static class q implements c {
        public final String a;
        public final Pattern b;
        public final boolean c;

        public q(String str, String str2, boolean z) {
            this.a = str;
            this.b = Pattern.compile(str2);
            this.c = z;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            Object h = jSONPath.h(obj3, this.a, false);
            if (h == null) {
                return false;
            }
            boolean matches = this.b.matcher(h.toString()).matches();
            return this.c ? !matches : matches;
        }
    }

    /* loaded from: classes.dex */
    public interface r {
        Object a(JSONPath jSONPath, Object obj, Object obj2);
    }

    /* loaded from: classes.dex */
    public static class s implements r {
        public static final s a = new s();

        @Override // com.alibaba.fastjson.JSONPath.r
        /* renamed from: b */
        public Integer a(JSONPath jSONPath, Object obj, Object obj2) {
            return Integer.valueOf(jSONPath.e(obj2));
        }
    }

    /* loaded from: classes.dex */
    public static class t implements c {
        public final String a;
        public final String[] b;
        public final boolean c;

        public t(String str, String[] strArr, boolean z) {
            this.a = str;
            this.b = strArr;
            this.c = z;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            String[] strArr;
            Object h = jSONPath.h(obj3, this.a, false);
            for (String str : this.b) {
                if (str == h) {
                    return !this.c;
                }
                if (str != null && str.equals(h)) {
                    return !this.c;
                }
            }
            return this.c;
        }
    }

    /* loaded from: classes.dex */
    public static class u implements c {
        public final String a;
        public final String b;
        public final Operator c;

        public u(String str, String str2, Operator operator) {
            this.a = str;
            this.b = str2;
            this.c = operator;
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            Object h = jSONPath.h(obj3, this.a, false);
            Operator operator = this.c;
            if (operator == Operator.EQ) {
                return this.b.equals(h);
            }
            if (operator == Operator.NE) {
                return !this.b.equals(h);
            }
            if (h == null) {
                return false;
            }
            int compareTo = this.b.compareTo(h.toString());
            Operator operator2 = this.c;
            return operator2 == Operator.GE ? compareTo <= 0 : operator2 == Operator.GT ? compareTo < 0 : operator2 == Operator.LE ? compareTo >= 0 : operator2 == Operator.LT && compareTo > 0;
        }
    }

    /* loaded from: classes.dex */
    public static class v implements c {
        public final String a;
        public final Object b;
        public boolean c;

        public v(String str, Object obj, boolean z) {
            this.c = true;
            if (obj != null) {
                this.a = str;
                this.b = obj;
                this.c = z;
                return;
            }
            throw new IllegalArgumentException("value is null");
        }

        @Override // com.alibaba.fastjson.JSONPath.c
        public boolean a(JSONPath jSONPath, Object obj, Object obj2, Object obj3) {
            boolean equals = this.b.equals(jSONPath.h(obj3, this.a, false));
            return !this.c ? !equals : equals;
        }
    }

    /* loaded from: classes.dex */
    public static class w implements r {
        public static w a = new w();

        @Override // com.alibaba.fastjson.JSONPath.r
        public Object a(JSONPath jSONPath, Object obj, Object obj2) {
            return jSONPath.i(obj2);
        }
    }

    public JSONPath(String str) {
        this(str, SerializeConfig.d(), ParserConfig.m());
    }

    public static JSONPath a(String str) {
        if (str != null) {
            JSONPath jSONPath = g.get(str);
            if (jSONPath == null) {
                JSONPath jSONPath2 = new JSONPath(str);
                if (g.size() < f) {
                    g.putIfAbsent(str, jSONPath2);
                    return g.get(str);
                }
                return jSONPath2;
            }
            return jSONPath;
        }
        throw new JSONPathException("jsonpath can not be null");
    }

    public static Object d(Object obj, String str) {
        return a(str).c(obj);
    }

    public static boolean k(Class<?> cls) {
        return cls == Byte.class || cls == Short.class || cls == Integer.class || cls == Long.class;
    }

    public void b(Object obj, String str, List<Object> list) {
        if (obj == null) {
            return;
        }
        if (obj instanceof Map) {
            Map map = (Map) obj;
            if (map.containsKey(str)) {
                list.add(map.get(str));
                return;
            }
            for (Object obj2 : map.values()) {
                b(obj2, str, list);
            }
            return;
        }
        l1.h g2 = g(obj.getClass());
        if (g2 != null) {
            try {
                l1.f r2 = g2.r(str);
                if (r2 != null) {
                    try {
                        try {
                            list.add(r2.c(obj));
                            return;
                        } catch (InvocationTargetException e2) {
                            throw new JSONException("getFieldValue error." + str, e2);
                        }
                    } catch (IllegalAccessException e3) {
                        throw new JSONException("getFieldValue error." + str, e3);
                    }
                }
                for (Object obj3 : g2.t(obj)) {
                    b(obj3, str, list);
                }
            } catch (Exception e4) {
                throw new JSONPathException("jsonpath error, path " + this.b + ", segement " + str, e4);
            }
        } else if (obj instanceof List) {
            List list2 = (List) obj;
            for (int i2 = 0; i2 < list2.size(); i2++) {
                b(list2.get(i2), str, list);
            }
        }
    }

    public Object c(Object obj) {
        if (obj == null) {
            return null;
        }
        j();
        int i2 = 0;
        Object obj2 = obj;
        while (true) {
            r[] rVarArr = this.c;
            if (i2 >= rVarArr.length) {
                return obj2;
            }
            obj2 = rVarArr[i2].a(this, obj, obj2);
            i2++;
        }
    }

    public int e(Object obj) {
        if (obj == null) {
            return -1;
        }
        if (obj instanceof Collection) {
            return ((Collection) obj).size();
        }
        if (obj instanceof Object[]) {
            return ((Object[]) obj).length;
        }
        if (obj.getClass().isArray()) {
            return Array.getLength(obj);
        }
        if (obj instanceof Map) {
            int i2 = 0;
            for (Object obj2 : ((Map) obj).values()) {
                if (obj2 != null) {
                    i2++;
                }
            }
            return i2;
        }
        l1.h g2 = g(obj.getClass());
        if (g2 == null) {
            return -1;
        }
        try {
            return g2.v(obj);
        } catch (Exception e2) {
            throw new JSONPathException("evalSize error : " + this.b, e2);
        }
    }

    public Object f(Object obj, int i2) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof List) {
            List list = (List) obj;
            if (i2 >= 0) {
                if (i2 < list.size()) {
                    return list.get(i2);
                }
                return null;
            } else if (Math.abs(i2) <= list.size()) {
                return list.get(list.size() + i2);
            } else {
                return null;
            }
        } else if (obj.getClass().isArray()) {
            int length = Array.getLength(obj);
            if (i2 >= 0) {
                if (i2 < length) {
                    return Array.get(obj, i2);
                }
                return null;
            } else if (Math.abs(i2) <= length) {
                return Array.get(obj, length + i2);
            } else {
                return null;
            }
        } else if (obj instanceof Map) {
            Map map = (Map) obj;
            Object obj2 = map.get(Integer.valueOf(i2));
            return obj2 == null ? map.get(Integer.toString(i2)) : obj2;
        } else {
            throw new UnsupportedOperationException();
        }
    }

    public l1.h g(Class<?> cls) {
        l1.h e2 = this.d.e(cls);
        if (e2 instanceof l1.h) {
            return e2;
        }
        return null;
    }

    public Object h(Object obj, String str, boolean z) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Map) {
            Map map = (Map) obj;
            Object obj2 = map.get(str);
            return (obj2 == null && "size".equals(str)) ? Integer.valueOf(map.size()) : obj2;
        }
        l1.h g2 = g(obj.getClass());
        if (g2 != null) {
            try {
                return g2.s(obj, str);
            } catch (Exception e2) {
                throw new JSONPathException("jsonpath error, path " + this.b + ", segement " + str, e2);
            }
        } else if (obj instanceof List) {
            List list = (List) obj;
            if ("size".equals(str)) {
                return Integer.valueOf(list.size());
            }
            JSONArray jSONArray = new JSONArray(list.size());
            for (int i2 = 0; i2 < list.size(); i2++) {
                Object h2 = h(list.get(i2), str, z);
                if (h2 instanceof Collection) {
                    jSONArray.addAll((Collection) h2);
                } else {
                    jSONArray.add(h2);
                }
            }
            return jSONArray;
        } else {
            if (obj instanceof Enum) {
                Enum r7 = (Enum) obj;
                if ("name".equals(str)) {
                    return r7.name();
                }
                if ("ordinal".equals(str)) {
                    return Integer.valueOf(r7.ordinal());
                }
            }
            if (obj instanceof Calendar) {
                Calendar calendar = (Calendar) obj;
                if ("year".equals(str)) {
                    return Integer.valueOf(calendar.get(1));
                }
                if ("month".equals(str)) {
                    return Integer.valueOf(calendar.get(2));
                }
                if ("day".equals(str)) {
                    return Integer.valueOf(calendar.get(5));
                }
                if ("hour".equals(str)) {
                    return Integer.valueOf(calendar.get(11));
                }
                if ("minute".equals(str)) {
                    return Integer.valueOf(calendar.get(12));
                }
                if ("second".equals(str)) {
                    return Integer.valueOf(calendar.get(13));
                }
            }
            throw new JSONPathException("jsonpath error, path " + this.b + ", segement " + str);
        }
    }

    public Collection<Object> i(Object obj) {
        l1.h g2 = g(obj.getClass());
        if (g2 != null) {
            try {
                return g2.t(obj);
            } catch (Exception e2) {
                throw new JSONPathException("jsonpath error, path " + this.b, e2);
            }
        } else if (obj instanceof Map) {
            return ((Map) obj).values();
        } else {
            throw new UnsupportedOperationException();
        }
    }

    public void j() {
        if (this.c != null) {
            return;
        }
        if ("*".equals(this.b)) {
            this.c = new r[]{w.a};
        } else {
            this.c = new i(this.b).c();
        }
    }

    @Override // com.alibaba.fastjson.a
    public String toJSONString() {
        return JSON.toJSONString(this.b);
    }

    public JSONPath(String str, SerializeConfig serializeConfig, ParserConfig parserConfig) {
        if (str != null && str.length() != 0) {
            this.b = str;
            this.d = serializeConfig;
            this.e = parserConfig;
            return;
        }
        throw new JSONPathException("json-path can not be null or empty");
    }
}
