package com.alibaba.fastjson.parser.deserializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.JSONSerializer;
import com.alibaba.fastjson.serializer.SerializeWriter;
import com.alibaba.fastjson.serializer.SerializerFeature;
import j1.a;
import j1.b;
import java.io.IOException;
import java.lang.reflect.Type;
import java.time.Duration;
import java.time.Instant;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.OffsetDateTime;
import java.time.OffsetTime;
import java.time.Period;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.TemporalAccessor;
import java.util.Locale;
import l1.c;
import l1.d;
import l1.k;
/* loaded from: classes.dex */
public class Jdk8DateCodec extends ContextObjectDeserializer implements k, d {
    public static final Jdk8DateCodec a = new Jdk8DateCodec();
    public static final DateTimeFormatter b = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
    public static final DateTimeFormatter c = DateTimeFormatter.ofPattern("yyyy/MM/dd HH:mm:ss");
    public static final DateTimeFormatter d = DateTimeFormatter.ofPattern("yyyy年M月d日 HH:mm:ss");
    public static final DateTimeFormatter e = DateTimeFormatter.ofPattern("yyyy年M月d日 H时m分s秒");
    public static final DateTimeFormatter f = DateTimeFormatter.ofPattern("yyyy년M월d일 HH:mm:ss");
    public static final DateTimeFormatter g = DateTimeFormatter.ofPattern("MM/dd/yyyy HH:mm:ss");
    public static final DateTimeFormatter h = DateTimeFormatter.ofPattern("dd/MM/yyyy HH:mm:ss");
    public static final DateTimeFormatter i = DateTimeFormatter.ofPattern("dd.MM.yyyy HH:mm:ss");
    public static final DateTimeFormatter j = DateTimeFormatter.ofPattern("dd-MM-yyyy HH:mm:ss");
    public static final DateTimeFormatter k = DateTimeFormatter.ofPattern("yyyyMMdd");
    public static final DateTimeFormatter l = DateTimeFormatter.ofPattern("yyyy/MM/dd");
    public static final DateTimeFormatter m = DateTimeFormatter.ofPattern("yyyy年M月d日");
    public static final DateTimeFormatter n = DateTimeFormatter.ofPattern("yyyy년M월d일");
    public static final DateTimeFormatter o = DateTimeFormatter.ofPattern("MM/dd/yyyy");
    public static final DateTimeFormatter p = DateTimeFormatter.ofPattern("dd/MM/yyyy");
    public static final DateTimeFormatter q = DateTimeFormatter.ofPattern("dd.MM.yyyy");
    public static final DateTimeFormatter r = DateTimeFormatter.ofPattern("dd-MM-yyyy");
    public static final DateTimeFormatter s = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss").withZone(ZoneId.systemDefault());
    public static final DateTimeFormatter t = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ss");

    public int b() {
        return 4;
    }

    public void c(JSONSerializer jSONSerializer, Object obj, c cVar) throws IOException {
        j(jSONSerializer.k, (TemporalAccessor) obj, cVar.b());
    }

    public void e(JSONSerializer jSONSerializer, Object obj, Object obj2, Type type, int i2) throws IOException {
        SerializeWriter serializeWriter = jSONSerializer.k;
        if (obj == null) {
            serializeWriter.D();
            return;
        }
        if (type == null) {
            type = obj.getClass();
        }
        if (type == LocalDateTime.class) {
            SerializerFeature serializerFeature = SerializerFeature.UseISO8601DateFormat;
            int mask = serializerFeature.getMask();
            LocalDateTime localDateTime = (LocalDateTime) obj;
            String u = jSONSerializer.u();
            if ((u == null && (i2 & mask) != 0) || jSONSerializer.y(serializerFeature)) {
                u = "yyyy-MM-dd'T'HH:mm:ss";
            }
            if (localDateTime.getNano() != 0 && u == null) {
                serializeWriter.G(obj.toString());
                return;
            }
            if (u == null) {
                u = JSON.DEFFAULT_DATE_FORMAT;
            }
            j(serializeWriter, localDateTime, u);
            return;
        }
        serializeWriter.G(obj.toString());
    }

    @Override // com.alibaba.fastjson.parser.deserializer.ContextObjectDeserializer
    public <T> T f(a aVar, Type type, Object obj, String str, int i2) {
        DateTimeFormatter dateTimeFormatter;
        b bVar = aVar.g;
        if (bVar.H() == 8) {
            bVar.nextToken();
            return null;
        } else if (bVar.H() == 4) {
            String F = bVar.F();
            bVar.nextToken();
            if (str == null) {
                dateTimeFormatter = null;
            } else if ("yyyy-MM-dd HH:mm:ss".equals(str)) {
                dateTimeFormatter = b;
            } else {
                dateTimeFormatter = DateTimeFormatter.ofPattern(str);
            }
            if ("".equals(F)) {
                return null;
            }
            if (type == LocalDateTime.class) {
                if (F.length() != 10 && F.length() != 8) {
                    return (T) g(F, dateTimeFormatter);
                }
                return (T) LocalDateTime.of(h(F, str, dateTimeFormatter), LocalTime.MIN);
            } else if (type == LocalDate.class) {
                if (F.length() == 23) {
                    LocalDateTime parse = LocalDateTime.parse(F);
                    return (T) LocalDate.of(parse.getYear(), parse.getMonthValue(), parse.getDayOfMonth());
                }
                return (T) h(F, str, dateTimeFormatter);
            } else if (type == LocalTime.class) {
                if (F.length() == 23) {
                    LocalDateTime parse2 = LocalDateTime.parse(F);
                    return (T) LocalTime.of(parse2.getHour(), parse2.getMinute(), parse2.getSecond(), parse2.getNano());
                }
                return (T) LocalTime.parse(F);
            } else if (type == ZonedDateTime.class) {
                if (dateTimeFormatter == b) {
                    dateTimeFormatter = s;
                }
                return (T) i(F, dateTimeFormatter);
            } else if (type == OffsetDateTime.class) {
                return (T) OffsetDateTime.parse(F);
            } else {
                if (type == OffsetTime.class) {
                    return (T) OffsetTime.parse(F);
                }
                if (type == ZoneId.class) {
                    return (T) ZoneId.of(F);
                }
                if (type == Period.class) {
                    return (T) Period.parse(F);
                }
                if (type == Duration.class) {
                    return (T) Duration.parse(F);
                }
                if (type == Instant.class) {
                    return (T) Instant.parse(F);
                }
                return null;
            }
        } else {
            throw new UnsupportedOperationException();
        }
    }

    public LocalDateTime g(String str, DateTimeFormatter dateTimeFormatter) {
        if (dateTimeFormatter == null) {
            if (str.length() == 19) {
                char charAt = str.charAt(4);
                char charAt2 = str.charAt(7);
                char charAt3 = str.charAt(10);
                char charAt4 = str.charAt(13);
                char charAt5 = str.charAt(16);
                if (charAt4 == ':' && charAt5 == ':') {
                    if (charAt == '-' && charAt2 == '-') {
                        if (charAt3 == 'T') {
                            dateTimeFormatter = DateTimeFormatter.ISO_LOCAL_DATE_TIME;
                        } else if (charAt3 == ' ') {
                            dateTimeFormatter = b;
                        }
                    } else if (charAt == '-' && charAt2 == '-') {
                        dateTimeFormatter = b;
                    } else if (charAt == '/' && charAt2 == '/') {
                        dateTimeFormatter = c;
                    } else {
                        char charAt6 = str.charAt(0);
                        char charAt7 = str.charAt(1);
                        char charAt8 = str.charAt(2);
                        char charAt9 = str.charAt(3);
                        char charAt10 = str.charAt(5);
                        if (charAt8 == '/' && charAt10 == '/') {
                            int i2 = ((charAt9 - '0') * 10) + (charAt - '0');
                            if (((charAt6 - '0') * 10) + (charAt7 - '0') > 12) {
                                dateTimeFormatter = h;
                            } else if (i2 > 12) {
                                dateTimeFormatter = g;
                            } else {
                                String country = Locale.getDefault().getCountry();
                                if (country.equals("US")) {
                                    dateTimeFormatter = g;
                                } else if (country.equals("BR") || country.equals("AU")) {
                                    dateTimeFormatter = h;
                                }
                            }
                        } else if (charAt8 == '.' && charAt10 == '.') {
                            dateTimeFormatter = i;
                        } else if (charAt8 == '-' && charAt10 == '-') {
                            dateTimeFormatter = j;
                        }
                    }
                }
            }
            if (str.length() >= 17) {
                char charAt11 = str.charAt(4);
                if (charAt11 == 24180) {
                    if (str.charAt(str.length() - 1) == 31186) {
                        dateTimeFormatter = e;
                    } else {
                        dateTimeFormatter = d;
                    }
                } else if (charAt11 == 45380) {
                    dateTimeFormatter = f;
                }
            }
        }
        if (dateTimeFormatter == null) {
            return LocalDateTime.parse(str);
        }
        return LocalDateTime.parse(str, dateTimeFormatter);
    }

    public LocalDate h(String str, String str2, DateTimeFormatter dateTimeFormatter) {
        DateTimeFormatter dateTimeFormatter2;
        if (dateTimeFormatter == null) {
            if (str.length() == 8) {
                dateTimeFormatter = k;
            }
            if (str.length() == 10) {
                char charAt = str.charAt(4);
                char charAt2 = str.charAt(7);
                if (charAt == '/' && charAt2 == '/') {
                    dateTimeFormatter = l;
                }
                char charAt3 = str.charAt(0);
                char charAt4 = str.charAt(1);
                char charAt5 = str.charAt(2);
                char charAt6 = str.charAt(3);
                char charAt7 = str.charAt(5);
                if (charAt5 == '/' && charAt7 == '/') {
                    int i2 = ((charAt6 - '0') * 10) + (charAt - '0');
                    if (((charAt3 - '0') * 10) + (charAt4 - '0') > 12) {
                        dateTimeFormatter = p;
                    } else if (i2 > 12) {
                        dateTimeFormatter = o;
                    } else {
                        String country = Locale.getDefault().getCountry();
                        if (country.equals("US")) {
                            dateTimeFormatter = o;
                        } else if (country.equals("BR") || country.equals("AU")) {
                            dateTimeFormatter = p;
                        }
                    }
                } else {
                    if (charAt5 == '.' && charAt7 == '.') {
                        dateTimeFormatter2 = q;
                    } else if (charAt5 == '-' && charAt7 == '-') {
                        dateTimeFormatter2 = r;
                    }
                    dateTimeFormatter = dateTimeFormatter2;
                }
            }
            if (str.length() >= 9) {
                char charAt8 = str.charAt(4);
                if (charAt8 == 24180) {
                    dateTimeFormatter = m;
                } else if (charAt8 == 45380) {
                    dateTimeFormatter = n;
                }
            }
        }
        if (dateTimeFormatter == null) {
            return LocalDate.parse(str);
        }
        return LocalDate.parse(str, dateTimeFormatter);
    }

    public ZonedDateTime i(String str, DateTimeFormatter dateTimeFormatter) {
        if (dateTimeFormatter == null) {
            if (str.length() == 19) {
                char charAt = str.charAt(4);
                char charAt2 = str.charAt(7);
                char charAt3 = str.charAt(10);
                char charAt4 = str.charAt(13);
                char charAt5 = str.charAt(16);
                if (charAt4 == ':' && charAt5 == ':') {
                    if (charAt == '-' && charAt2 == '-') {
                        if (charAt3 == 'T') {
                            dateTimeFormatter = DateTimeFormatter.ISO_LOCAL_DATE_TIME;
                        } else if (charAt3 == ' ') {
                            dateTimeFormatter = b;
                        }
                    } else if (charAt == '-' && charAt2 == '-') {
                        dateTimeFormatter = b;
                    } else if (charAt == '/' && charAt2 == '/') {
                        dateTimeFormatter = c;
                    } else {
                        char charAt6 = str.charAt(0);
                        char charAt7 = str.charAt(1);
                        char charAt8 = str.charAt(2);
                        char charAt9 = str.charAt(3);
                        char charAt10 = str.charAt(5);
                        if (charAt8 == '/' && charAt10 == '/') {
                            int i2 = ((charAt9 - '0') * 10) + (charAt - '0');
                            if (((charAt6 - '0') * 10) + (charAt7 - '0') > 12) {
                                dateTimeFormatter = h;
                            } else if (i2 > 12) {
                                dateTimeFormatter = g;
                            } else {
                                String country = Locale.getDefault().getCountry();
                                if (country.equals("US")) {
                                    dateTimeFormatter = g;
                                } else if (country.equals("BR") || country.equals("AU")) {
                                    dateTimeFormatter = h;
                                }
                            }
                        } else if (charAt8 == '.' && charAt10 == '.') {
                            dateTimeFormatter = i;
                        } else if (charAt8 == '-' && charAt10 == '-') {
                            dateTimeFormatter = j;
                        }
                    }
                }
            }
            if (str.length() >= 17) {
                char charAt11 = str.charAt(4);
                if (charAt11 == 24180) {
                    if (str.charAt(str.length() - 1) == 31186) {
                        dateTimeFormatter = e;
                    } else {
                        dateTimeFormatter = d;
                    }
                } else if (charAt11 == 45380) {
                    dateTimeFormatter = f;
                }
            }
        }
        if (dateTimeFormatter == null) {
            return ZonedDateTime.parse(str);
        }
        return ZonedDateTime.parse(str, dateTimeFormatter);
    }

    public final void j(SerializeWriter serializeWriter, TemporalAccessor temporalAccessor, String str) {
        DateTimeFormatter ofPattern;
        if (str == "yyyy-MM-dd'T'HH:mm:ss") {
            ofPattern = t;
        } else {
            ofPattern = DateTimeFormatter.ofPattern(str);
        }
        serializeWriter.G(ofPattern.format(temporalAccessor));
    }
}
