package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.parser.deserializer.AbstractDateDeserializer;
import com.alibaba.fastjson.util.IOUtils;
import com.alibaba.fastjson.util.TypeUtils;
import j1.a;
import j1.e;
import java.io.IOException;
import java.lang.reflect.Type;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import l1.k;
/* loaded from: classes.dex */
public class DateCodec extends AbstractDateDeserializer implements k {
    public static final DateCodec a = new DateCodec();

    public int b() {
        return 2;
    }

    public void e(JSONSerializer jSONSerializer, Object obj, Object obj2, Type type, int i) throws IOException {
        Date m;
        char[] charArray;
        SerializeWriter serializeWriter = jSONSerializer.k;
        if (obj == null) {
            serializeWriter.D();
            return;
        }
        if (obj instanceof Date) {
            m = (Date) obj;
        } else {
            m = TypeUtils.m(obj);
        }
        if (serializeWriter.k(SerializerFeature.WriteDateUseDateFormat)) {
            DateFormat t = jSONSerializer.t();
            if (t == null) {
                t = new SimpleDateFormat(JSON.DEFFAULT_DATE_FORMAT, jSONSerializer.s);
                t.setTimeZone(jSONSerializer.r);
            }
            serializeWriter.G(t.format(m));
        } else if (serializeWriter.k(SerializerFeature.WriteClassName) && obj.getClass() != type) {
            if (obj.getClass() == Date.class) {
                serializeWriter.write("new Date(");
                serializeWriter.C(((Date) obj).getTime());
                serializeWriter.write(41);
                return;
            }
            serializeWriter.write(123);
            serializeWriter.r(JSON.DEFAULT_TYPE_KEY);
            jSONSerializer.F(obj.getClass().getName());
            serializeWriter.v(',', "val", ((Date) obj).getTime());
            serializeWriter.write(125);
        } else {
            long time = m.getTime();
            if (serializeWriter.k(SerializerFeature.UseISO8601DateFormat)) {
                int i2 = serializeWriter.k(SerializerFeature.UseSingleQuotes) ? 39 : 34;
                serializeWriter.write(i2);
                Calendar calendar = Calendar.getInstance(jSONSerializer.r, jSONSerializer.s);
                calendar.setTimeInMillis(time);
                int i3 = calendar.get(1);
                int i4 = calendar.get(2) + 1;
                int i5 = calendar.get(5);
                int i6 = calendar.get(11);
                int i7 = calendar.get(12);
                int i8 = calendar.get(13);
                int i9 = calendar.get(14);
                if (i9 != 0) {
                    charArray = "0000-00-00T00:00:00.000".toCharArray();
                    IOUtils.i(i9, 23, charArray);
                    IOUtils.i(i8, 19, charArray);
                    IOUtils.i(i7, 16, charArray);
                    IOUtils.i(i6, 13, charArray);
                    IOUtils.i(i5, 10, charArray);
                    IOUtils.i(i4, 7, charArray);
                    IOUtils.i(i3, 4, charArray);
                } else if (i8 == 0 && i7 == 0 && i6 == 0) {
                    charArray = "0000-00-00".toCharArray();
                    IOUtils.i(i5, 10, charArray);
                    IOUtils.i(i4, 7, charArray);
                    IOUtils.i(i3, 4, charArray);
                } else {
                    charArray = "0000-00-00T00:00:00".toCharArray();
                    IOUtils.i(i8, 19, charArray);
                    IOUtils.i(i7, 16, charArray);
                    IOUtils.i(i6, 13, charArray);
                    IOUtils.i(i5, 10, charArray);
                    IOUtils.i(i4, 7, charArray);
                    IOUtils.i(i3, 4, charArray);
                }
                serializeWriter.write(charArray);
                int rawOffset = calendar.getTimeZone().getRawOffset() / 3600000;
                if (rawOffset == 0) {
                    serializeWriter.write(90);
                } else {
                    if (rawOffset > 0) {
                        serializeWriter.append('+').append(String.format("%02d", Integer.valueOf(rawOffset)));
                    } else {
                        serializeWriter.append('-').append(String.format("%02d", Integer.valueOf(-rawOffset)));
                    }
                    serializeWriter.append(":00");
                }
                serializeWriter.write(i2);
                return;
            }
            serializeWriter.C(time);
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r3v17, types: [java.util.Calendar, T] */
    @Override // com.alibaba.fastjson.parser.deserializer.AbstractDateDeserializer
    public <T> T g(a aVar, Type type, Object obj, Object obj2) {
        if (obj2 == 0) {
            return null;
        }
        if (obj2 instanceof Date) {
            return obj2;
        }
        if (obj2 instanceof Number) {
            return (T) new Date(((Number) obj2).longValue());
        }
        if (obj2 instanceof String) {
            String str = (String) obj2;
            if (str.length() == 0) {
                return null;
            }
            e eVar = new e(str);
            try {
                if (eVar.A0(false)) {
                    ?? r3 = (T) eVar.R();
                    return type == Calendar.class ? r3 : (T) r3.getTime();
                }
                eVar.close();
                if (str.length() == aVar.j().length()) {
                    try {
                        return (T) aVar.k().parse(str);
                    } catch (ParseException unused) {
                    }
                }
                if (str.startsWith("/Date(") && str.endsWith(")/")) {
                    str = str.substring(6, str.length() - 2);
                }
                if ("0000-00-00".equals(str) || "0000-00-00T00:00:00".equalsIgnoreCase(str) || "0001-01-01T00:00:00+08:00".equalsIgnoreCase(str)) {
                    return null;
                }
                return (T) new Date(Long.parseLong(str));
            } finally {
                eVar.close();
            }
        }
        throw new JSONException("parse error");
    }
}
