package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.util.IOUtils;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.lang.reflect.Type;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.IdentityHashMap;
import java.util.Locale;
import java.util.TimeZone;
import java.util.zip.GZIPOutputStream;
import l1.k;
import l1.n;
/* loaded from: classes.dex */
public class JSONSerializer extends SerializeFilterable {
    public final SerializeConfig j;
    public final SerializeWriter k;
    public int l;
    public String m;
    public String n;
    public DateFormat o;
    public IdentityHashMap<Object, n> p;
    public n q;
    public TimeZone r;
    public Locale s;

    public JSONSerializer() {
        this(new SerializeWriter(), SerializeConfig.d());
    }

    public void A() {
        this.k.write(10);
        for (int i = 0; i < this.l; i++) {
            this.k.write(this.m);
        }
    }

    public void B(n nVar, Object obj, Object obj2, int i) {
        C(nVar, obj, obj2, i, 0);
    }

    public void C(n nVar, Object obj, Object obj2, int i, int i2) {
        if (this.k.i) {
            return;
        }
        this.q = new n(nVar, obj, obj2, i, i2);
        if (this.p == null) {
            this.p = new IdentityHashMap<>();
        }
        this.p.put(obj, this.q);
    }

    public void D(String str) {
        this.n = str;
        if (this.o != null) {
            this.o = null;
        }
    }

    public final void E(Object obj) {
        if (obj == null) {
            this.k.D();
            return;
        }
        try {
            v(obj.getClass()).e(this, obj, (Object) null, (Type) null, 0);
        } catch (IOException e) {
            throw new JSONException(e.getMessage(), e);
        }
    }

    public final void F(String str) {
        StringCodec.a.g(this, str);
    }

    public void G() {
        this.k.D();
    }

    public void H(Object obj) {
        n nVar = this.q;
        if (obj == nVar.b) {
            this.k.write("{\"$ref\":\"@\"}");
            return;
        }
        n nVar2 = nVar.a;
        if (nVar2 != null && obj == nVar2.b) {
            this.k.write("{\"$ref\":\"..\"}");
            return;
        }
        while (true) {
            n nVar3 = nVar.a;
            if (nVar3 == null) {
                break;
            }
            nVar = nVar3;
        }
        if (obj == nVar.b) {
            this.k.write("{\"$ref\":\"$\"}");
            return;
        }
        this.k.write("{\"$ref\":\"");
        this.k.write(this.p.get(obj).toString());
        this.k.write("\"}");
    }

    public final void I(Object obj, Object obj2) {
        J(obj, obj2, null, 0);
    }

    public final void J(Object obj, Object obj2, Type type, int i) {
        try {
            if (obj == null) {
                this.k.D();
            } else {
                v(obj.getClass()).e(this, obj, obj2, type, i);
            }
        } catch (IOException e) {
            throw new JSONException(e.getMessage(), e);
        }
    }

    public final void K(Object obj, String str) {
        GZIPOutputStream gZIPOutputStream;
        if (obj instanceof Date) {
            DateFormat t = t();
            if (t == null) {
                t = new SimpleDateFormat(str, this.s);
                t.setTimeZone(this.r);
            }
            this.k.G(t.format((Date) obj));
        } else if (obj instanceof byte[]) {
            byte[] bArr = (byte[]) obj;
            if (!"gzip".equals(str) && !"gzip,base64".equals(str)) {
                if ("hex".equals(str)) {
                    this.k.z(bArr);
                    return;
                } else {
                    this.k.o(bArr);
                    return;
                }
            }
            GZIPOutputStream gZIPOutputStream2 = null;
            try {
                try {
                    ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
                    if (bArr.length < 512) {
                        gZIPOutputStream = new GZIPOutputStream(byteArrayOutputStream, bArr.length);
                    } else {
                        gZIPOutputStream = new GZIPOutputStream(byteArrayOutputStream);
                    }
                    gZIPOutputStream2 = gZIPOutputStream;
                    gZIPOutputStream2.write(bArr);
                    gZIPOutputStream2.finish();
                    this.k.o(byteArrayOutputStream.toByteArray());
                } catch (IOException e) {
                    throw new JSONException("write gzipBytes error", e);
                }
            } finally {
                IOUtils.a(gZIPOutputStream2);
            }
        } else {
            E(obj);
        }
    }

    public void q(SerializerFeature serializerFeature, boolean z) {
        this.k.f(serializerFeature, z);
    }

    public boolean r(Object obj) {
        n nVar;
        IdentityHashMap<Object, n> identityHashMap = this.p;
        if (identityHashMap == null || (nVar = identityHashMap.get(obj)) == null) {
            return false;
        }
        Object obj2 = nVar.c;
        return obj2 == null || (obj2 instanceof Integer) || (obj2 instanceof String);
    }

    public void s() {
        this.l--;
    }

    public DateFormat t() {
        if (this.o == null && this.n != null) {
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat(this.n, this.s);
            this.o = simpleDateFormat;
            simpleDateFormat.setTimeZone(this.r);
        }
        return this.o;
    }

    public String toString() {
        return this.k.toString();
    }

    public String u() {
        DateFormat dateFormat = this.o;
        if (dateFormat instanceof SimpleDateFormat) {
            return ((SimpleDateFormat) dateFormat).toPattern();
        }
        return this.n;
    }

    public k v(Class<?> cls) {
        return this.j.e(cls);
    }

    public SerializeWriter w() {
        return this.k;
    }

    public void x() {
        this.l++;
    }

    public boolean y(SerializerFeature serializerFeature) {
        return this.k.k(serializerFeature);
    }

    public final boolean z(Type type, Object obj) {
        return this.k.k(SerializerFeature.WriteClassName) && !(type == null && this.k.k(SerializerFeature.NotWriteRootClassName) && this.q.a == null);
    }

    public JSONSerializer(SerializeWriter serializeWriter) {
        this(serializeWriter, SerializeConfig.d());
    }

    public JSONSerializer(SerializeWriter serializeWriter, SerializeConfig serializeConfig) {
        this.l = 0;
        this.m = "\t";
        this.p = null;
        this.r = JSON.defaultTimeZone;
        this.s = JSON.defaultLocale;
        this.k = serializeWriter;
        this.j = serializeConfig;
    }
}
