package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONPath;
import com.alibaba.fastjson.c;
import com.alibaba.fastjson.util.TypeUtils;
import j1.a;
import j1.b;
import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.net.Inet4Address;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URL;
import java.net.UnknownHostException;
import java.nio.charset.Charset;
import java.text.SimpleDateFormat;
import java.util.Currency;
import java.util.Iterator;
import java.util.Locale;
import java.util.Map;
import java.util.TimeZone;
import java.util.UUID;
import java.util.regex.Pattern;
import k1.l;
import l1.k;
/* loaded from: classes.dex */
public class MiscCodec implements k, l {
    public static Method b;
    public static final MiscCodec a = new MiscCodec();
    public static boolean c = false;

    public int b() {
        return 4;
    }

    /* JADX WARN: Type inference failed for: r10v36, types: [T, java.text.SimpleDateFormat] */
    public <T> T d(a aVar, Type type, Object obj) {
        Object v;
        String str;
        b bVar = aVar.g;
        InetAddress inetAddress = null;
        int i = 0;
        if (type == InetSocketAddress.class) {
            if (bVar.H() == 8) {
                bVar.nextToken();
                return null;
            }
            aVar.a(12);
            while (true) {
                String F = bVar.F();
                bVar.e(17);
                if (F.equals("address")) {
                    aVar.a(17);
                    inetAddress = (InetAddress) aVar.G(InetAddress.class);
                } else if (F.equals("port")) {
                    aVar.a(17);
                    if (bVar.H() == 2) {
                        int t = bVar.t();
                        bVar.nextToken();
                        i = t;
                    } else {
                        throw new JSONException("port is not int");
                    }
                } else {
                    aVar.a(17);
                    aVar.v();
                }
                if (bVar.H() == 16) {
                    bVar.nextToken();
                } else {
                    aVar.a(13);
                    return (T) new InetSocketAddress(inetAddress, i);
                }
            }
        } else {
            if (aVar.l == 2) {
                aVar.l = 0;
                aVar.a(16);
                if (bVar.H() == 4) {
                    if ("val".equals(bVar.F())) {
                        bVar.nextToken();
                        aVar.a(17);
                        v = aVar.v();
                        aVar.a(13);
                    } else {
                        throw new JSONException("syntax error");
                    }
                } else {
                    throw new JSONException("syntax error");
                }
            } else {
                v = aVar.v();
            }
            if (v == null) {
                str = null;
            } else if (v instanceof String) {
                str = (String) v;
            } else {
                if (v instanceof JSONObject) {
                    JSONObject jSONObject = (JSONObject) v;
                    if (type == Currency.class) {
                        String string = jSONObject.getString("currency");
                        if (string != null) {
                            return (T) Currency.getInstance(string);
                        }
                        String string2 = jSONObject.getString("symbol");
                        if (string2 != null) {
                            return (T) Currency.getInstance(string2);
                        }
                    }
                    if (type == Map.Entry.class) {
                        return (T) jSONObject.entrySet().iterator().next();
                    }
                }
                throw new JSONException("expect string");
            }
            if (str == null || str.length() == 0) {
                return null;
            }
            if (type == UUID.class) {
                return (T) UUID.fromString(str);
            }
            if (type == URI.class) {
                return (T) URI.create(str);
            }
            if (type == URL.class) {
                try {
                    return (T) new URL(str);
                } catch (MalformedURLException e) {
                    throw new JSONException("create url error", e);
                }
            } else if (type == Pattern.class) {
                return (T) Pattern.compile(str);
            } else {
                if (type == Locale.class) {
                    return (T) TypeUtils.Z(str);
                }
                if (type == SimpleDateFormat.class) {
                    ?? r10 = (T) new SimpleDateFormat(str, bVar.o());
                    r10.setTimeZone(bVar.i());
                    return r10;
                } else if (type != InetAddress.class && type != Inet4Address.class && type != Inet6Address.class) {
                    if (type == File.class) {
                        return (T) new File(str);
                    }
                    if (type == TimeZone.class) {
                        return (T) TimeZone.getTimeZone(str);
                    }
                    if (type instanceof ParameterizedType) {
                        type = ((ParameterizedType) type).getRawType();
                    }
                    if (type == Class.class) {
                        return (T) TypeUtils.X(str, aVar.h().h());
                    }
                    if (type == Charset.class) {
                        return (T) Charset.forName(str);
                    }
                    if (type == Currency.class) {
                        return (T) Currency.getInstance(str);
                    }
                    if (type == JSONPath.class) {
                        return (T) new JSONPath(str);
                    }
                    if (type instanceof Class) {
                        String name = ((Class) type).getName();
                        if (name.equals("java.nio.file.Path")) {
                            try {
                                if (b == null && !c) {
                                    b = TypeUtils.W("java.nio.file.Paths").getMethod("get", String.class, String[].class);
                                }
                                Method method = b;
                                if (method != null) {
                                    return (T) method.invoke(null, str, new String[0]);
                                }
                                throw new JSONException("Path deserialize erorr");
                            } catch (IllegalAccessException e2) {
                                throw new JSONException("Path deserialize erorr", e2);
                            } catch (NoSuchMethodException unused) {
                                c = true;
                            } catch (InvocationTargetException e3) {
                                throw new JSONException("Path deserialize erorr", e3);
                            }
                        }
                        throw new JSONException("MiscCodec not support " + name);
                    }
                    throw new JSONException("MiscCodec not support " + type.toString());
                } else {
                    try {
                        return (T) InetAddress.getByName(str);
                    } catch (UnknownHostException e4) {
                        throw new JSONException("deserialize inet adress error", e4);
                    }
                }
            }
        }
    }

    public void e(JSONSerializer jSONSerializer, Object obj, Object obj2, Type type, int i) throws IOException {
        String currencyCode;
        SerializeWriter serializeWriter = jSONSerializer.k;
        if (obj == null) {
            serializeWriter.D();
            return;
        }
        Class<?> cls = obj.getClass();
        if (cls == SimpleDateFormat.class) {
            currencyCode = ((SimpleDateFormat) obj).toPattern();
            if (serializeWriter.k(SerializerFeature.WriteClassName) && obj.getClass() != type) {
                serializeWriter.write(123);
                serializeWriter.r(JSON.DEFAULT_TYPE_KEY);
                jSONSerializer.F(obj.getClass().getName());
                serializeWriter.w(',', "val", currencyCode);
                serializeWriter.write(125);
                return;
            }
        } else if (cls == Class.class) {
            currencyCode = ((Class) obj).getName();
        } else if (cls == InetSocketAddress.class) {
            InetSocketAddress inetSocketAddress = (InetSocketAddress) obj;
            InetAddress address = inetSocketAddress.getAddress();
            serializeWriter.write(123);
            if (address != null) {
                serializeWriter.r("address");
                jSONSerializer.E(address);
                serializeWriter.write(44);
            }
            serializeWriter.r("port");
            serializeWriter.A(inetSocketAddress.getPort());
            serializeWriter.write(125);
            return;
        } else if (obj instanceof File) {
            currencyCode = ((File) obj).getPath();
        } else if (obj instanceof InetAddress) {
            currencyCode = ((InetAddress) obj).getHostAddress();
        } else if (obj instanceof TimeZone) {
            currencyCode = ((TimeZone) obj).getID();
        } else if (obj instanceof Currency) {
            currencyCode = ((Currency) obj).getCurrencyCode();
        } else if (obj instanceof c) {
            ((c) obj).writeJSONString(serializeWriter);
            return;
        } else if (obj instanceof Iterator) {
            f(jSONSerializer, serializeWriter, (Iterator) obj);
            return;
        } else if (obj instanceof Iterable) {
            f(jSONSerializer, serializeWriter, ((Iterable) obj).iterator());
            return;
        } else if (obj instanceof Map.Entry) {
            Map.Entry entry = (Map.Entry) obj;
            Object key = entry.getKey();
            Object value = entry.getValue();
            if (key instanceof String) {
                String str = (String) key;
                if (value instanceof String) {
                    serializeWriter.x('{', str, (String) value);
                } else {
                    serializeWriter.write(123);
                    serializeWriter.r(str);
                    jSONSerializer.E(value);
                }
            } else {
                serializeWriter.write(123);
                jSONSerializer.E(key);
                serializeWriter.write(58);
                jSONSerializer.E(value);
            }
            serializeWriter.write(125);
            return;
        } else if (obj.getClass().getName().equals("net.sf.json.JSONNull")) {
            serializeWriter.D();
            return;
        } else {
            throw new JSONException("not support class : " + cls);
        }
        serializeWriter.G(currencyCode);
    }

    public void f(JSONSerializer jSONSerializer, SerializeWriter serializeWriter, Iterator<?> it) {
        serializeWriter.write(91);
        int i = 0;
        while (it.hasNext()) {
            if (i != 0) {
                serializeWriter.write(44);
            }
            jSONSerializer.E(it.next());
            i++;
        }
        serializeWriter.write(93);
    }
}
