package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.util.TypeUtils;
import j1.a;
import j1.b;
import java.io.IOException;
import java.lang.reflect.Array;
import java.lang.reflect.GenericArrayType;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import k1.l;
import l1.k;
import l1.n;
/* loaded from: classes.dex */
public class ObjectArrayCodec implements k, l {
    public static final ObjectArrayCodec a = new ObjectArrayCodec();

    public int b() {
        return 14;
    }

    /* JADX WARN: Type inference failed for: r8v1, types: [T, byte[]] */
    public <T> T d(a aVar, Type type, Object obj) {
        Type componentType;
        Class<?> cls;
        b bVar = aVar.g;
        int H = bVar.H();
        Type type2 = 0;
        if (H == 8) {
            bVar.e(16);
            return null;
        } else if (H != 4 && H != 26) {
            if (type instanceof GenericArrayType) {
                componentType = ((GenericArrayType) type).getGenericComponentType();
                if (componentType instanceof TypeVariable) {
                    TypeVariable typeVariable = (TypeVariable) componentType;
                    Type type3 = aVar.i().d;
                    if (type3 instanceof ParameterizedType) {
                        ParameterizedType parameterizedType = (ParameterizedType) type3;
                        Type rawType = parameterizedType.getRawType();
                        if (rawType instanceof Class) {
                            TypeVariable<Class<T>>[] typeParameters = ((Class) rawType).getTypeParameters();
                            for (int i = 0; i < typeParameters.length; i++) {
                                if (typeParameters[i].getName().equals(typeVariable.getName())) {
                                    type2 = parameterizedType.getActualTypeArguments()[i];
                                }
                            }
                        }
                        if (type2 instanceof Class) {
                            cls = type2;
                        } else {
                            cls = Object.class;
                        }
                    } else {
                        cls = TypeUtils.D(typeVariable.getBounds()[0]);
                    }
                } else {
                    cls = TypeUtils.D(componentType);
                }
            } else {
                componentType = ((Class) type).getComponentType();
                cls = componentType;
            }
            JSONArray jSONArray = new JSONArray();
            aVar.A(componentType, jSONArray, obj);
            return (T) f(aVar, cls, jSONArray);
        } else {
            ?? r8 = (T) bVar.g();
            bVar.e(16);
            if (r8.length != 0 || type == byte[].class) {
                return r8;
            }
            return null;
        }
    }

    public final void e(JSONSerializer jSONSerializer, Object obj, Object obj2, Type type, int i) throws IOException {
        SerializeWriter serializeWriter = jSONSerializer.k;
        Object[] objArr = (Object[]) obj;
        if (obj == null) {
            serializeWriter.F(SerializerFeature.WriteNullListAsEmpty);
            return;
        }
        int length = objArr.length;
        int i2 = length - 1;
        if (i2 == -1) {
            serializeWriter.append("[]");
            return;
        }
        n nVar = jSONSerializer.q;
        jSONSerializer.B(nVar, obj, obj2, 0);
        try {
            serializeWriter.append('[');
            if (serializeWriter.k(SerializerFeature.PrettyFormat)) {
                jSONSerializer.x();
                jSONSerializer.A();
                for (int i3 = 0; i3 < length; i3++) {
                    if (i3 != 0) {
                        serializeWriter.write(44);
                        jSONSerializer.A();
                    }
                    jSONSerializer.E(objArr[i3]);
                }
                jSONSerializer.s();
                jSONSerializer.A();
                serializeWriter.write(93);
                return;
            }
            Class<?> cls = null;
            k kVar = null;
            for (int i4 = 0; i4 < i2; i4++) {
                Object obj3 = objArr[i4];
                if (obj3 == null) {
                    serializeWriter.append("null,");
                } else {
                    if (jSONSerializer.r(obj3)) {
                        jSONSerializer.H(obj3);
                    } else {
                        Class<?> cls2 = obj3.getClass();
                        if (cls2 == cls) {
                            kVar.e(jSONSerializer, obj3, (Object) null, (Type) null, 0);
                        } else {
                            kVar = jSONSerializer.v(cls2);
                            kVar.e(jSONSerializer, obj3, (Object) null, (Type) null, 0);
                            cls = cls2;
                        }
                    }
                    serializeWriter.append(',');
                }
            }
            Object obj4 = objArr[i2];
            if (obj4 == null) {
                serializeWriter.append("null]");
            } else {
                if (jSONSerializer.r(obj4)) {
                    jSONSerializer.H(obj4);
                } else {
                    jSONSerializer.I(obj4, Integer.valueOf(i2));
                }
                serializeWriter.append(']');
            }
        } finally {
            jSONSerializer.q = nVar;
        }
    }

    /* JADX WARN: Removed duplicated region for block: B:29:0x0057  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public final <T> T f(a aVar, Class<?> cls, JSONArray jSONArray) {
        Object obj;
        if (jSONArray == null) {
            return null;
        }
        int size = jSONArray.size();
        T t = (T) Array.newInstance(cls, size);
        for (int i = 0; i < size; i++) {
            Object obj2 = jSONArray.get(i);
            if (obj2 == jSONArray) {
                Array.set(t, i, t);
            } else if (cls.isArray()) {
                if (!cls.isInstance(obj2)) {
                    obj2 = f(aVar, cls, (JSONArray) obj2);
                }
                Array.set(t, i, obj2);
            } else {
                if (obj2 instanceof JSONArray) {
                    JSONArray jSONArray2 = (JSONArray) obj2;
                    int size2 = jSONArray2.size();
                    boolean z = false;
                    for (int i2 = 0; i2 < size2; i2++) {
                        if (jSONArray2.get(i2) == jSONArray) {
                            jSONArray2.set(i, t);
                            z = true;
                        }
                    }
                    if (z) {
                        obj = jSONArray2.toArray();
                        if (obj == null) {
                            obj = TypeUtils.d(obj2, cls, aVar.h());
                        }
                        Array.set(t, i, obj);
                    }
                }
                obj = null;
                if (obj == null) {
                }
                Array.set(t, i, obj);
            }
        }
        jSONArray.setRelatedArray(t);
        jSONArray.setComponentType(cls);
        return t;
    }
}
