package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.PropertyNamingStrategy;
import com.alibaba.fastjson.c;
import com.alibaba.fastjson.parser.deserializer.Jdk8DateCodec;
import com.alibaba.fastjson.parser.deserializer.OptionalCodec;
import com.alibaba.fastjson.support.springfox.SwaggerJsonSerializer;
import com.alibaba.fastjson.util.ASMUtils;
import com.alibaba.fastjson.util.IdentityHashMap;
import com.alibaba.fastjson.util.ServiceLoader;
import com.alibaba.fastjson.util.TypeUtils;
import h1.b;
import h1.d;
import java.io.File;
import java.io.Serializable;
import java.lang.ref.SoftReference;
import java.lang.ref.WeakReference;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.Type;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.net.Inet4Address;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.URI;
import java.net.URL;
import java.nio.charset.Charset;
import java.sql.Clob;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collection;
import java.util.Currency;
import java.util.Date;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.TimeZone;
import java.util.UUID;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicIntegerArray;
import java.util.concurrent.atomic.AtomicLong;
import java.util.concurrent.atomic.AtomicLongArray;
import java.util.concurrent.atomic.AtomicReference;
import java.util.regex.Pattern;
import javax.xml.datatype.XMLGregorianCalendar;
import l1.f;
import l1.g;
import l1.h;
import l1.k;
import l1.o;
import m1.a;
/* loaded from: classes.dex */
public class SerializeConfig {
    public static final SerializeConfig g = new SerializeConfig();
    public static boolean h = false;
    public static boolean i = false;
    public static boolean j = false;
    public static boolean k = false;
    public static boolean l = false;
    public boolean a;
    public ASMSerializerFactory b;
    public String c;
    public PropertyNamingStrategy d;
    public final IdentityHashMap<Type, k> e;
    public final boolean f;

    public SerializeConfig() {
        this(1024);
    }

    public static SerializeConfig d() {
        return g;
    }

    public final h a(o oVar) throws Exception {
        h z = this.b.z(oVar);
        int i2 = 0;
        while (true) {
            f[] fVarArr = z.k;
            if (i2 >= fVarArr.length) {
                return z;
            }
            Class<?> cls = fVarArr[i2].b.f;
            if (cls.isEnum() && !(e(cls) instanceof EnumSerializer)) {
                z.i = false;
            }
            i2++;
        }
    }

    public final k b(Class<?> cls) {
        o c = TypeUtils.c(cls, null, this.d, this.f);
        if (c.e.length == 0 && Iterable.class.isAssignableFrom(cls)) {
            return MiscCodec.a;
        }
        return c(c);
    }

    /* JADX WARN: Code restructure failed: missing block: B:90:0x0102, code lost:
        r0 = a(r14);
     */
    /* JADX WARN: Code restructure failed: missing block: B:91:0x0106, code lost:
        if (r0 == null) goto L56;
     */
    /* JADX WARN: Code restructure failed: missing block: B:92:0x0108, code lost:
        return r0;
     */
    /* JADX WARN: Code restructure failed: missing block: B:93:0x0109, code lost:
        r14 = move-exception;
     */
    /* JADX WARN: Code restructure failed: missing block: B:95:0x0120, code lost:
        throw new com.alibaba.fastjson.JSONException("create asm serializer error, class " + r0, r14);
     */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public k c(o oVar) {
        a[] aVarArr;
        Method method;
        SerializerFeature[] serialzeFeatures;
        SerializerFeature[] serialzeFeatures2;
        d dVar = oVar.d;
        boolean z = false;
        if (dVar != null) {
            Class serializer = dVar.serializer();
            if (serializer != Void.class) {
                try {
                    Object newInstance = serializer.newInstance();
                    if (newInstance instanceof k) {
                        return (k) newInstance;
                    }
                } catch (Throwable unused) {
                }
            }
            if (!dVar.asm()) {
                this.a = false;
            }
            for (SerializerFeature serializerFeature : dVar.serialzeFeatures()) {
                if (SerializerFeature.WriteNonStringValueAsString == serializerFeature || SerializerFeature.WriteEnumUsingToString == serializerFeature || SerializerFeature.NotWriteDefaultValue == serializerFeature) {
                    this.a = false;
                    break;
                }
            }
        }
        Class<?> cls = oVar.a;
        if (!Modifier.isPublic(cls.getModifiers())) {
            return new h(oVar);
        }
        boolean z2 = this.a && !this.f;
        if ((z2 && this.b.a.c(cls)) || cls == Serializable.class || cls == Object.class) {
            z2 = false;
        }
        if (z2 && !ASMUtils.a(cls.getSimpleName())) {
            z2 = false;
        }
        if (z2) {
            for (a aVar : oVar.e) {
                Field field = aVar.d;
                if ((field != null && !field.getType().equals(aVar.f)) || ((method = aVar.c) != null && !method.getReturnType().equals(aVar.f))) {
                    break;
                }
                b e = aVar.e();
                if (e != null) {
                    if (!ASMUtils.a(e.name()) || e.format().length() != 0 || e.jsonDirect() || e.serializeUsing() != Void.class || e.unwrapped()) {
                        break;
                    }
                    for (SerializerFeature serializerFeature2 : e.serialzeFeatures()) {
                        if (SerializerFeature.WriteNonStringValueAsString == serializerFeature2 || SerializerFeature.WriteEnumUsingToString == serializerFeature2 || SerializerFeature.NotWriteDefaultValue == serializerFeature2) {
                            z2 = false;
                            break;
                        }
                    }
                    if (TypeUtils.O(method)) {
                        z = true;
                        break;
                    }
                }
            }
        }
        z = z2;
        return new h(oVar);
    }

    public k e(Class<?> cls) {
        return f(cls, true);
    }

    public final k f(Class<?> cls, boolean z) {
        ClassLoader classLoader;
        k b = this.e.b(cls);
        if (b == null) {
            try {
                for (Object obj : ServiceLoader.a(l1.b.class, Thread.currentThread().getContextClassLoader())) {
                    if (obj instanceof l1.b) {
                        l1.b bVar = (l1.b) obj;
                        for (Type type : bVar.a()) {
                            g(type, bVar);
                        }
                    }
                }
            } catch (ClassCastException unused) {
            }
            b = this.e.b(cls);
        }
        if (b == null && (classLoader = JSON.class.getClassLoader()) != Thread.currentThread().getContextClassLoader()) {
            try {
                for (Object obj2 : ServiceLoader.a(l1.b.class, classLoader)) {
                    if (obj2 instanceof l1.b) {
                        l1.b bVar2 = (l1.b) obj2;
                        for (Type type2 : bVar2.a()) {
                            g(type2, bVar2);
                        }
                    }
                }
            } catch (ClassCastException unused2) {
            }
            b = this.e.b(cls);
        }
        if (b == null) {
            String name = cls.getName();
            if (Map.class.isAssignableFrom(cls)) {
                g(cls, MapSerializer.j);
            } else if (List.class.isAssignableFrom(cls)) {
                g(cls, ListSerializer.a);
            } else if (Collection.class.isAssignableFrom(cls)) {
                g(cls, CollectionCodec.a);
            } else if (Date.class.isAssignableFrom(cls)) {
                g(cls, DateCodec.a);
            } else if (com.alibaba.fastjson.a.class.isAssignableFrom(cls)) {
                g(cls, JSONAwareSerializer.a);
            } else if (g.class.isAssignableFrom(cls)) {
                g(cls, JSONSerializableSerializer.a);
            } else if (c.class.isAssignableFrom(cls)) {
                g(cls, MiscCodec.a);
            } else if (!cls.isEnum() && (cls.getSuperclass() == null || !cls.getSuperclass().isEnum())) {
                if (cls.isArray()) {
                    Class<?> componentType = cls.getComponentType();
                    g(cls, new l1.a(componentType, e(componentType)));
                } else if (Throwable.class.isAssignableFrom(cls)) {
                    o b2 = TypeUtils.b(cls, null, this.d);
                    b2.g |= SerializerFeature.WriteClassName.mask;
                    g(cls, new h(b2));
                } else if (!TimeZone.class.isAssignableFrom(cls) && !Map.Entry.class.isAssignableFrom(cls)) {
                    if (Appendable.class.isAssignableFrom(cls)) {
                        g(cls, AppendableSerializer.a);
                    } else if (Charset.class.isAssignableFrom(cls)) {
                        g(cls, ToStringSerializer.a);
                    } else if (Enumeration.class.isAssignableFrom(cls)) {
                        g(cls, EnumerationSerializer.a);
                    } else if (!Calendar.class.isAssignableFrom(cls) && !XMLGregorianCalendar.class.isAssignableFrom(cls)) {
                        if (Clob.class.isAssignableFrom(cls)) {
                            g(cls, ClobSeriliazer.a);
                        } else if (TypeUtils.T(cls)) {
                            g(cls, ToStringSerializer.a);
                        } else if (Iterator.class.isAssignableFrom(cls)) {
                            g(cls, MiscCodec.a);
                        } else if (name.startsWith("java.awt.") && AwtCodec.k(cls)) {
                            if (!h) {
                                try {
                                    Class<?> cls2 = Class.forName("java.awt.Color");
                                    AwtCodec awtCodec = AwtCodec.a;
                                    g(cls2, awtCodec);
                                    g(Class.forName("java.awt.Font"), awtCodec);
                                    g(Class.forName("java.awt.Point"), awtCodec);
                                    g(Class.forName("java.awt.Rectangle"), awtCodec);
                                } catch (Throwable unused3) {
                                    h = true;
                                }
                            }
                            return AwtCodec.a;
                        } else {
                            if (!i && (name.startsWith("java.time.") || name.startsWith("java.util.Optional") || name.equals("java.util.concurrent.atomic.LongAdder") || name.equals("java.util.concurrent.atomic.DoubleAdder"))) {
                                try {
                                    Class<?> cls3 = Class.forName("java.time.LocalDateTime");
                                    Jdk8DateCodec jdk8DateCodec = Jdk8DateCodec.a;
                                    g(cls3, jdk8DateCodec);
                                    g(Class.forName("java.time.LocalDate"), jdk8DateCodec);
                                    g(Class.forName("java.time.LocalTime"), jdk8DateCodec);
                                    g(Class.forName("java.time.ZonedDateTime"), jdk8DateCodec);
                                    g(Class.forName("java.time.OffsetDateTime"), jdk8DateCodec);
                                    g(Class.forName("java.time.OffsetTime"), jdk8DateCodec);
                                    g(Class.forName("java.time.ZoneOffset"), jdk8DateCodec);
                                    g(Class.forName("java.time.ZoneRegion"), jdk8DateCodec);
                                    g(Class.forName("java.time.Period"), jdk8DateCodec);
                                    g(Class.forName("java.time.Duration"), jdk8DateCodec);
                                    g(Class.forName("java.time.Instant"), jdk8DateCodec);
                                    g(Class.forName("java.util.Optional"), OptionalCodec.a);
                                    g(Class.forName("java.util.OptionalDouble"), OptionalCodec.a);
                                    g(Class.forName("java.util.OptionalInt"), OptionalCodec.a);
                                    g(Class.forName("java.util.OptionalLong"), OptionalCodec.a);
                                    Class<?> cls4 = Class.forName("java.util.concurrent.atomic.LongAdder");
                                    AdderSerializer adderSerializer = AdderSerializer.a;
                                    g(cls4, adderSerializer);
                                    g(Class.forName("java.util.concurrent.atomic.DoubleAdder"), adderSerializer);
                                    k b3 = this.e.b(cls);
                                    if (b3 != null) {
                                        return b3;
                                    }
                                } catch (Throwable unused4) {
                                    i = true;
                                }
                            }
                            if (!j && name.startsWith("oracle.sql.")) {
                                try {
                                    Class<?> cls5 = Class.forName("oracle.sql.DATE");
                                    DateCodec dateCodec = DateCodec.a;
                                    g(cls5, dateCodec);
                                    g(Class.forName("oracle.sql.TIMESTAMP"), dateCodec);
                                    k b4 = this.e.b(cls);
                                    if (b4 != null) {
                                        return b4;
                                    }
                                } catch (Throwable unused5) {
                                    j = true;
                                }
                            }
                            if (!k && name.equals("springfox.documentation.spring.web.json.Json")) {
                                try {
                                    g(Class.forName("springfox.documentation.spring.web.json.Json"), SwaggerJsonSerializer.a);
                                    k b5 = this.e.b(cls);
                                    if (b5 != null) {
                                        return b5;
                                    }
                                } catch (ClassNotFoundException unused6) {
                                    k = true;
                                }
                            }
                            if (!l && name.startsWith("com.google.common.collect.")) {
                                try {
                                    g(Class.forName("com.google.common.collect.HashMultimap"), GuavaCodec.a);
                                    g(Class.forName("com.google.common.collect.LinkedListMultimap"), GuavaCodec.a);
                                    g(Class.forName("com.google.common.collect.ArrayListMultimap"), GuavaCodec.a);
                                    g(Class.forName("com.google.common.collect.TreeMultimap"), GuavaCodec.a);
                                    k b6 = this.e.b(cls);
                                    if (b6 != null) {
                                        return b6;
                                    }
                                } catch (ClassNotFoundException unused7) {
                                    l = true;
                                }
                            }
                            if (name.equals("net.sf.json.JSONNull")) {
                                try {
                                    g(Class.forName("net.sf.json.JSONNull"), MiscCodec.a);
                                } catch (ClassNotFoundException unused8) {
                                }
                                k b7 = this.e.b(cls);
                                if (b7 != null) {
                                    return b7;
                                }
                            }
                            Class<?>[] interfaces = cls.getInterfaces();
                            if (interfaces.length == 1 && interfaces[0].isAnnotation()) {
                                return AnnotationSerializer.a;
                            }
                            if (TypeUtils.U(cls)) {
                                k e = e(cls.getSuperclass());
                                g(cls, e);
                                return e;
                            } else if (z) {
                                g(cls, b(cls));
                            }
                        }
                    } else {
                        g(cls, CalendarCodec.b);
                    }
                } else {
                    g(cls, MiscCodec.a);
                }
            } else {
                d annotation = cls.getAnnotation(d.class);
                if (annotation != null && annotation.serializeEnumAsJavaBean()) {
                    g(cls, b(cls));
                } else {
                    g(cls, EnumSerializer.a);
                }
            }
            return this.e.b(cls);
        }
        return b;
    }

    public boolean g(Type type, k kVar) {
        return this.e.c(type, kVar);
    }

    public SerializeConfig(int i2) {
        this(i2, false);
    }

    public SerializeConfig(int i2, boolean z) {
        this.a = !ASMUtils.b;
        this.c = JSON.DEFAULT_TYPE_KEY;
        this.f = z;
        this.e = new IdentityHashMap<>(1024);
        try {
            if (this.a) {
                this.b = new ASMSerializerFactory();
            }
        } catch (Throwable unused) {
            this.a = false;
        }
        g(Boolean.class, BooleanCodec.a);
        g(Character.class, CharacterCodec.a);
        g(Byte.class, IntegerCodec.a);
        g(Short.class, IntegerCodec.a);
        g(Integer.class, IntegerCodec.a);
        g(Long.class, LongCodec.a);
        g(Float.class, FloatCodec.b);
        g(Double.class, DoubleSerializer.b);
        g(BigDecimal.class, BigDecimalCodec.a);
        g(BigInteger.class, BigIntegerCodec.a);
        g(String.class, StringCodec.a);
        g(byte[].class, PrimitiveArraySerializer.a);
        g(short[].class, PrimitiveArraySerializer.a);
        g(int[].class, PrimitiveArraySerializer.a);
        g(long[].class, PrimitiveArraySerializer.a);
        g(float[].class, PrimitiveArraySerializer.a);
        g(double[].class, PrimitiveArraySerializer.a);
        g(boolean[].class, PrimitiveArraySerializer.a);
        g(char[].class, PrimitiveArraySerializer.a);
        g(Object[].class, ObjectArrayCodec.a);
        MiscCodec miscCodec = MiscCodec.a;
        g(Class.class, miscCodec);
        g(SimpleDateFormat.class, miscCodec);
        g(Currency.class, new MiscCodec());
        g(TimeZone.class, miscCodec);
        g(InetAddress.class, miscCodec);
        g(Inet4Address.class, miscCodec);
        g(Inet6Address.class, miscCodec);
        g(InetSocketAddress.class, miscCodec);
        g(File.class, miscCodec);
        AppendableSerializer appendableSerializer = AppendableSerializer.a;
        g(Appendable.class, appendableSerializer);
        g(StringBuffer.class, appendableSerializer);
        g(StringBuilder.class, appendableSerializer);
        ToStringSerializer toStringSerializer = ToStringSerializer.a;
        g(Charset.class, toStringSerializer);
        g(Pattern.class, toStringSerializer);
        g(Locale.class, toStringSerializer);
        g(URI.class, toStringSerializer);
        g(URL.class, toStringSerializer);
        g(UUID.class, toStringSerializer);
        AtomicCodec atomicCodec = AtomicCodec.a;
        g(AtomicBoolean.class, atomicCodec);
        g(AtomicInteger.class, atomicCodec);
        g(AtomicLong.class, atomicCodec);
        ReferenceCodec referenceCodec = ReferenceCodec.a;
        g(AtomicReference.class, referenceCodec);
        g(AtomicIntegerArray.class, atomicCodec);
        g(AtomicLongArray.class, atomicCodec);
        g(WeakReference.class, referenceCodec);
        g(SoftReference.class, referenceCodec);
    }
}
