package com.alibaba.fastjson.serializer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.util.IOUtils;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;
import java.nio.charset.Charset;
/* loaded from: classes.dex */
public final class SerializeWriter extends Writer {
    public static final Charset r = Charset.forName("UTF-8");
    public static final ThreadLocal<char[]> s = new ThreadLocal<>();
    public static final ThreadLocal<byte[]> t = new ThreadLocal<>();
    public static final int u = (((((((((SerializerFeature.UseSingleQuotes.mask | 0) | SerializerFeature.BrowserSecure.mask) | SerializerFeature.BrowserCompatible.mask) | SerializerFeature.PrettyFormat.mask) | SerializerFeature.WriteEnumUsingToString.mask) | SerializerFeature.WriteNonStringValueAsString.mask) | SerializerFeature.WriteSlashAsSpecial.mask) | SerializerFeature.IgnoreErrorGetter.mask) | SerializerFeature.WriteClassName.mask) | SerializerFeature.NotWriteDefaultValue.mask;
    public char[] b;
    public int c;
    public int d;
    public final Writer e;
    public boolean f;
    public boolean g;
    public boolean h;
    public boolean i;
    public boolean j;
    public boolean k;
    public boolean l;
    public boolean m;
    public boolean n;
    public boolean o;
    public char p;
    public int q;

    public SerializeWriter() {
        this(null);
    }

    public static boolean l(char c, int i) {
        if (c == ' ') {
            return false;
        }
        if (c == '/') {
            return (SerializerFeature.WriteSlashAsSpecial.mask & i) != 0;
        } else if (c <= '#' || c == '\\') {
            return c <= 31 || c == '\\' || c == '\"';
        } else {
            return false;
        }
    }

    public void A(int i) {
        if (i == Integer.MIN_VALUE) {
            write("-2147483648");
            return;
        }
        int n = i < 0 ? IOUtils.n(-i) + 1 : IOUtils.n(i);
        int i2 = this.c + n;
        if (i2 > this.b.length) {
            if (this.e == null) {
                i(i2);
            } else {
                char[] cArr = new char[n];
                IOUtils.i(i, n, cArr);
                write(cArr, 0, n);
                return;
            }
        }
        IOUtils.i(i, i2, this.b);
        this.c = i2;
    }

    public final void B(String str) {
        byte[] bArr = IOUtils.g;
        int length = str.length();
        boolean z = true;
        int i = this.c + length + 1;
        int i2 = 0;
        if (i > this.b.length) {
            if (this.e != null) {
                if (length == 0) {
                    write(39);
                    write(39);
                    write(58);
                    return;
                }
                int i3 = 0;
                while (true) {
                    if (i3 < length) {
                        char charAt = str.charAt(i3);
                        if (charAt < bArr.length && bArr[charAt] != 0) {
                            break;
                        }
                        i3++;
                    } else {
                        z = false;
                        break;
                    }
                }
                if (z) {
                    write(39);
                }
                while (i2 < length) {
                    char charAt2 = str.charAt(i2);
                    if (charAt2 < bArr.length && bArr[charAt2] != 0) {
                        write(92);
                        write(IOUtils.j[charAt2]);
                    } else {
                        write(charAt2);
                    }
                    i2++;
                }
                if (z) {
                    write(39);
                }
                write(58);
                return;
            }
            i(i);
        }
        if (length == 0) {
            int i4 = this.c;
            if (i4 + 3 > this.b.length) {
                i(i4 + 3);
            }
            char[] cArr = this.b;
            int i5 = this.c;
            int i6 = i5 + 1;
            this.c = i6;
            cArr[i5] = '\'';
            int i7 = i6 + 1;
            this.c = i7;
            cArr[i6] = '\'';
            this.c = i7 + 1;
            cArr[i7] = ':';
            return;
        }
        int i8 = this.c;
        int i9 = i8 + length;
        str.getChars(0, length, this.b, i8);
        this.c = i;
        int i10 = i8;
        boolean z2 = false;
        while (i10 < i9) {
            char[] cArr2 = this.b;
            char c = cArr2[i10];
            if (c < bArr.length && bArr[c] != 0) {
                if (!z2) {
                    i += 3;
                    if (i > cArr2.length) {
                        i(i);
                    }
                    this.c = i;
                    char[] cArr3 = this.b;
                    int i11 = i10 + 1;
                    System.arraycopy(cArr3, i11, cArr3, i10 + 3, (i9 - i10) - 1);
                    char[] cArr4 = this.b;
                    System.arraycopy(cArr4, i2, cArr4, 1, i10);
                    char[] cArr5 = this.b;
                    cArr5[i8] = '\'';
                    cArr5[i11] = '\\';
                    int i12 = i11 + 1;
                    cArr5[i12] = IOUtils.j[c];
                    i9 += 2;
                    cArr5[this.c - 2] = '\'';
                    i10 = i12;
                    z2 = true;
                } else {
                    i++;
                    if (i > cArr2.length) {
                        i(i);
                    }
                    this.c = i;
                    char[] cArr6 = this.b;
                    int i13 = i10 + 1;
                    System.arraycopy(cArr6, i13, cArr6, i10 + 2, i9 - i10);
                    char[] cArr7 = this.b;
                    cArr7[i10] = '\\';
                    cArr7[i13] = IOUtils.j[c];
                    i9++;
                    i10 = i13;
                }
            }
            i10++;
            i2 = 0;
        }
        this.b[i - 1] = ':';
    }

    public void C(long j) {
        boolean z = k(SerializerFeature.BrowserCompatible) && !k(SerializerFeature.WriteClassName) && (j > 9007199254740991L || j < -9007199254740991L);
        if (j == Long.MIN_VALUE) {
            if (z) {
                write("\"-9223372036854775808\"");
                return;
            } else {
                write("-9223372036854775808");
                return;
            }
        }
        int o = j < 0 ? IOUtils.o(-j) + 1 : IOUtils.o(j);
        int i = this.c + o;
        if (z) {
            i += 2;
        }
        if (i > this.b.length) {
            if (this.e == null) {
                i(i);
            } else {
                char[] cArr = new char[o];
                IOUtils.j(j, o, cArr);
                if (z) {
                    write(34);
                    write(cArr, 0, o);
                    write(34);
                    return;
                }
                write(cArr, 0, o);
                return;
            }
        }
        if (z) {
            char[] cArr2 = this.b;
            cArr2[this.c] = '\"';
            int i2 = i - 1;
            IOUtils.j(j, i2, cArr2);
            this.b[i2] = '\"';
        } else {
            IOUtils.j(j, i, this.b);
        }
        this.c = i;
    }

    public void D() {
        write("null");
    }

    public void E(int i, int i2) {
        if ((i & i2) == 0 && (this.d & i2) == 0) {
            D();
        } else if (i2 == SerializerFeature.WriteNullListAsEmpty.mask) {
            write("[]");
        } else if (i2 == SerializerFeature.WriteNullStringAsEmpty.mask) {
            G("");
        } else if (i2 == SerializerFeature.WriteNullBooleanAsFalse.mask) {
            write("false");
        } else if (i2 == SerializerFeature.WriteNullNumberAsZero.mask) {
            write(48);
        } else {
            D();
        }
    }

    public void F(SerializerFeature serializerFeature) {
        E(0, serializerFeature.mask);
    }

    public void G(String str) {
        if (this.f) {
            I(str);
        } else {
            H(str, (char) 0);
        }
    }

    /* JADX WARN: Code restructure failed: missing block: B:234:0x0409, code lost:
        if (r10 == (-1)) goto L271;
     */
    /* JADX WARN: Code restructure failed: missing block: B:237:0x0410, code lost:
        if (r10 == (-1)) goto L271;
     */
    /* JADX WARN: Code restructure failed: missing block: B:238:0x0412, code lost:
        r10 = r7;
        r17 = r10;
     */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public void H(String str, char c) {
        int i;
        if (str == null) {
            D();
            if (c != 0) {
                write(c);
                return;
            }
            return;
        }
        int length = str.length();
        int i2 = this.c + length + 2;
        if (c != 0) {
            i2++;
        }
        char c2 = '<';
        char c3 = 'a';
        if (i2 > this.b.length) {
            if (this.e != null) {
                write(34);
                int i3 = 0;
                while (i3 < str.length()) {
                    char charAt = str.charAt(i3);
                    if (k(SerializerFeature.BrowserSecure)) {
                        if (charAt == c2) {
                            write("&lt;");
                        } else if (charAt == '>') {
                            write("&gt;");
                        } else {
                            if ((charAt < '0' || charAt > '9') && ((charAt < 'a' || charAt > 'z') && ((charAt < 'A' || charAt > 'Z') && charAt != ',' && charAt != '.' && charAt != '_'))) {
                                write(92);
                                write(117);
                                char[] cArr = IOUtils.c;
                                write(cArr[(charAt >>> '\f') & 15]);
                                write(cArr[(charAt >>> '\b') & 15]);
                                write(cArr[(charAt >>> 4) & 15]);
                                write(cArr[charAt & 15]);
                            }
                            write(charAt);
                        }
                    } else if (!k(SerializerFeature.BrowserCompatible)) {
                        byte[] bArr = IOUtils.f;
                        if ((charAt < bArr.length && bArr[charAt] != 0) || (charAt == '/' && k(SerializerFeature.WriteSlashAsSpecial))) {
                            write(92);
                            if (bArr[charAt] == 4) {
                                write(117);
                                char[] cArr2 = IOUtils.c;
                                write(cArr2[(charAt >>> '\f') & 15]);
                                write(cArr2[(charAt >>> '\b') & 15]);
                                write(cArr2[(charAt >>> 4) & 15]);
                                write(cArr2[charAt & 15]);
                            } else {
                                write(IOUtils.j[charAt]);
                            }
                        }
                        write(charAt);
                    } else if (charAt == '\b' || charAt == '\f' || charAt == '\n' || charAt == '\r' || charAt == '\t' || charAt == '\"' || charAt == '/' || charAt == '\\') {
                        write(92);
                        write(IOUtils.j[charAt]);
                    } else if (charAt < ' ') {
                        write(92);
                        write(117);
                        write(48);
                        write(48);
                        char[] cArr3 = IOUtils.k;
                        int i4 = charAt * 2;
                        write(cArr3[i4]);
                        write(cArr3[i4 + 1]);
                    } else {
                        if (charAt >= 127) {
                            write(92);
                            write(117);
                            char[] cArr4 = IOUtils.c;
                            write(cArr4[(charAt >>> '\f') & 15]);
                            write(cArr4[(charAt >>> '\b') & 15]);
                            write(cArr4[(charAt >>> 4) & 15]);
                            write(cArr4[charAt & 15]);
                        }
                        write(charAt);
                    }
                    i3++;
                    c2 = '<';
                }
                write(34);
                if (c != 0) {
                    write(c);
                    return;
                }
                return;
            }
            i(i2);
        }
        int i5 = this.c;
        int i6 = i5 + 1;
        int i7 = i6 + length;
        char[] cArr5 = this.b;
        cArr5[i5] = '\"';
        int i8 = 0;
        str.getChars(0, length, cArr5, i6);
        this.c = i2;
        int i9 = -1;
        if (k(SerializerFeature.BrowserSecure)) {
            for (int i10 = i6; i10 < i7; i10++) {
                char c4 = this.b[i10];
                if ((c4 < '0' || c4 > '9') && ((c4 < 'a' || c4 > 'z') && ((c4 < 'A' || c4 > 'Z') && c4 != ',' && c4 != '.' && c4 != '_'))) {
                    i2 = (c4 == '<' || c4 == '>') ? i2 + 3 : i2 + 5;
                    i9 = i10;
                }
            }
            if (i2 > this.b.length) {
                i(i2);
            }
            this.c = i2;
            while (i9 >= i6) {
                char[] cArr6 = this.b;
                char c5 = cArr6[i9];
                if ((c5 < '0' || c5 > '9') && ((c5 < c3 || c5 > 'z') && ((c5 < 'A' || c5 > 'Z') && c5 != ',' && c5 != '.' && c5 != '_'))) {
                    if (c5 == '<') {
                        int i11 = i9 + 1;
                        System.arraycopy(cArr6, i11, cArr6, i9 + 4, (i7 - i9) - 1);
                        char[] cArr7 = this.b;
                        cArr7[i9] = '&';
                        cArr7[i11] = 'l';
                        cArr7[i9 + 2] = 't';
                        cArr7[i9 + 3] = ';';
                    } else if (c5 == '>') {
                        int i12 = i9 + 1;
                        System.arraycopy(cArr6, i12, cArr6, i9 + 4, (i7 - i9) - 1);
                        char[] cArr8 = this.b;
                        cArr8[i9] = '&';
                        cArr8[i12] = 'g';
                        cArr8[i9 + 2] = 't';
                        cArr8[i9 + 3] = ';';
                    } else {
                        int i13 = i9 + 1;
                        System.arraycopy(cArr6, i13, cArr6, i9 + 6, (i7 - i9) - 1);
                        char[] cArr9 = this.b;
                        cArr9[i9] = '\\';
                        cArr9[i13] = 'u';
                        char[] cArr10 = IOUtils.c;
                        cArr9[i9 + 2] = cArr10[(c5 >>> '\f') & 15];
                        cArr9[i9 + 3] = cArr10[(c5 >>> '\b') & 15];
                        cArr9[i9 + 4] = cArr10[(c5 >>> 4) & 15];
                        cArr9[i9 + 5] = cArr10[c5 & 15];
                        i7 += 5;
                    }
                    i7 += 3;
                }
                i9--;
                c3 = 'a';
            }
            if (c != 0) {
                char[] cArr11 = this.b;
                int i14 = this.c;
                cArr11[i14 - 2] = '\"';
                cArr11[i14 - 1] = c;
                return;
            }
            this.b[this.c - 1] = '\"';
        } else if (k(SerializerFeature.BrowserCompatible)) {
            for (int i15 = i6; i15 < i7; i15++) {
                char c6 = this.b[i15];
                if (c6 == '\"' || c6 == '/' || c6 == '\\' || c6 == '\b' || c6 == '\f' || c6 == '\n' || c6 == '\r' || c6 == '\t') {
                    i2++;
                } else if (c6 < ' ' || c6 >= 127) {
                    i2 += 5;
                }
                i9 = i15;
            }
            if (i2 > this.b.length) {
                i(i2);
            }
            this.c = i2;
            while (i9 >= i6) {
                char[] cArr12 = this.b;
                char c7 = cArr12[i9];
                if (c7 == '\b' || c7 == '\f' || c7 == '\n' || c7 == '\r' || c7 == '\t') {
                    int i16 = i9 + 1;
                    System.arraycopy(cArr12, i16, cArr12, i9 + 2, (i7 - i9) - 1);
                    char[] cArr13 = this.b;
                    cArr13[i9] = '\\';
                    cArr13[i16] = IOUtils.j[c7];
                } else if (c7 == '\"' || c7 == '/' || c7 == '\\') {
                    int i17 = i9 + 1;
                    System.arraycopy(cArr12, i17, cArr12, i9 + 2, (i7 - i9) - 1);
                    char[] cArr14 = this.b;
                    cArr14[i9] = '\\';
                    cArr14[i17] = c7;
                } else {
                    if (c7 < ' ') {
                        int i18 = i9 + 1;
                        System.arraycopy(cArr12, i18, cArr12, i9 + 6, (i7 - i9) - 1);
                        char[] cArr15 = this.b;
                        cArr15[i9] = '\\';
                        cArr15[i18] = 'u';
                        cArr15[i9 + 2] = '0';
                        cArr15[i9 + 3] = '0';
                        char[] cArr16 = IOUtils.k;
                        int i19 = c7 * 2;
                        cArr15[i9 + 4] = cArr16[i19];
                        cArr15[i9 + 5] = cArr16[i19 + 1];
                    } else if (c7 >= 127) {
                        int i20 = i9 + 1;
                        System.arraycopy(cArr12, i20, cArr12, i9 + 6, (i7 - i9) - 1);
                        char[] cArr17 = this.b;
                        cArr17[i9] = '\\';
                        cArr17[i20] = 'u';
                        char[] cArr18 = IOUtils.c;
                        cArr17[i9 + 2] = cArr18[(c7 >>> '\f') & 15];
                        cArr17[i9 + 3] = cArr18[(c7 >>> '\b') & 15];
                        cArr17[i9 + 4] = cArr18[(c7 >>> 4) & 15];
                        cArr17[i9 + 5] = cArr18[c7 & 15];
                    } else {
                        i9--;
                    }
                    i7 += 5;
                    i9--;
                }
                i7++;
                i9--;
            }
            if (c != 0) {
                char[] cArr19 = this.b;
                int i21 = this.c;
                cArr19[i21 - 2] = '\"';
                cArr19[i21 - 1] = c;
                return;
            }
            this.b[this.c - 1] = '\"';
        } else {
            char c8 = 0;
            int i22 = i6;
            int i23 = -1;
            int i24 = -1;
            while (i22 < i7) {
                char c9 = this.b[i22];
                if (c9 == 8232 || c9 == 8233) {
                    i8++;
                    i2 += 4;
                } else if (c9 >= ']') {
                    if (c9 >= 127 && c9 < 160) {
                        if (i23 == -1) {
                            i23 = i22;
                        }
                        i8++;
                        i2 += 4;
                        i24 = i22;
                    }
                    i22++;
                } else if (l(c9, this.d)) {
                    i8++;
                    byte[] bArr2 = IOUtils.f;
                    if (c9 < bArr2.length && bArr2[c9] == 4) {
                        i2 += 4;
                    }
                } else {
                    i22++;
                }
                c8 = c9;
                i22++;
            }
            if (i8 > 0) {
                int i25 = i2 + i8;
                if (i25 > this.b.length) {
                    i(i25);
                }
                this.c = i25;
                if (i8 == 1) {
                    if (c8 == 8232) {
                        int i26 = i24 + 1;
                        char[] cArr20 = this.b;
                        System.arraycopy(cArr20, i26, cArr20, i24 + 6, (i7 - i24) - 1);
                        char[] cArr21 = this.b;
                        cArr21[i24] = '\\';
                        cArr21[i26] = 'u';
                        int i27 = i26 + 1;
                        cArr21[i27] = '2';
                        int i28 = i27 + 1;
                        cArr21[i28] = '0';
                        int i29 = i28 + 1;
                        cArr21[i29] = '2';
                        cArr21[i29 + 1] = '8';
                    } else if (c8 == 8233) {
                        int i30 = i24 + 1;
                        char[] cArr22 = this.b;
                        System.arraycopy(cArr22, i30, cArr22, i24 + 6, (i7 - i24) - 1);
                        char[] cArr23 = this.b;
                        cArr23[i24] = '\\';
                        cArr23[i30] = 'u';
                        int i31 = i30 + 1;
                        cArr23[i31] = '2';
                        int i32 = i31 + 1;
                        cArr23[i32] = '0';
                        int i33 = i32 + 1;
                        cArr23[i33] = '2';
                        cArr23[i33 + 1] = '9';
                    } else {
                        byte[] bArr3 = IOUtils.f;
                        if (c8 < bArr3.length && bArr3[c8] == 4) {
                            int i34 = i24 + 1;
                            char[] cArr24 = this.b;
                            System.arraycopy(cArr24, i34, cArr24, i24 + 6, (i7 - i24) - 1);
                            char[] cArr25 = this.b;
                            cArr25[i24] = '\\';
                            int i35 = i34 + 1;
                            cArr25[i34] = 'u';
                            int i36 = i35 + 1;
                            char[] cArr26 = IOUtils.c;
                            cArr25[i35] = cArr26[(c8 >>> '\f') & 15];
                            int i37 = i36 + 1;
                            cArr25[i36] = cArr26[(c8 >>> '\b') & 15];
                            cArr25[i37] = cArr26[(c8 >>> 4) & 15];
                            cArr25[i37 + 1] = cArr26[c8 & 15];
                        } else {
                            int i38 = i24 + 1;
                            char[] cArr27 = this.b;
                            System.arraycopy(cArr27, i38, cArr27, i24 + 2, (i7 - i24) - 1);
                            char[] cArr28 = this.b;
                            cArr28[i24] = '\\';
                            cArr28[i38] = IOUtils.j[c8];
                        }
                    }
                } else if (i8 > 1) {
                    for (int i39 = i23 - i6; i39 < str.length(); i39++) {
                        char charAt2 = str.charAt(i39);
                        byte[] bArr4 = IOUtils.f;
                        if ((charAt2 >= bArr4.length || bArr4[charAt2] == 0) && (charAt2 != '/' || !k(SerializerFeature.WriteSlashAsSpecial))) {
                            if (charAt2 != 8232 && charAt2 != 8233) {
                                this.b[i23] = charAt2;
                                i23++;
                            } else {
                                char[] cArr29 = this.b;
                                int i40 = i23 + 1;
                                cArr29[i23] = '\\';
                                int i41 = i40 + 1;
                                cArr29[i40] = 'u';
                                int i42 = i41 + 1;
                                char[] cArr30 = IOUtils.c;
                                cArr29[i41] = cArr30[(charAt2 >>> '\f') & 15];
                                int i43 = i42 + 1;
                                cArr29[i42] = cArr30[(charAt2 >>> '\b') & 15];
                                int i44 = i43 + 1;
                                cArr29[i43] = cArr30[(charAt2 >>> 4) & 15];
                                i23 = i44 + 1;
                                cArr29[i44] = cArr30[charAt2 & 15];
                            }
                        }
                        char[] cArr31 = this.b;
                        int i45 = i23 + 1;
                        cArr31[i23] = '\\';
                        if (bArr4[charAt2] == 4) {
                            int i46 = i45 + 1;
                            cArr31[i45] = 'u';
                            int i47 = i46 + 1;
                            char[] cArr32 = IOUtils.c;
                            cArr31[i46] = cArr32[(charAt2 >>> '\f') & 15];
                            int i48 = i47 + 1;
                            cArr31[i47] = cArr32[(charAt2 >>> '\b') & 15];
                            int i49 = i48 + 1;
                            cArr31[i48] = cArr32[(charAt2 >>> 4) & 15];
                            i = i49 + 1;
                            cArr31[i49] = cArr32[charAt2 & 15];
                        } else {
                            i = i45 + 1;
                            cArr31[i45] = IOUtils.j[charAt2];
                        }
                        i23 = i;
                    }
                }
            }
            if (c != 0) {
                char[] cArr33 = this.b;
                int i50 = this.c;
                cArr33[i50 - 2] = '\"';
                cArr33[i50 - 1] = c;
                return;
            }
            this.b[this.c - 1] = '\"';
        }
    }

    public void I(String str) {
        int i = 0;
        if (str == null) {
            int i2 = this.c + 4;
            if (i2 > this.b.length) {
                i(i2);
            }
            "null".getChars(0, 4, this.b, this.c);
            this.c = i2;
            return;
        }
        int length = str.length();
        int i3 = this.c + length + 2;
        if (i3 > this.b.length) {
            if (this.e != null) {
                write(39);
                while (i < str.length()) {
                    char charAt = str.charAt(i);
                    if (charAt > '\r' && charAt != '\\' && charAt != '\'' && (charAt != '/' || !k(SerializerFeature.WriteSlashAsSpecial))) {
                        write(charAt);
                    } else {
                        write(92);
                        write(IOUtils.j[charAt]);
                    }
                    i++;
                }
                write(39);
                return;
            }
            i(i3);
        }
        int i4 = this.c;
        int i5 = i4 + 1;
        int i6 = i5 + length;
        char[] cArr = this.b;
        cArr[i4] = '\'';
        str.getChars(0, length, cArr, i5);
        this.c = i3;
        int i7 = -1;
        char c = 0;
        for (int i8 = i5; i8 < i6; i8++) {
            char c2 = this.b[i8];
            if (c2 <= '\r' || c2 == '\\' || c2 == '\'' || (c2 == '/' && k(SerializerFeature.WriteSlashAsSpecial))) {
                i++;
                i7 = i8;
                c = c2;
            }
        }
        int i9 = i3 + i;
        if (i9 > this.b.length) {
            i(i9);
        }
        this.c = i9;
        if (i == 1) {
            char[] cArr2 = this.b;
            int i10 = i7 + 1;
            System.arraycopy(cArr2, i10, cArr2, i7 + 2, (i6 - i7) - 1);
            char[] cArr3 = this.b;
            cArr3[i7] = '\\';
            cArr3[i10] = IOUtils.j[c];
        } else if (i > 1) {
            char[] cArr4 = this.b;
            int i11 = i7 + 1;
            System.arraycopy(cArr4, i11, cArr4, i7 + 2, (i6 - i7) - 1);
            char[] cArr5 = this.b;
            cArr5[i7] = '\\';
            cArr5[i11] = IOUtils.j[c];
            int i12 = i6 + 1;
            for (int i13 = i11 - 2; i13 >= i5; i13--) {
                char c3 = this.b[i13];
                if (c3 <= '\r' || c3 == '\\' || c3 == '\'' || (c3 == '/' && k(SerializerFeature.WriteSlashAsSpecial))) {
                    char[] cArr6 = this.b;
                    int i14 = i13 + 1;
                    System.arraycopy(cArr6, i14, cArr6, i13 + 2, (i12 - i13) - 1);
                    char[] cArr7 = this.b;
                    cArr7[i13] = '\\';
                    cArr7[i14] = IOUtils.j[c3];
                    i12++;
                }
            }
        }
        this.b[this.c - 1] = '\'';
    }

    public int J(OutputStream outputStream, Charset charset) throws IOException {
        if (this.e == null) {
            if (charset == r) {
                return g(outputStream);
            }
            byte[] bytes = new String(this.b, 0, this.c).getBytes(charset);
            outputStream.write(bytes);
            return bytes.length;
        }
        throw new UnsupportedOperationException("writer not null");
    }

    @Override // java.io.Writer, java.lang.Appendable
    /* renamed from: a */
    public SerializeWriter append(char c) {
        write(c);
        return this;
    }

    @Override // java.io.Writer, java.lang.Appendable
    /* renamed from: c */
    public SerializeWriter append(CharSequence charSequence) {
        String charSequence2 = charSequence == null ? "null" : charSequence.toString();
        write(charSequence2, 0, charSequence2.length());
        return this;
    }

    @Override // java.io.Writer, java.io.Closeable, java.lang.AutoCloseable
    public void close() {
        if (this.e != null && this.c > 0) {
            flush();
        }
        char[] cArr = this.b;
        if (cArr.length <= 65536) {
            s.set(cArr);
        }
        this.b = null;
    }

    @Override // java.io.Writer, java.lang.Appendable
    /* renamed from: d */
    public SerializeWriter append(CharSequence charSequence, int i, int i2) {
        if (charSequence == null) {
            charSequence = "null";
        }
        String charSequence2 = charSequence.subSequence(i, i2).toString();
        write(charSequence2, 0, charSequence2.length());
        return this;
    }

    public void e() {
        int i = this.d;
        boolean z = true;
        boolean z2 = (SerializerFeature.QuoteFieldNames.mask & i) != 0;
        this.g = z2;
        boolean z3 = (SerializerFeature.UseSingleQuotes.mask & i) != 0;
        this.f = z3;
        this.h = (SerializerFeature.SortField.mask & i) != 0;
        this.i = (SerializerFeature.DisableCircularReferenceDetect.mask & i) != 0;
        boolean z4 = (SerializerFeature.BeanToArray.mask & i) != 0;
        this.j = z4;
        this.k = (SerializerFeature.WriteNonStringValueAsString.mask & i) != 0;
        this.l = (SerializerFeature.NotWriteDefaultValue.mask & i) != 0;
        boolean z5 = (SerializerFeature.WriteEnumUsingName.mask & i) != 0;
        this.m = z5;
        this.n = (SerializerFeature.WriteEnumUsingToString.mask & i) != 0;
        if (!z2 || (i & u) != 0 || (!z4 && !z5)) {
            z = false;
        }
        this.o = z;
        this.p = z3 ? '\'' : '\"';
    }

    public void f(SerializerFeature serializerFeature, boolean z) {
        if (z) {
            int mask = this.d | serializerFeature.getMask();
            this.d = mask;
            SerializerFeature serializerFeature2 = SerializerFeature.WriteEnumUsingToString;
            if (serializerFeature == serializerFeature2) {
                this.d = (~SerializerFeature.WriteEnumUsingName.getMask()) & mask;
            } else if (serializerFeature == SerializerFeature.WriteEnumUsingName) {
                this.d = (~serializerFeature2.getMask()) & mask;
            }
        } else {
            this.d = (~serializerFeature.getMask()) & this.d;
        }
        e();
    }

    @Override // java.io.Writer, java.io.Flushable
    public void flush() {
        Writer writer = this.e;
        if (writer == null) {
            return;
        }
        try {
            writer.write(this.b, 0, this.c);
            this.e.flush();
            this.c = 0;
        } catch (IOException e) {
            throw new JSONException(e.getMessage(), e);
        }
    }

    public final int g(OutputStream outputStream) throws IOException {
        int i = (int) (this.c * 3.0d);
        ThreadLocal<byte[]> threadLocal = t;
        byte[] bArr = threadLocal.get();
        if (bArr == null) {
            bArr = new byte[8192];
            threadLocal.set(bArr);
        }
        if (bArr.length < i) {
            bArr = new byte[i];
        }
        int g = IOUtils.g(this.b, 0, this.c, bArr);
        outputStream.write(bArr, 0, g);
        return g;
    }

    public final byte[] h() {
        int i = (int) (this.c * 3.0d);
        ThreadLocal<byte[]> threadLocal = t;
        byte[] bArr = threadLocal.get();
        if (bArr == null) {
            bArr = new byte[8192];
            threadLocal.set(bArr);
        }
        if (bArr.length < i) {
            bArr = new byte[i];
        }
        int g = IOUtils.g(this.b, 0, this.c, bArr);
        byte[] bArr2 = new byte[g];
        System.arraycopy(bArr, 0, bArr2, 0, g);
        return bArr2;
    }

    public void i(int i) {
        int i2 = this.q;
        if (i2 != -1 && i >= i2) {
            throw new JSONException("serialize exceeded MAX_OUTPUT_LENGTH=" + this.q + ", minimumCapacity=" + i);
        }
        char[] cArr = this.b;
        int length = ((cArr.length * 3) / 2) + 1;
        if (length >= i) {
            i = length;
        }
        char[] cArr2 = new char[i];
        System.arraycopy(cArr, 0, cArr2, 0, this.c);
        this.b = cArr2;
    }

    public boolean j(int i) {
        return (i & this.d) != 0;
    }

    public boolean k(SerializerFeature serializerFeature) {
        return (serializerFeature.mask & this.d) != 0;
    }

    public byte[] m(Charset charset) {
        if (this.e == null) {
            if (charset == r) {
                return h();
            }
            return new String(this.b, 0, this.c).getBytes(charset);
        }
        throw new UnsupportedOperationException("writer not null");
    }

    public void n(boolean z) {
        if (z) {
            write("true");
        } else {
            write("false");
        }
    }

    public void o(byte[] bArr) {
        if (j(SerializerFeature.WriteClassName.mask)) {
            z(bArr);
            return;
        }
        int length = bArr.length;
        boolean z = this.f;
        char c = z ? '\'' : '\"';
        if (length == 0) {
            write(z ? "''" : "\"\"");
            return;
        }
        char[] cArr = IOUtils.p;
        int i = (length / 3) * 3;
        int i2 = length - 1;
        int i3 = this.c;
        int i4 = (((i2 / 3) + 1) << 2) + i3 + 2;
        if (i4 > this.b.length) {
            if (this.e != null) {
                write(c);
                int i5 = 0;
                while (i5 < i) {
                    int i6 = i5 + 1;
                    int i7 = i6 + 1;
                    int i8 = ((bArr[i5] & 255) << 16) | ((bArr[i6] & 255) << 8) | (bArr[i7] & 255);
                    write(cArr[(i8 >>> 18) & 63]);
                    write(cArr[(i8 >>> 12) & 63]);
                    write(cArr[(i8 >>> 6) & 63]);
                    write(cArr[i8 & 63]);
                    i5 = i7 + 1;
                }
                int i9 = length - i;
                if (i9 > 0) {
                    int i10 = ((bArr[i] & 255) << 10) | (i9 == 2 ? (bArr[i2] & 255) << 2 : 0);
                    write(cArr[i10 >> 12]);
                    write(cArr[(i10 >>> 6) & 63]);
                    write(i9 == 2 ? cArr[i10 & 63] : '=');
                    write(61);
                }
                write(c);
                return;
            }
            i(i4);
        }
        this.c = i4;
        int i11 = i3 + 1;
        this.b[i3] = c;
        int i12 = 0;
        while (i12 < i) {
            int i13 = i12 + 1;
            int i14 = i13 + 1;
            int i15 = ((bArr[i12] & 255) << 16) | ((bArr[i13] & 255) << 8);
            int i16 = i14 + 1;
            int i17 = i15 | (bArr[i14] & 255);
            char[] cArr2 = this.b;
            int i18 = i11 + 1;
            cArr2[i11] = cArr[(i17 >>> 18) & 63];
            int i19 = i18 + 1;
            cArr2[i18] = cArr[(i17 >>> 12) & 63];
            int i20 = i19 + 1;
            cArr2[i19] = cArr[(i17 >>> 6) & 63];
            i11 = i20 + 1;
            cArr2[i20] = cArr[i17 & 63];
            i12 = i16;
        }
        int i21 = length - i;
        if (i21 > 0) {
            int i22 = ((bArr[i] & 255) << 10) | (i21 == 2 ? (bArr[i2] & 255) << 2 : 0);
            char[] cArr3 = this.b;
            cArr3[i4 - 5] = cArr[i22 >> 12];
            cArr3[i4 - 4] = cArr[(i22 >>> 6) & 63];
            cArr3[i4 - 3] = i21 == 2 ? cArr[i22 & 63] : '=';
            cArr3[i4 - 2] = '=';
        }
        this.b[i4 - 1] = c;
    }

    public void p(double d, boolean z) {
        if (!Double.isNaN(d) && !Double.isInfinite(d)) {
            String d2 = Double.toString(d);
            if (k(SerializerFeature.WriteNullNumberAsZero) && d2.endsWith(".0")) {
                d2 = d2.substring(0, d2.length() - 2);
            }
            write(d2);
            if (z && k(SerializerFeature.WriteClassName)) {
                write(68);
                return;
            }
            return;
        }
        D();
    }

    public void q(Enum<?> r3) {
        if (r3 == null) {
            D();
            return;
        }
        String str = null;
        if (this.m && !this.n) {
            str = r3.name();
        } else if (this.n) {
            str = r3.toString();
        }
        if (str != null) {
            int i = k(SerializerFeature.UseSingleQuotes) ? 39 : 34;
            write(i);
            write(str);
            write(i);
            return;
        }
        A(r3.ordinal());
    }

    public void r(String str) {
        s(str, false);
    }

    public void s(String str, boolean z) {
        if (str == null) {
            write("null:");
        } else if (this.f) {
            if (this.g) {
                I(str);
                write(58);
                return;
            }
            B(str);
        } else if (this.g) {
            H(str, ':');
        } else {
            boolean z2 = true;
            boolean z3 = str.length() == 0;
            int i = 0;
            while (true) {
                if (i >= str.length()) {
                    z2 = z3;
                    break;
                } else if (l(str.charAt(i), 0)) {
                    break;
                } else {
                    i++;
                }
            }
            if (z2) {
                H(str, ':');
                return;
            }
            write(str);
            write(58);
        }
    }

    public void t(char c, String str, double d) {
        write(c);
        r(str);
        p(d, false);
    }

    public String toString() {
        return new String(this.b, 0, this.c);
    }

    public void u(char c, String str, int i) {
        if (i != Integer.MIN_VALUE && this.g) {
            int n = i < 0 ? IOUtils.n(-i) + 1 : IOUtils.n(i);
            int length = str.length();
            int i2 = this.c + length + 4 + n;
            if (i2 > this.b.length) {
                if (this.e != null) {
                    write(c);
                    r(str);
                    A(i);
                    return;
                }
                i(i2);
            }
            int i3 = this.c;
            this.c = i2;
            char[] cArr = this.b;
            cArr[i3] = c;
            int i4 = i3 + length + 1;
            cArr[i3 + 1] = this.p;
            str.getChars(0, length, cArr, i3 + 2);
            char[] cArr2 = this.b;
            cArr2[i4 + 1] = this.p;
            cArr2[i4 + 2] = ':';
            IOUtils.i(i, this.c, cArr2);
            return;
        }
        write(c);
        r(str);
        A(i);
    }

    public void v(char c, String str, long j) {
        if (j != Long.MIN_VALUE && this.g) {
            int o = j < 0 ? IOUtils.o(-j) + 1 : IOUtils.o(j);
            int length = str.length();
            int i = this.c + length + 4 + o;
            if (i > this.b.length) {
                if (this.e != null) {
                    write(c);
                    r(str);
                    C(j);
                    return;
                }
                i(i);
            }
            int i2 = this.c;
            this.c = i;
            char[] cArr = this.b;
            cArr[i2] = c;
            int i3 = i2 + length + 1;
            cArr[i2 + 1] = this.p;
            str.getChars(0, length, cArr, i2 + 2);
            char[] cArr2 = this.b;
            cArr2[i3 + 1] = this.p;
            cArr2[i3 + 2] = ':';
            IOUtils.j(j, this.c, cArr2);
            return;
        }
        write(c);
        r(str);
        C(j);
    }

    public void w(char c, String str, String str2) {
        if (this.g) {
            if (this.f) {
                write(c);
                r(str);
                if (str2 == null) {
                    D();
                    return;
                } else {
                    G(str2);
                    return;
                }
            } else if (k(SerializerFeature.BrowserSecure)) {
                write(c);
                H(str, ':');
                H(str2, (char) 0);
                return;
            } else if (k(SerializerFeature.BrowserCompatible)) {
                write(c);
                H(str, ':');
                H(str2, (char) 0);
                return;
            } else {
                x(c, str, str2);
                return;
            }
        }
        write(c);
        r(str);
        if (str2 == null) {
            D();
        } else {
            G(str2);
        }
    }

    @Override // java.io.Writer
    public void write(int i) {
        int i2 = 1;
        int i3 = this.c + 1;
        if (i3 > this.b.length) {
            if (this.e == null) {
                i(i3);
            } else {
                flush();
                this.b[this.c] = (char) i;
                this.c = i2;
            }
        }
        i2 = i3;
        this.b[this.c] = (char) i;
        this.c = i2;
    }

    public void x(char c, String str, String str2) {
        int length;
        int i;
        int i2;
        int length2 = str.length();
        int i3 = this.c;
        if (str2 == null) {
            i = i3 + length2 + 8;
            length = 4;
        } else {
            length = str2.length();
            i = i3 + length2 + length + 6;
        }
        int i4 = 0;
        if (i > this.b.length) {
            if (this.e != null) {
                write(c);
                H(str, ':');
                H(str2, (char) 0);
                return;
            }
            i(i);
        }
        char[] cArr = this.b;
        int i5 = this.c;
        cArr[i5] = c;
        int i6 = i5 + 2;
        int i7 = i6 + length2;
        cArr[i5 + 1] = '\"';
        str.getChars(0, length2, cArr, i6);
        this.c = i;
        char[] cArr2 = this.b;
        cArr2[i7] = '\"';
        int i8 = i7 + 1;
        int i9 = i8 + 1;
        cArr2[i8] = ':';
        if (str2 == null) {
            int i10 = i9 + 1;
            cArr2[i9] = 'n';
            int i11 = i10 + 1;
            cArr2[i10] = 'u';
            cArr2[i11] = 'l';
            cArr2[i11 + 1] = 'l';
            return;
        }
        int i12 = i9 + 1;
        cArr2[i9] = '\"';
        int i13 = i12 + length;
        str2.getChars(0, length, cArr2, i12);
        int i14 = -1;
        int i15 = -1;
        char c2 = 0;
        for (int i16 = i12; i16 < i13; i16++) {
            char c3 = this.b[i16];
            if (c3 >= ']') {
                if (c3 >= 127 && (c3 == 8232 || c3 == 8233 || c3 < 160)) {
                    if (i14 == -1) {
                        i14 = i16;
                    }
                    i4++;
                    i += 4;
                    c2 = c3;
                    i15 = i16;
                }
            } else if (l(c3, this.d)) {
                i4++;
                byte[] bArr = IOUtils.f;
                if (c3 < bArr.length && bArr[c3] == 4) {
                    i += 4;
                }
                c2 = c3;
                if (i14 == -1) {
                    i14 = i16;
                    i15 = i14;
                }
                i15 = i16;
            }
        }
        if (i4 > 0) {
            int i17 = i + i4;
            if (i17 > this.b.length) {
                i(i17);
            }
            this.c = i17;
            if (i4 == 1) {
                if (c2 == 8232) {
                    int i18 = i15 + 1;
                    char[] cArr3 = this.b;
                    System.arraycopy(cArr3, i18, cArr3, i15 + 6, (i13 - i15) - 1);
                    char[] cArr4 = this.b;
                    cArr4[i15] = '\\';
                    cArr4[i18] = 'u';
                    int i19 = i18 + 1;
                    cArr4[i19] = '2';
                    int i20 = i19 + 1;
                    cArr4[i20] = '0';
                    int i21 = i20 + 1;
                    cArr4[i21] = '2';
                    cArr4[i21 + 1] = '8';
                } else if (c2 == 8233) {
                    int i22 = i15 + 1;
                    char[] cArr5 = this.b;
                    System.arraycopy(cArr5, i22, cArr5, i15 + 6, (i13 - i15) - 1);
                    char[] cArr6 = this.b;
                    cArr6[i15] = '\\';
                    cArr6[i22] = 'u';
                    int i23 = i22 + 1;
                    cArr6[i23] = '2';
                    int i24 = i23 + 1;
                    cArr6[i24] = '0';
                    int i25 = i24 + 1;
                    cArr6[i25] = '2';
                    cArr6[i25 + 1] = '9';
                } else {
                    byte[] bArr2 = IOUtils.f;
                    if (c2 < bArr2.length && bArr2[c2] == 4) {
                        int i26 = i15 + 1;
                        char[] cArr7 = this.b;
                        System.arraycopy(cArr7, i26, cArr7, i15 + 6, (i13 - i15) - 1);
                        char[] cArr8 = this.b;
                        cArr8[i15] = '\\';
                        int i27 = i26 + 1;
                        cArr8[i26] = 'u';
                        int i28 = i27 + 1;
                        char[] cArr9 = IOUtils.c;
                        cArr8[i27] = cArr9[(c2 >>> '\f') & 15];
                        int i29 = i28 + 1;
                        cArr8[i28] = cArr9[(c2 >>> '\b') & 15];
                        cArr8[i29] = cArr9[(c2 >>> 4) & 15];
                        cArr8[i29 + 1] = cArr9[c2 & 15];
                    } else {
                        int i30 = i15 + 1;
                        char[] cArr10 = this.b;
                        System.arraycopy(cArr10, i30, cArr10, i15 + 2, (i13 - i15) - 1);
                        char[] cArr11 = this.b;
                        cArr11[i15] = '\\';
                        cArr11[i30] = IOUtils.j[c2];
                    }
                }
            } else if (i4 > 1) {
                for (int i31 = i14 - i12; i31 < str2.length(); i31++) {
                    char charAt = str2.charAt(i31);
                    byte[] bArr3 = IOUtils.f;
                    if ((charAt < bArr3.length && bArr3[charAt] != 0) || (charAt == '/' && k(SerializerFeature.WriteSlashAsSpecial))) {
                        char[] cArr12 = this.b;
                        int i32 = i14 + 1;
                        cArr12[i14] = '\\';
                        if (bArr3[charAt] == 4) {
                            int i33 = i32 + 1;
                            cArr12[i32] = 'u';
                            int i34 = i33 + 1;
                            char[] cArr13 = IOUtils.c;
                            cArr12[i33] = cArr13[(charAt >>> '\f') & 15];
                            int i35 = i34 + 1;
                            cArr12[i34] = cArr13[(charAt >>> '\b') & 15];
                            int i36 = i35 + 1;
                            cArr12[i35] = cArr13[(charAt >>> 4) & 15];
                            i2 = i36 + 1;
                            cArr12[i36] = cArr13[charAt & 15];
                        } else {
                            i2 = i32 + 1;
                            cArr12[i32] = IOUtils.j[charAt];
                        }
                        i14 = i2;
                    } else if (charAt != 8232 && charAt != 8233) {
                        this.b[i14] = charAt;
                        i14++;
                    } else {
                        char[] cArr14 = this.b;
                        int i37 = i14 + 1;
                        cArr14[i14] = '\\';
                        int i38 = i37 + 1;
                        cArr14[i37] = 'u';
                        int i39 = i38 + 1;
                        char[] cArr15 = IOUtils.c;
                        cArr14[i38] = cArr15[(charAt >>> '\f') & 15];
                        int i40 = i39 + 1;
                        cArr14[i39] = cArr15[(charAt >>> '\b') & 15];
                        int i41 = i40 + 1;
                        cArr14[i40] = cArr15[(charAt >>> 4) & 15];
                        cArr14[i41] = cArr15[charAt & 15];
                        i14 = i41 + 1;
                    }
                }
            }
        }
        this.b[this.c - 1] = '\"';
    }

    public void y(float f, boolean z) {
        if (!Float.isNaN(f) && !Float.isInfinite(f)) {
            String f2 = Float.toString(f);
            if (k(SerializerFeature.WriteNullNumberAsZero) && f2.endsWith(".0")) {
                f2 = f2.substring(0, f2.length() - 2);
            }
            write(f2);
            if (z && k(SerializerFeature.WriteClassName)) {
                write(70);
                return;
            }
            return;
        }
        D();
    }

    public void z(byte[] bArr) {
        int i = 2;
        int length = this.c + (bArr.length * 2) + 3;
        int i2 = 0;
        if (length > this.b.length) {
            if (this.e != null) {
                char[] cArr = new char[bArr.length + 3];
                cArr[0] = 'x';
                cArr[1] = '\'';
                while (i2 < bArr.length) {
                    int i3 = bArr[i2] & 255;
                    int i4 = i3 >> 4;
                    int i5 = i3 & 15;
                    int i6 = i + 1;
                    cArr[i] = (char) (i4 + (i4 < 10 ? 48 : 55));
                    i = i6 + 1;
                    cArr[i6] = (char) (i5 + (i5 < 10 ? 48 : 55));
                    i2++;
                }
                cArr[i] = '\'';
                try {
                    this.e.write(cArr);
                    return;
                } catch (IOException e) {
                    throw new JSONException("writeBytes error.", e);
                }
            }
            i(length);
        }
        char[] cArr2 = this.b;
        int i7 = this.c;
        int i8 = i7 + 1;
        this.c = i8;
        cArr2[i7] = 'x';
        this.c = i8 + 1;
        cArr2[i8] = '\'';
        while (i2 < bArr.length) {
            int i9 = bArr[i2] & 255;
            int i10 = i9 >> 4;
            int i11 = i9 & 15;
            char[] cArr3 = this.b;
            int i12 = this.c;
            int i13 = i12 + 1;
            this.c = i13;
            cArr3[i12] = (char) (i10 + (i10 < 10 ? 48 : 55));
            this.c = i13 + 1;
            cArr3[i13] = (char) (i11 + (i11 < 10 ? 48 : 55));
            i2++;
        }
        char[] cArr4 = this.b;
        int i14 = this.c;
        this.c = i14 + 1;
        cArr4[i14] = '\'';
    }

    public SerializeWriter(Writer writer) {
        this(writer, JSON.DEFAULT_GENERATE_FEATURE, SerializerFeature.EMPTY);
    }

    public SerializeWriter(Writer writer, int i, SerializerFeature... serializerFeatureArr) {
        this.q = -1;
        this.e = writer;
        ThreadLocal<char[]> threadLocal = s;
        char[] cArr = threadLocal.get();
        this.b = cArr;
        if (cArr != null) {
            threadLocal.set(null);
        } else {
            this.b = new char[2048];
        }
        for (SerializerFeature serializerFeature : serializerFeatureArr) {
            i |= serializerFeature.getMask();
        }
        this.d = i;
        e();
    }

    @Override // java.io.Writer
    public void write(char[] cArr, int i, int i2) {
        int i3;
        if (i < 0 || i > cArr.length || i2 < 0 || (i3 = i + i2) > cArr.length || i3 < 0) {
            throw new IndexOutOfBoundsException();
        }
        if (i2 == 0) {
            return;
        }
        int i4 = this.c + i2;
        if (i4 > this.b.length) {
            if (this.e == null) {
                i(i4);
            } else {
                do {
                    char[] cArr2 = this.b;
                    int length = cArr2.length;
                    int i5 = this.c;
                    int i6 = length - i5;
                    System.arraycopy(cArr, i, cArr2, i5, i6);
                    this.c = this.b.length;
                    flush();
                    i2 -= i6;
                    i += i6;
                } while (i2 > this.b.length);
                i4 = i2;
            }
        }
        System.arraycopy(cArr, i, this.b, this.c, i2);
        this.c = i4;
    }

    @Override // java.io.Writer
    public void write(String str, int i, int i2) {
        int i3;
        int i4 = this.c + i2;
        if (i4 > this.b.length) {
            if (this.e == null) {
                i(i4);
            } else {
                while (true) {
                    char[] cArr = this.b;
                    int length = cArr.length;
                    int i5 = this.c;
                    int i6 = length - i5;
                    i3 = i + i6;
                    str.getChars(i, i3, cArr, i5);
                    this.c = this.b.length;
                    flush();
                    i2 -= i6;
                    if (i2 <= this.b.length) {
                        break;
                    }
                    i = i3;
                }
                i4 = i2;
                i = i3;
            }
        }
        str.getChars(i, i2 + i, this.b, this.c);
        this.c = i4;
    }

    @Override // java.io.Writer
    public void write(String str) {
        if (str == null) {
            D();
        } else {
            write(str, 0, str.length());
        }
    }
}
