package com.alibaba.fastjson.util;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.PropertyNamingStrategy;
import com.alibaba.fastjson.parser.Feature;
import com.alibaba.fastjson.parser.ParserConfig;
import com.alibaba.fastjson.serializer.CalendarCodec;
import com.alibaba.fastjson.serializer.SerializerFeature;
import h1.b;
import h1.d;
import j1.e;
import java.lang.annotation.Annotation;
import java.lang.reflect.AccessibleObject;
import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Proxy;
import java.lang.reflect.Type;
import java.lang.reflect.TypeVariable;
import java.lang.reflect.WildcardType;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.security.AccessControlException;
import java.sql.Time;
import java.sql.Timestamp;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.AbstractCollection;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.Currency;
import java.util.Date;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.UUID;
import java.util.WeakHashMap;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.concurrent.atomic.AtomicLong;
import k1.k;
import k1.l;
import l1.o;
import m1.a;
/* loaded from: classes.dex */
public class TypeUtils {
    public static boolean a = false;
    public static boolean b = false;
    public static boolean c = true;
    public static boolean d;
    public static Method e;
    public static boolean f;
    public static Method g;
    public static boolean h;
    public static Class<?> i;
    public static boolean j;
    public static Class<? extends Annotation> k;
    public static Class<? extends Annotation> l;
    public static boolean m;
    public static Method n;
    public static boolean o;
    public static ConcurrentMap<String, Class<?>> p;
    public static Class<?> q;
    public static boolean r;

    static {
        try {
            a = "true".equals(IOUtils.k("fastjson.compatibleWithJavaBean"));
            b = "true".equals(IOUtils.k("fastjson.compatibleWithFieldName"));
        } catch (Throwable unused) {
        }
        p = new ConcurrentHashMap(16, 0.75f, 1);
        a();
        r = false;
    }

    public static List<a> A(Class<?> cls, Map<String, String> map, boolean z, PropertyNamingStrategy propertyNamingStrategy) {
        LinkedHashMap linkedHashMap = new LinkedHashMap();
        for (Class<?> cls2 = cls; cls2 != null; cls2 = cls2.getSuperclass()) {
            y(cls2, map, propertyNamingStrategy, linkedHashMap, cls2.getDeclaredFields());
        }
        return I(cls, z, linkedHashMap);
    }

    public static Collection B(Type type) {
        Type type2;
        Class<?> M = M(type);
        if (M != AbstractCollection.class && M != Collection.class) {
            if (M.isAssignableFrom(HashSet.class)) {
                return new HashSet();
            }
            if (M.isAssignableFrom(LinkedHashSet.class)) {
                return new LinkedHashSet();
            }
            if (M.isAssignableFrom(TreeSet.class)) {
                return new TreeSet();
            }
            if (M.isAssignableFrom(ArrayList.class)) {
                return new ArrayList();
            }
            if (M.isAssignableFrom(EnumSet.class)) {
                if (type instanceof ParameterizedType) {
                    type2 = ((ParameterizedType) type).getActualTypeArguments()[0];
                } else {
                    type2 = Object.class;
                }
                return EnumSet.noneOf(type2);
            }
            try {
                return (Collection) M.newInstance();
            } catch (Exception unused) {
                throw new JSONException("create instance error, class " + M.getName());
            }
        }
        return new ArrayList();
    }

    public static String C(String str) {
        if (str == null || str.length() == 0) {
            return str;
        }
        if (str.length() > 1 && Character.isUpperCase(str.charAt(1)) && Character.isUpperCase(str.charAt(0))) {
            return str;
        }
        char[] charArray = str.toCharArray();
        charArray[0] = Character.toLowerCase(charArray[0]);
        return new String(charArray);
    }

    public static Class<?> D(Type type) {
        if (type.getClass() == Class.class) {
            return (Class) type;
        }
        if (type instanceof ParameterizedType) {
            return D(((ParameterizedType) type).getRawType());
        }
        if (type instanceof TypeVariable) {
            return (Class) ((TypeVariable) type).getBounds()[0];
        }
        return Object.class;
    }

    public static Class<?> E(String str) {
        return p.get(str);
    }

    public static Class<?> F(Type type) {
        if (type instanceof ParameterizedType) {
            Type type2 = ((ParameterizedType) type).getActualTypeArguments()[0];
            if (type2 instanceof WildcardType) {
                Type[] upperBounds = ((WildcardType) type2).getUpperBounds();
                if (upperBounds.length == 1) {
                    type2 = upperBounds[0];
                }
            }
            if (type2 instanceof Class) {
                Class<?> cls = (Class) type2;
                if (Modifier.isPublic(cls.getModifiers())) {
                    return cls;
                }
                throw new JSONException("can not create ASMParser");
            }
            throw new JSONException("can not create ASMParser");
        }
        return Object.class;
    }

    public static Type G(Type type) {
        Type type2;
        if (type instanceof ParameterizedType) {
            type2 = ((ParameterizedType) type).getActualTypeArguments()[0];
            if (type2 instanceof WildcardType) {
                Type[] upperBounds = ((WildcardType) type2).getUpperBounds();
                if (upperBounds.length == 1) {
                    type2 = upperBounds[0];
                }
            }
        } else {
            if (type instanceof Class) {
                Class cls = (Class) type;
                if (!cls.getName().startsWith("java.")) {
                    type2 = G(cls.getGenericSuperclass());
                }
            }
            type2 = null;
        }
        return type2 == null ? Object.class : type2;
    }

    public static Field H(Class<?> cls, String str, Field[] fieldArr) {
        for (Field field : fieldArr) {
            if (str.equals(field.getName())) {
                return field;
            }
        }
        Class<? super Object> superclass = cls.getSuperclass();
        if (superclass == null || superclass == Object.class) {
            return null;
        }
        return H(superclass, str, superclass.getDeclaredFields());
    }

    /* JADX WARN: Removed duplicated region for block: B:18:0x0033  */
    /* JADX WARN: Removed duplicated region for block: B:21:0x0044  */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static List<a> I(Class<?> cls, boolean z, Map<String, a> map) {
        String[] strArr;
        boolean z2;
        ArrayList arrayList = new ArrayList();
        d annotation = cls.getAnnotation(d.class);
        if (annotation != null) {
            strArr = annotation.orders();
            if (strArr != null && strArr.length == map.size()) {
                for (String str : strArr) {
                    if (map.containsKey(str)) {
                    }
                }
                z2 = true;
                if (z2) {
                    for (a aVar : map.values()) {
                        arrayList.add(aVar);
                    }
                    if (z) {
                        Collections.sort(arrayList);
                    }
                } else {
                    for (String str2 : strArr) {
                        arrayList.add(map.get(str2));
                    }
                }
                return arrayList;
            }
        } else {
            strArr = null;
        }
        z2 = false;
        if (z2) {
        }
        return arrayList;
    }

    public static Type J(Type type) {
        return (!(type instanceof ParameterizedType) && (type instanceof Class)) ? J(((Class) type).getGenericSuperclass()) : type;
    }

    public static int K(Class<?> cls) {
        d annotation = cls.getAnnotation(d.class);
        if (annotation == null) {
            return 0;
        }
        return Feature.of(annotation.parseFeatures());
    }

    public static String L(Map<String, Field> map, String str, String str2, int i2) {
        if (!b || map.containsKey(str2)) {
            return str2;
        }
        String substring = str.substring(i2);
        return map.containsKey(substring) ? substring : str2;
    }

    public static Class<?> M(Type type) {
        if (type instanceof Class) {
            return (Class) type;
        }
        if (type instanceof ParameterizedType) {
            return M(((ParameterizedType) type).getRawType());
        }
        throw new JSONException("TODO");
    }

    public static b N(Class<?> cls, Method method) {
        Method[] methods;
        boolean z;
        b annotation;
        Method[] methods2;
        boolean z2;
        b annotation2;
        Class<?>[] interfaces = cls.getInterfaces();
        if (interfaces.length > 0) {
            Class<?>[] parameterTypes = method.getParameterTypes();
            for (Class<?> cls2 : interfaces) {
                for (Method method2 : cls2.getMethods()) {
                    Class<?>[] parameterTypes2 = method2.getParameterTypes();
                    if (parameterTypes2.length == parameterTypes.length && method2.getName().equals(method.getName())) {
                        int i2 = 0;
                        while (true) {
                            if (i2 >= parameterTypes.length) {
                                z2 = true;
                                break;
                            } else if (!parameterTypes2[i2].equals(parameterTypes[i2])) {
                                z2 = false;
                                break;
                            } else {
                                i2++;
                            }
                        }
                        if (z2 && (annotation2 = method2.getAnnotation(b.class)) != null) {
                            return annotation2;
                        }
                    }
                }
            }
        }
        Class<? super Object> superclass = cls.getSuperclass();
        if (superclass != null && Modifier.isAbstract(superclass.getModifiers())) {
            Class<?>[] parameterTypes3 = method.getParameterTypes();
            for (Method method3 : superclass.getMethods()) {
                Class<?>[] parameterTypes4 = method3.getParameterTypes();
                if (parameterTypes4.length == parameterTypes3.length && method3.getName().equals(method.getName())) {
                    int i3 = 0;
                    while (true) {
                        if (i3 >= parameterTypes3.length) {
                            z = true;
                            break;
                        } else if (!parameterTypes4[i3].equals(parameterTypes3[i3])) {
                            z = false;
                            break;
                        } else {
                            i3++;
                        }
                    }
                    if (z && (annotation = method3.getAnnotation(b.class)) != null) {
                        return annotation;
                    }
                }
            }
        }
        return null;
    }

    public static boolean O(Method method) {
        if (method == null) {
            return false;
        }
        if (l == null && !m) {
            try {
                l = Class.forName("javax.persistence.OneToMany");
            } catch (Throwable unused) {
                m = true;
            }
        }
        Class<? extends Annotation> cls = l;
        if (cls == null) {
            return false;
        }
        return method.isAnnotationPresent(cls);
    }

    public static boolean P(Type type) {
        Type genericSuperclass;
        if (type instanceof ParameterizedType) {
            return true;
        }
        if (!(type instanceof Class) || (genericSuperclass = ((Class) type).getGenericSuperclass()) == Object.class) {
            return false;
        }
        return P(genericSuperclass);
    }

    public static boolean Q(Object obj) {
        if (obj == null) {
            return false;
        }
        if (n == null && !o) {
            try {
                n = Class.forName("org.hibernate.Hibernate").getMethod("isInitialized", Object.class);
            } catch (Throwable unused) {
                o = true;
            }
        }
        Method method = n;
        if (method != null) {
            try {
                return ((Boolean) method.invoke(null, obj)).booleanValue();
            } catch (Throwable unused2) {
            }
        }
        return true;
    }

    public static boolean R(Class<?> cls, String str) {
        d annotation = cls.getAnnotation(d.class);
        if (annotation != null) {
            String[] includes = annotation.includes();
            if (includes.length > 0) {
                for (String str2 : includes) {
                    if (str.equals(str2)) {
                        return false;
                    }
                }
                return true;
            }
            for (String str3 : annotation.ignores()) {
                if (str.equals(str3)) {
                    return true;
                }
            }
        }
        return (cls.getSuperclass() == Object.class || cls.getSuperclass() == null || !R(cls.getSuperclass(), str)) ? false : true;
    }

    public static boolean S(String str) {
        for (int i2 = 0; i2 < str.length(); i2++) {
            char charAt = str.charAt(i2);
            if (charAt == '+' || charAt == '-') {
                if (i2 != 0) {
                    return false;
                }
            } else if (charAt < '0' || charAt > '9') {
                return false;
            }
        }
        return true;
    }

    public static boolean T(Class<?> cls) {
        if (q == null && !r) {
            try {
                q = Class.forName("java.nio.file.Path");
            } catch (Throwable unused) {
                r = true;
            }
        }
        Class<?> cls2 = q;
        if (cls2 != null) {
            return cls2.isAssignableFrom(cls);
        }
        return false;
    }

    public static boolean U(Class<?> cls) {
        for (Class<?> cls2 : cls.getInterfaces()) {
            String name = cls2.getName();
            if (name.equals("net.sf.cglib.proxy.Factory") || name.equals("org.springframework.cglib.proxy.Factory") || name.equals("javassist.util.proxy.ProxyObject") || name.equals("org.apache.ibatis.javassist.util.proxy.ProxyObject")) {
                return true;
            }
        }
        return false;
    }

    public static boolean V(Method method) {
        if (method == null) {
            return false;
        }
        if (!j) {
            try {
                k = Class.forName("java.beans.Transient");
            } catch (Exception unused) {
            } catch (Throwable th) {
                j = true;
                throw th;
            }
            j = true;
        }
        Class<? extends Annotation> cls = k;
        return (cls == null || method.getAnnotation(cls) == null) ? false : true;
    }

    public static Class<?> W(String str) {
        return X(str, null);
    }

    public static Class<?> X(String str, ClassLoader classLoader) {
        if (str == null || str.length() == 0) {
            return null;
        }
        Class<?> cls = p.get(str);
        if (cls != null) {
            return cls;
        }
        if (str.charAt(0) == '[') {
            return Array.newInstance(X(str.substring(1), classLoader), 0).getClass();
        }
        if (str.startsWith("L") && str.endsWith(";")) {
            return X(str.substring(1, str.length() - 1), classLoader);
        }
        if (classLoader != null) {
            try {
                cls = classLoader.loadClass(str);
                p.put(str, cls);
                return cls;
            } catch (Throwable th) {
                th.printStackTrace();
            }
        }
        try {
            ClassLoader contextClassLoader = Thread.currentThread().getContextClassLoader();
            if (contextClassLoader != null && contextClassLoader != classLoader) {
                Class<?> loadClass = contextClassLoader.loadClass(str);
                try {
                    p.put(str, loadClass);
                    return loadClass;
                } catch (Throwable unused) {
                    cls = loadClass;
                }
            }
        } catch (Throwable unused2) {
        }
        try {
            cls = Class.forName(str);
            p.put(str, cls);
            return cls;
        } catch (Throwable unused3) {
            return cls;
        }
    }

    public static void Y(AccessibleObject accessibleObject) {
        if (c && !accessibleObject.isAccessible()) {
            try {
                accessibleObject.setAccessible(true);
            } catch (AccessControlException unused) {
                c = false;
            }
        }
    }

    public static Locale Z(String str) {
        String[] split = str.split("_");
        if (split.length == 1) {
            return new Locale(split[0]);
        }
        if (split.length == 2) {
            return new Locale(split[0], split[1]);
        }
        return new Locale(split[0], split[1], split[2]);
    }

    public static void a() {
        p.put("byte", Byte.TYPE);
        p.put("short", Short.TYPE);
        p.put("int", Integer.TYPE);
        p.put("long", Long.TYPE);
        p.put("float", Float.TYPE);
        p.put("double", Double.TYPE);
        p.put("boolean", Boolean.TYPE);
        p.put("char", Character.TYPE);
        p.put("[byte", byte[].class);
        p.put("[short", short[].class);
        p.put("[int", int[].class);
        p.put("[long", long[].class);
        p.put("[float", float[].class);
        p.put("[double", double[].class);
        p.put("[boolean", boolean[].class);
        p.put("[char", char[].class);
        p.put("[B", byte[].class);
        p.put("[S", short[].class);
        p.put("[I", int[].class);
        p.put("[J", long[].class);
        p.put("[F", float[].class);
        p.put("[D", double[].class);
        p.put("[C", char[].class);
        p.put("[Z", boolean[].class);
        Class<?>[] clsArr = {Object.class, Cloneable.class, W("java.lang.AutoCloseable"), Exception.class, RuntimeException.class, IllegalAccessError.class, IllegalAccessException.class, IllegalArgumentException.class, IllegalMonitorStateException.class, IllegalStateException.class, IllegalThreadStateException.class, IndexOutOfBoundsException.class, InstantiationError.class, InstantiationException.class, InternalError.class, InterruptedException.class, LinkageError.class, NegativeArraySizeException.class, NoClassDefFoundError.class, NoSuchFieldError.class, NoSuchFieldException.class, NoSuchMethodError.class, NoSuchMethodException.class, NullPointerException.class, NumberFormatException.class, OutOfMemoryError.class, SecurityException.class, StackOverflowError.class, StringIndexOutOfBoundsException.class, TypeNotPresentException.class, VerifyError.class, StackTraceElement.class, HashMap.class, Hashtable.class, TreeMap.class, java.util.IdentityHashMap.class, WeakHashMap.class, LinkedHashMap.class, HashSet.class, LinkedHashSet.class, TreeSet.class, TimeUnit.class, ConcurrentHashMap.class, W("java.util.concurrent.ConcurrentSkipListMap"), W("java.util.concurrent.ConcurrentSkipListSet"), AtomicInteger.class, AtomicLong.class, Collections.EMPTY_MAP.getClass(), BitSet.class, Calendar.class, Date.class, Locale.class, UUID.class, Time.class, java.sql.Date.class, Timestamp.class, SimpleDateFormat.class, JSONObject.class};
        for (int i2 = 0; i2 < 58; i2++) {
            Class<?> cls = clsArr[i2];
            if (cls != null) {
                p.put(cls.getName(), cls);
            }
        }
        String[] strArr = {"java.awt.Rectangle", "java.awt.Point", "java.awt.Font", "java.awt.Color"};
        for (int i3 = 0; i3 < 4; i3++) {
            Class<?> W = W(strArr[i3]);
            if (W == null) {
                break;
            }
            p.put(W.getName(), W);
        }
        String[] strArr2 = {"org.springframework.util.LinkedMultiValueMap", "org.springframework.util.LinkedCaseInsensitiveMap", "org.springframework.remoting.support.RemoteInvocation", "org.springframework.remoting.support.RemoteInvocationResult"};
        for (int i4 = 0; i4 < 4; i4++) {
            Class<?> W2 = W(strArr2[i4]);
            if (W2 == null) {
                return;
            }
            p.put(W2.getName(), W2);
        }
    }

    public static Type a0(Type type) {
        if (!h) {
            try {
                i = Class.forName("java.util.Optional");
            } catch (Exception unused) {
            } catch (Throwable th) {
                h = true;
                throw th;
            }
            h = true;
        }
        if (type instanceof ParameterizedType) {
            ParameterizedType parameterizedType = (ParameterizedType) type;
            return parameterizedType.getRawType() == i ? parameterizedType.getActualTypeArguments()[0] : type;
        }
        return type;
    }

    public static o b(Class<?> cls, Map<String, String> map, PropertyNamingStrategy propertyNamingStrategy) {
        return c(cls, map, propertyNamingStrategy, false);
    }

    public static o c(Class<?> cls, Map<String, String> map, PropertyNamingStrategy propertyNamingStrategy, boolean z) {
        int i2;
        String[] strArr;
        String str;
        String str2;
        List<a> z2;
        List<a> list;
        d annotation = cls.getAnnotation(d.class);
        if (annotation != null) {
            String[] orders = annotation.orders();
            String typeName = annotation.typeName();
            if (typeName.length() == 0) {
                typeName = null;
            }
            int of = SerializerFeature.of(annotation.serialzeFeatures());
            String str3 = null;
            for (Class<? super Object> superclass = cls.getSuperclass(); superclass != null && superclass != Object.class; superclass = superclass.getSuperclass()) {
                d annotation2 = superclass.getAnnotation(d.class);
                if (annotation2 == null) {
                    break;
                }
                str3 = annotation2.typeKey();
                if (str3.length() != 0) {
                    break;
                }
            }
            for (Class<?> cls2 : cls.getInterfaces()) {
                d annotation3 = cls2.getAnnotation(d.class);
                if (annotation3 != null) {
                    str3 = annotation3.typeKey();
                    if (str3.length() != 0) {
                        break;
                    }
                }
            }
            if (str3 == null || str3.length() != 0) {
                str = typeName;
                i2 = of;
                str2 = str3;
                strArr = orders;
            } else {
                str2 = null;
                strArr = orders;
                str = typeName;
                i2 = of;
            }
        } else {
            i2 = 0;
            strArr = null;
            str = null;
            str2 = null;
        }
        HashMap hashMap = new HashMap();
        ParserConfig.o(cls, hashMap);
        if (z) {
            z2 = A(cls, map, false, propertyNamingStrategy);
        } else {
            z2 = z(cls, annotation, map, hashMap, false, propertyNamingStrategy);
        }
        a[] aVarArr = new a[z2.size()];
        z2.toArray(aVarArr);
        if (strArr == null || strArr.length == 0) {
            ArrayList arrayList = new ArrayList(z2);
            Collections.sort(arrayList);
            list = arrayList;
        } else if (z) {
            list = A(cls, map, true, propertyNamingStrategy);
        } else {
            list = z(cls, annotation, map, hashMap, true, propertyNamingStrategy);
        }
        a[] aVarArr2 = new a[list.size()];
        list.toArray(aVarArr2);
        return new o(cls, annotation, str, str2, i2, aVarArr, Arrays.equals(aVarArr2, aVarArr) ? aVarArr : aVarArr2);
    }

    /* JADX WARN: Multi-variable type inference failed */
    public static <T> T d(Object obj, Class<T> cls, ParserConfig parserConfig) {
        T t;
        int i2 = 0;
        if (obj == 0) {
            if (cls == Integer.TYPE) {
                return (T) 0;
            }
            if (cls == Long.TYPE) {
                return (T) 0L;
            }
            if (cls == Short.TYPE) {
                return (T) (short) 0;
            }
            if (cls == Byte.TYPE) {
                return (T) (byte) 0;
            }
            if (cls == Float.TYPE) {
                return (T) Float.valueOf(0.0f);
            }
            if (cls == Double.TYPE) {
                return (T) Double.valueOf(0.0d);
            }
            if (cls == Boolean.TYPE) {
                return (T) Boolean.FALSE;
            }
            return null;
        } else if (cls != null) {
            if (cls == obj.getClass()) {
                return obj;
            }
            if (obj instanceof Map) {
                if (cls == Map.class) {
                    return obj;
                }
                Map map = (Map) obj;
                return (cls != Object.class || map.containsKey(JSON.DEFAULT_TYPE_KEY)) ? (T) s(map, cls, parserConfig) : obj;
            }
            if (cls.isArray()) {
                if (obj instanceof Collection) {
                    Collection<Object> collection = (Collection) obj;
                    T t2 = (T) Array.newInstance(cls.getComponentType(), collection.size());
                    for (Object obj2 : collection) {
                        Array.set(t2, i2, d(obj2, cls.getComponentType(), parserConfig));
                        i2++;
                    }
                    return t2;
                } else if (cls == byte[].class) {
                    return (T) k(obj);
                }
            }
            if (cls.isAssignableFrom(obj.getClass())) {
                return obj;
            }
            if (cls != Boolean.TYPE && cls != Boolean.class) {
                if (cls != Byte.TYPE && cls != Byte.class) {
                    if (cls != Character.TYPE && cls != Character.class) {
                        if (cls != Short.TYPE && cls != Short.class) {
                            if (cls != Integer.TYPE && cls != Integer.class) {
                                if (cls != Long.TYPE && cls != Long.class) {
                                    if (cls != Float.TYPE && cls != Float.class) {
                                        if (cls != Double.TYPE && cls != Double.class) {
                                            if (cls == String.class) {
                                                return (T) w(obj);
                                            }
                                            if (cls == BigDecimal.class) {
                                                return (T) g(obj);
                                            }
                                            if (cls == BigInteger.class) {
                                                return (T) h(obj);
                                            }
                                            if (cls == Date.class) {
                                                return (T) m(obj);
                                            }
                                            if (cls == java.sql.Date.class) {
                                                return (T) v(obj);
                                            }
                                            if (cls == Timestamp.class) {
                                                return (T) x(obj);
                                            }
                                            if (cls.isEnum()) {
                                                return (T) o(obj, cls, parserConfig);
                                            }
                                            if (Calendar.class.isAssignableFrom(cls)) {
                                                Date m2 = m(obj);
                                                if (cls == Calendar.class) {
                                                    t = (T) Calendar.getInstance(JSON.defaultTimeZone, JSON.defaultLocale);
                                                } else {
                                                    try {
                                                        t = (T) ((Calendar) cls.newInstance());
                                                    } catch (Exception e2) {
                                                        throw new JSONException("can not cast to : " + cls.getName(), e2);
                                                    }
                                                }
                                                ((Calendar) t).setTime(m2);
                                                return t;
                                            } else if (cls.getName().equals("javax.xml.datatype.XMLGregorianCalendar")) {
                                                Date m3 = m(obj);
                                                Calendar calendar = Calendar.getInstance(JSON.defaultTimeZone, JSON.defaultLocale);
                                                calendar.setTime(m3);
                                                return (T) CalendarCodec.b.f(calendar);
                                            } else {
                                                if (obj instanceof String) {
                                                    String str = (String) obj;
                                                    if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                                                        return null;
                                                    }
                                                    if (cls == Currency.class) {
                                                        return (T) Currency.getInstance(str);
                                                    }
                                                    if (cls == Locale.class) {
                                                        return (T) Z(str);
                                                    }
                                                }
                                                throw new JSONException("can not cast to : " + cls.getName());
                                            }
                                        }
                                        return (T) n(obj);
                                    }
                                    return (T) p(obj);
                                }
                                return (T) t(obj);
                            }
                            return (T) q(obj);
                        }
                        return (T) u(obj);
                    }
                    return (T) l(obj);
                }
                return (T) j(obj);
            }
            return (T) i(obj);
        } else {
            throw new IllegalArgumentException("clazz is null");
        }
    }

    /* JADX WARN: Type inference failed for: r7v8, types: [T, java.util.Map, java.util.HashMap] */
    public static <T> T e(Object obj, ParameterizedType parameterizedType, ParserConfig parserConfig) {
        T t;
        Type rawType = parameterizedType.getRawType();
        if (rawType == Set.class || rawType == HashSet.class || rawType == TreeSet.class || rawType == List.class || rawType == ArrayList.class) {
            Type type = parameterizedType.getActualTypeArguments()[0];
            if (obj instanceof Iterable) {
                if (rawType != Set.class && rawType != HashSet.class) {
                    if (rawType == TreeSet.class) {
                        t = (T) new TreeSet();
                    } else {
                        t = (T) new ArrayList();
                    }
                } else {
                    t = (T) new HashSet();
                }
                for (T t2 : (Iterable) obj) {
                    ((Collection) t).add(f(t2, type, parserConfig));
                }
                return t;
            }
        }
        if (rawType == Map.class || rawType == HashMap.class) {
            Type type2 = parameterizedType.getActualTypeArguments()[0];
            Type type3 = parameterizedType.getActualTypeArguments()[1];
            if (obj instanceof Map) {
                ?? r7 = (T) new HashMap();
                for (Map.Entry entry : ((Map) obj).entrySet()) {
                    r7.put(f(entry.getKey(), type2, parserConfig), f(entry.getValue(), type3, parserConfig));
                }
                return r7;
            }
        }
        if ((obj instanceof String) && ((String) obj).length() == 0) {
            return null;
        }
        if (parameterizedType.getActualTypeArguments().length == 1 && (parameterizedType.getActualTypeArguments()[0] instanceof WildcardType)) {
            return (T) f(obj, rawType, parserConfig);
        }
        throw new JSONException("can not cast to : " + parameterizedType);
    }

    /* JADX WARN: Multi-variable type inference failed */
    public static <T> T f(Object obj, Type type, ParserConfig parserConfig) {
        if (obj == 0) {
            return null;
        }
        if (type instanceof Class) {
            return (T) d(obj, (Class) type, parserConfig);
        }
        if (type instanceof ParameterizedType) {
            return (T) e(obj, (ParameterizedType) type, parserConfig);
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
        }
        if (type instanceof TypeVariable) {
            return obj;
        }
        throw new JSONException("can not cast to : " + type);
    }

    public static BigDecimal g(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof BigDecimal) {
            return (BigDecimal) obj;
        }
        if (obj instanceof BigInteger) {
            return new BigDecimal((BigInteger) obj);
        }
        String obj2 = obj.toString();
        if (obj2.length() == 0) {
            return null;
        }
        if ((obj instanceof Map) && ((Map) obj).size() == 0) {
            return null;
        }
        return new BigDecimal(obj2);
    }

    public static BigInteger h(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof BigInteger) {
            return (BigInteger) obj;
        }
        if (!(obj instanceof Float) && !(obj instanceof Double)) {
            String obj2 = obj.toString();
            if (obj2.length() == 0 || "null".equals(obj2) || "NULL".equals(obj2)) {
                return null;
            }
            return new BigInteger(obj2);
        }
        return BigInteger.valueOf(((Number) obj).longValue());
    }

    public static Boolean i(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Boolean) {
            return (Boolean) obj;
        }
        if (obj instanceof Number) {
            return Boolean.valueOf(((Number) obj).intValue() == 1);
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            if (!"true".equalsIgnoreCase(str) && !"1".equals(str)) {
                if (!"false".equalsIgnoreCase(str) && !"0".equals(str)) {
                    if (!"Y".equalsIgnoreCase(str) && !"T".equals(str)) {
                        if ("F".equalsIgnoreCase(str) || "N".equals(str)) {
                            return Boolean.FALSE;
                        }
                    } else {
                        return Boolean.TRUE;
                    }
                } else {
                    return Boolean.FALSE;
                }
            } else {
                return Boolean.TRUE;
            }
        }
        throw new JSONException("can not cast to boolean, value : " + obj);
    }

    public static Byte j(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Number) {
            return Byte.valueOf(((Number) obj).byteValue());
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            return Byte.valueOf(Byte.parseByte(str));
        }
        throw new JSONException("can not cast to byte, value : " + obj);
    }

    public static byte[] k(Object obj) {
        if (obj instanceof byte[]) {
            return (byte[]) obj;
        }
        if (obj instanceof String) {
            return IOUtils.c((String) obj);
        }
        throw new JSONException("can not cast to int, value : " + obj);
    }

    public static Character l(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Character) {
            return (Character) obj;
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0) {
                return null;
            }
            if (str.length() == 1) {
                return Character.valueOf(str.charAt(0));
            }
            throw new JSONException("can not cast to char, value : " + obj);
        }
        throw new JSONException("can not cast to char, value : " + obj);
    }

    public static Date m(Object obj) {
        String str;
        if (obj == null) {
            return null;
        }
        if (obj instanceof Date) {
            return (Date) obj;
        }
        if (obj instanceof Calendar) {
            return ((Calendar) obj).getTime();
        }
        long j2 = -1;
        if (obj instanceof Number) {
            return new Date(((Number) obj).longValue());
        }
        if (obj instanceof String) {
            String str2 = (String) obj;
            e eVar = new e(str2);
            try {
                if (eVar.A0(false)) {
                    return eVar.R().getTime();
                }
                eVar.close();
                if (str2.startsWith("/Date(") && str2.endsWith(")/")) {
                    str2 = str2.substring(6, str2.length() - 2);
                }
                if (str2.indexOf(45) != -1) {
                    if (str2.length() == JSON.DEFFAULT_DATE_FORMAT.length()) {
                        str = JSON.DEFFAULT_DATE_FORMAT;
                    } else if (str2.length() == 10) {
                        str = "yyyy-MM-dd";
                    } else if (str2.length() == 19) {
                        str = "yyyy-MM-dd HH:mm:ss";
                    } else {
                        str = (str2.length() == 29 && str2.charAt(26) == ':' && str2.charAt(28) == '0') ? "yyyy-MM-dd'T'HH:mm:ss.SSSXXX" : "yyyy-MM-dd HH:mm:ss.SSS";
                    }
                    SimpleDateFormat simpleDateFormat = new SimpleDateFormat(str, JSON.defaultLocale);
                    simpleDateFormat.setTimeZone(JSON.defaultTimeZone);
                    try {
                        return simpleDateFormat.parse(str2);
                    } catch (ParseException unused) {
                        throw new JSONException("can not cast to Date, value : " + str2);
                    }
                } else if (str2.length() == 0) {
                    return null;
                } else {
                    j2 = Long.parseLong(str2);
                }
            } finally {
                eVar.close();
            }
        }
        if (j2 < 0) {
            Class<?> cls = obj.getClass();
            if ("oracle.sql.TIMESTAMP".equals(cls.getName())) {
                if (e == null && !d) {
                    try {
                        e = cls.getMethod("toJdbc", new Class[0]);
                    } catch (NoSuchMethodException unused2) {
                    } catch (Throwable th) {
                        d = true;
                        throw th;
                    }
                    d = true;
                }
                try {
                    return (Date) e.invoke(obj, new Object[0]);
                } catch (Exception e2) {
                    throw new JSONException("can not cast oracle.sql.TIMESTAMP to Date", e2);
                }
            } else if ("oracle.sql.DATE".equals(cls.getName())) {
                if (g == null && !f) {
                    try {
                        g = cls.getMethod("toJdbc", new Class[0]);
                    } catch (NoSuchMethodException unused3) {
                    } catch (Throwable th2) {
                        f = true;
                        throw th2;
                    }
                    f = true;
                }
                try {
                    return (Date) g.invoke(obj, new Object[0]);
                } catch (Exception e3) {
                    throw new JSONException("can not cast oracle.sql.DATE to Date", e3);
                }
            } else {
                throw new JSONException("can not cast to Date, value : " + obj);
            }
        }
        return new Date(j2);
    }

    public static Double n(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Number) {
            return Double.valueOf(((Number) obj).doubleValue());
        }
        if (obj instanceof String) {
            String obj2 = obj.toString();
            if (obj2.length() == 0 || "null".equals(obj2) || "NULL".equals(obj2)) {
                return null;
            }
            if (obj2.indexOf(44) != 0) {
                obj2 = obj2.replaceAll(",", "");
            }
            return Double.valueOf(Double.parseDouble(obj2));
        }
        throw new JSONException("can not cast to double, value : " + obj);
    }

    public static <T> T o(Object obj, Class<T> cls, ParserConfig parserConfig) {
        try {
            if (obj instanceof String) {
                String str = (String) obj;
                if (str.length() == 0) {
                    return null;
                }
                return (T) Enum.valueOf(cls, str);
            }
            if (obj instanceof Number) {
                int intValue = ((Number) obj).intValue();
                T[] enumConstants = cls.getEnumConstants();
                if (intValue < enumConstants.length) {
                    return enumConstants[intValue];
                }
            }
            throw new JSONException("can not cast to : " + cls.getName());
        } catch (Exception e2) {
            throw new JSONException("can not cast to : " + cls.getName(), e2);
        }
    }

    public static Float p(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Number) {
            return Float.valueOf(((Number) obj).floatValue());
        }
        if (obj instanceof String) {
            String obj2 = obj.toString();
            if (obj2.length() == 0 || "null".equals(obj2) || "NULL".equals(obj2)) {
                return null;
            }
            if (obj2.indexOf(44) != 0) {
                obj2 = obj2.replaceAll(",", "");
            }
            return Float.valueOf(Float.parseFloat(obj2));
        }
        throw new JSONException("can not cast to float, value : " + obj);
    }

    public static Integer q(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Integer) {
            return (Integer) obj;
        }
        if (obj instanceof Number) {
            return Integer.valueOf(((Number) obj).intValue());
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            if (str.indexOf(44) != 0) {
                str = str.replaceAll(",", "");
            }
            return Integer.valueOf(Integer.parseInt(str));
        } else if (obj instanceof Boolean) {
            return Integer.valueOf(((Boolean) obj).booleanValue() ? 1 : 0);
        } else {
            if (obj instanceof Map) {
                Map map = (Map) obj;
                if (map.size() == 2 && map.containsKey("andIncrement") && map.containsKey("andDecrement")) {
                    Iterator it = map.values().iterator();
                    it.next();
                    return q(it.next());
                }
            }
            throw new JSONException("can not cast to int, value : " + obj);
        }
    }

    public static <T> T r(Object obj, Class<T> cls) {
        return (T) d(obj, cls, ParserConfig.m());
    }

    public static <T> T s(Map<String, Object> map, Class<T> cls, ParserConfig parserConfig) {
        JSONObject jSONObject;
        int i2 = 0;
        try {
            if (cls == StackTraceElement.class) {
                String str = (String) map.get("className");
                String str2 = (String) map.get("methodName");
                String str3 = (String) map.get("fileName");
                Number number = (Number) map.get("lineNumber");
                if (number != null) {
                    i2 = number.intValue();
                }
                return (T) new StackTraceElement(str, str2, str3, i2);
            }
            Object obj = map.get(JSON.DEFAULT_TYPE_KEY);
            if (obj instanceof String) {
                String str4 = (String) obj;
                if (parserConfig == null) {
                    parserConfig = ParserConfig.p;
                }
                Class<?> e2 = parserConfig.e(str4, null);
                if (e2 != null) {
                    if (!e2.equals(cls)) {
                        return (T) s(map, e2, parserConfig);
                    }
                } else {
                    throw new ClassNotFoundException(str4 + " not found");
                }
            }
            if (cls.isInterface()) {
                if (map instanceof JSONObject) {
                    jSONObject = (JSONObject) map;
                } else {
                    jSONObject = new JSONObject(map);
                }
                if (parserConfig == null) {
                    parserConfig = ParserConfig.m();
                }
                return parserConfig.k().b(cls) != null ? (T) JSON.parseObject(JSON.toJSONString(jSONObject), cls) : (T) Proxy.newProxyInstance(Thread.currentThread().getContextClassLoader(), new Class[]{cls}, jSONObject);
            }
            if (cls == Locale.class) {
                Object obj2 = map.get("language");
                Object obj3 = map.get("country");
                if (obj2 instanceof String) {
                    String str5 = (String) obj2;
                    if (obj3 instanceof String) {
                        return (T) new Locale(str5, (String) obj3);
                    }
                    if (obj3 == null) {
                        return (T) new Locale(str5);
                    }
                }
            }
            if (cls == String.class && (map instanceof JSONObject)) {
                return (T) map.toString();
            }
            if (parserConfig == null) {
                parserConfig = ParserConfig.m();
            }
            l j2 = parserConfig.j(cls);
            k kVar = j2 instanceof k ? (k) j2 : null;
            if (kVar != null) {
                return (T) kVar.f(map, parserConfig);
            }
            throw new JSONException("can not get javaBeanDeserializer. " + cls.getName());
        } catch (Exception e3) {
            throw new JSONException(e3.getMessage(), e3);
        }
    }

    public static Long t(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Number) {
            return Long.valueOf(((Number) obj).longValue());
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            if (str.indexOf(44) != 0) {
                str = str.replaceAll(",", "");
            }
            try {
                return Long.valueOf(Long.parseLong(str));
            } catch (NumberFormatException unused) {
                e eVar = new e(str);
                Calendar R = eVar.A0(false) ? eVar.R() : null;
                eVar.close();
                if (R != null) {
                    return Long.valueOf(R.getTimeInMillis());
                }
            }
        }
        if (obj instanceof Map) {
            Map map = (Map) obj;
            if (map.size() == 2 && map.containsKey("andIncrement") && map.containsKey("andDecrement")) {
                Iterator it = map.values().iterator();
                it.next();
                return t(it.next());
            }
        }
        throw new JSONException("can not cast to long, value : " + obj);
    }

    public static Short u(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Number) {
            return Short.valueOf(((Number) obj).shortValue());
        }
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            return Short.valueOf(Short.parseShort(str));
        }
        throw new JSONException("can not cast to short, value : " + obj);
    }

    public static java.sql.Date v(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof java.sql.Date) {
            return (java.sql.Date) obj;
        }
        if (obj instanceof Date) {
            return new java.sql.Date(((Date) obj).getTime());
        }
        if (obj instanceof Calendar) {
            return new java.sql.Date(((Calendar) obj).getTimeInMillis());
        }
        long longValue = obj instanceof Number ? ((Number) obj).longValue() : 0L;
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            if (S(str)) {
                longValue = Long.parseLong(str);
            } else {
                e eVar = new e(str);
                if (eVar.A0(false)) {
                    longValue = eVar.R().getTime().getTime();
                } else {
                    throw new JSONException("can not cast to Timestamp, value : " + str);
                }
            }
        }
        if (longValue > 0) {
            return new java.sql.Date(longValue);
        }
        throw new JSONException("can not cast to Date, value : " + obj);
    }

    public static String w(Object obj) {
        if (obj == null) {
            return null;
        }
        return obj.toString();
    }

    public static Timestamp x(Object obj) {
        if (obj == null) {
            return null;
        }
        if (obj instanceof Calendar) {
            return new Timestamp(((Calendar) obj).getTimeInMillis());
        }
        if (obj instanceof Timestamp) {
            return (Timestamp) obj;
        }
        if (obj instanceof Date) {
            return new Timestamp(((Date) obj).getTime());
        }
        long longValue = obj instanceof Number ? ((Number) obj).longValue() : 0L;
        if (obj instanceof String) {
            String str = (String) obj;
            if (str.length() == 0 || "null".equals(str) || "NULL".equals(str)) {
                return null;
            }
            if (S(str)) {
                longValue = Long.parseLong(str);
            } else {
                e eVar = new e(str);
                if (eVar.A0(false)) {
                    longValue = eVar.R().getTime().getTime();
                } else {
                    throw new JSONException("can not cast to Timestamp, value : " + str);
                }
            }
        }
        if (longValue > 0) {
            return new Timestamp(longValue);
        }
        throw new JSONException("can not cast to Timestamp, value : " + obj);
    }

    public static void y(Class<?> cls, Map<String, String> map, PropertyNamingStrategy propertyNamingStrategy, Map<String, a> map2, Field[] fieldArr) {
        String str;
        int i2;
        int i3;
        int i4;
        for (Field field : fieldArr) {
            if (!Modifier.isStatic(field.getModifiers())) {
                b annotation = field.getAnnotation(b.class);
                String name = field.getName();
                if (annotation == null) {
                    str = null;
                    i2 = 0;
                    i3 = 0;
                    i4 = 0;
                } else if (annotation.serialize()) {
                    int ordinal = annotation.ordinal();
                    int of = SerializerFeature.of(annotation.serialzeFeatures());
                    int of2 = Feature.of(annotation.parseFeatures());
                    if (annotation.name().length() != 0) {
                        name = annotation.name();
                    }
                    str = annotation.label().length() != 0 ? annotation.label() : null;
                    i2 = ordinal;
                    i3 = of;
                    i4 = of2;
                }
                if (map == null || (name = map.get(name)) != null) {
                    if (propertyNamingStrategy != null) {
                        name = propertyNamingStrategy.translate(name);
                    }
                    String str2 = name;
                    if (!map2.containsKey(str2)) {
                        map2.put(str2, new a(str2, (Method) null, field, cls, (Type) null, i2, i3, i4, (b) null, annotation, str));
                    }
                }
            }
        }
    }

    /* JADX WARN: Code restructure failed: missing block: B:157:0x0356, code lost:
        if (r0 == null) goto L118;
     */
    /* JADX WARN: Code restructure failed: missing block: B:98:0x020c, code lost:
        if (r0 == null) goto L33;
     */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
    */
    public static List<a> z(Class<?> cls, d dVar, Map<String, String> map, Map<String, Field> map2, boolean z, PropertyNamingStrategy propertyNamingStrategy) {
        int i2;
        int i3;
        Method[] methodArr;
        LinkedHashMap linkedHashMap;
        int i4;
        int i5;
        int i6;
        String str;
        Method method;
        char c2;
        String substring;
        int i7;
        int i8;
        int i9;
        b bVar;
        LinkedHashMap linkedHashMap2;
        String str2;
        String str3;
        String L;
        int i10;
        int i11;
        int i12;
        String str4;
        b bVar2;
        char charAt;
        Class<?> cls2 = cls;
        Map<String, String> map3 = map;
        Map<String, Field> map4 = map2;
        PropertyNamingStrategy propertyNamingStrategy2 = propertyNamingStrategy;
        LinkedHashMap linkedHashMap3 = new LinkedHashMap();
        Method[] methods = cls.getMethods();
        int length = methods.length;
        int i13 = 0;
        while (i13 < length) {
            Method method2 = methods[i13];
            String name = method2.getName();
            String str5 = null;
            if (!Modifier.isStatic(method2.getModifiers()) && !method2.getReturnType().equals(Void.TYPE) && method2.getParameterTypes().length == 0 && method2.getReturnType() != ClassLoader.class && (!method2.getName().equals("getMetaClass") || !method2.getReturnType().getName().equals("groovy.lang.MetaClass"))) {
                b annotation = method2.getAnnotation(b.class);
                if (annotation == null) {
                    annotation = N(cls2, method2);
                }
                b bVar3 = annotation;
                if (bVar3 == null) {
                    i2 = i13;
                    i3 = length;
                    methodArr = methods;
                    linkedHashMap = linkedHashMap3;
                    i4 = 0;
                    i5 = 0;
                    i6 = 0;
                } else if (bVar3.serialize()) {
                    i4 = bVar3.ordinal();
                    i5 = SerializerFeature.of(bVar3.serialzeFeatures());
                    i6 = Feature.of(bVar3.parseFeatures());
                    if (bVar3.name().length() != 0) {
                        String name2 = bVar3.name();
                        if (map3 == null || (name2 = map3.get(name2)) != null) {
                            String str6 = name2;
                            i2 = i13;
                            i3 = length;
                            methodArr = methods;
                            linkedHashMap = linkedHashMap3;
                            linkedHashMap.put(str6, new a(str6, method2, (Field) null, cls, (Type) null, i4, i5, i6, bVar3, (b) null, (String) null));
                            linkedHashMap2 = linkedHashMap;
                            propertyNamingStrategy2 = propertyNamingStrategy;
                            i13 = i2 + 1;
                            map4 = map2;
                            linkedHashMap3 = linkedHashMap2;
                            length = i3;
                            methods = methodArr;
                            cls2 = cls;
                        }
                    } else {
                        i2 = i13;
                        i3 = length;
                        methodArr = methods;
                        linkedHashMap = linkedHashMap3;
                        if (bVar3.label().length() != 0) {
                            str5 = bVar3.label();
                        }
                    }
                }
                if (name.startsWith("get")) {
                    if (name.length() >= 4 && !name.equals("getClass") && (!name.equals("getDeclaringClass") || !cls.isEnum())) {
                        char charAt2 = name.charAt(3);
                        if (Character.isUpperCase(charAt2) || charAt2 > 512) {
                            if (a) {
                                str3 = C(name.substring(3));
                            } else {
                                str3 = Character.toLowerCase(name.charAt(3)) + name.substring(4);
                            }
                            L = L(map4, name, str3, 3);
                        } else if (charAt2 == '_') {
                            L = name.substring(4);
                        } else if (charAt2 == 'f') {
                            L = name.substring(3);
                        } else if (name.length() >= 5 && Character.isUpperCase(name.charAt(4))) {
                            L = C(name.substring(3));
                        }
                        if (!R(cls2, L)) {
                            Field l2 = ParserConfig.l(L, map4);
                            if (l2 == null && L.length() > 1 && (charAt = L.charAt(1)) >= 'A' && charAt <= 'Z') {
                                l2 = ParserConfig.l(C(name.substring(3)), map4);
                            }
                            Field field = l2;
                            if (field != null) {
                                b bVar4 = (b) field.getAnnotation(b.class);
                                if (bVar4 == null) {
                                    i10 = i6;
                                    i11 = i5;
                                    i12 = i4;
                                } else if (bVar4.serialize()) {
                                    int ordinal = bVar4.ordinal();
                                    int of = SerializerFeature.of(bVar4.serialzeFeatures());
                                    int of2 = Feature.of(bVar4.parseFeatures());
                                    if (bVar4.name().length() != 0) {
                                        L = bVar4.name();
                                        if (map3 != null) {
                                            L = map3.get(L);
                                        }
                                    }
                                    if (bVar4.label().length() != 0) {
                                        bVar2 = bVar4;
                                        i12 = ordinal;
                                        i11 = of;
                                        i10 = of2;
                                        str4 = bVar4.label();
                                    } else {
                                        i12 = ordinal;
                                        i11 = of;
                                        i10 = of2;
                                    }
                                }
                                str4 = str5;
                                bVar2 = bVar4;
                            } else {
                                i10 = i6;
                                i11 = i5;
                                i12 = i4;
                                str4 = str5;
                                bVar2 = null;
                            }
                            if (map3 == null || (L = map3.get(L)) != null) {
                                LinkedHashMap linkedHashMap4 = linkedHashMap;
                                if (propertyNamingStrategy != null) {
                                    L = propertyNamingStrategy.translate(L);
                                }
                                String str7 = L;
                                str = name;
                                method = method2;
                                c2 = 'f';
                                linkedHashMap3 = linkedHashMap4;
                                linkedHashMap3.put(str7, new a(str7, method2, field, cls, (Type) null, i12, i11, i10, bVar3, bVar2, str4));
                                str5 = str4;
                                i4 = i12;
                                i5 = i11;
                                i6 = i10;
                            }
                        }
                    }
                    linkedHashMap2 = linkedHashMap;
                    propertyNamingStrategy2 = propertyNamingStrategy;
                    i13 = i2 + 1;
                    map4 = map2;
                    linkedHashMap3 = linkedHashMap2;
                    length = i3;
                    methods = methodArr;
                    cls2 = cls;
                } else {
                    str = name;
                    method = method2;
                    c2 = 'f';
                    linkedHashMap3 = linkedHashMap;
                }
                String str8 = str;
                if (str8.startsWith("is") && str8.length() >= 3 && (method.getReturnType() == Boolean.TYPE || method.getReturnType() == Boolean.class)) {
                    char charAt3 = str8.charAt(2);
                    if (Character.isUpperCase(charAt3)) {
                        if (a) {
                            str2 = C(str8.substring(2));
                        } else {
                            str2 = Character.toLowerCase(str8.charAt(2)) + str8.substring(3);
                        }
                        substring = L(map4, str8, str2, 2);
                    } else if (charAt3 == '_') {
                        substring = str8.substring(3);
                    } else if (charAt3 == c2) {
                        substring = str8.substring(2);
                    }
                    if (!R(cls, substring)) {
                        Field l3 = ParserConfig.l(substring, map4);
                        Field l4 = l3 == null ? ParserConfig.l(str8, map4) : l3;
                        if (l4 != null) {
                            b bVar5 = (b) l4.getAnnotation(b.class);
                            if (bVar5 == null) {
                                map3 = map;
                                bVar = bVar5;
                                i7 = i4;
                                i8 = i5;
                                i9 = i6;
                            } else if (bVar5.serialize()) {
                                int ordinal2 = bVar5.ordinal();
                                int of3 = SerializerFeature.of(bVar5.serialzeFeatures());
                                int of4 = Feature.of(bVar5.parseFeatures());
                                if (bVar5.name().length() != 0) {
                                    substring = bVar5.name();
                                    map3 = map;
                                    if (map3 != null) {
                                        substring = map3.get(substring);
                                    }
                                } else {
                                    map3 = map;
                                }
                                if (bVar5.label().length() != 0) {
                                    bVar = bVar5;
                                    i8 = of3;
                                    i9 = of4;
                                    str5 = bVar5.label();
                                    i7 = ordinal2;
                                } else {
                                    bVar = bVar5;
                                    i7 = ordinal2;
                                    i8 = of3;
                                    i9 = of4;
                                }
                            }
                        } else {
                            map3 = map;
                            i7 = i4;
                            i8 = i5;
                            i9 = i6;
                            bVar = null;
                        }
                        if (map3 == null || (substring = map3.get(substring)) != null) {
                            propertyNamingStrategy2 = propertyNamingStrategy;
                            if (propertyNamingStrategy2 != null) {
                                substring = propertyNamingStrategy2.translate(substring);
                            }
                            String str9 = substring;
                            if (!linkedHashMap3.containsKey(str9)) {
                                linkedHashMap2 = linkedHashMap3;
                                linkedHashMap2.put(str9, new a(str9, method, l4, cls, (Type) null, i7, i8, i9, bVar3, bVar, str5));
                                i13 = i2 + 1;
                                map4 = map2;
                                linkedHashMap3 = linkedHashMap2;
                                length = i3;
                                methods = methodArr;
                                cls2 = cls;
                            }
                            linkedHashMap2 = linkedHashMap3;
                            i13 = i2 + 1;
                            map4 = map2;
                            linkedHashMap3 = linkedHashMap2;
                            length = i3;
                            methods = methodArr;
                            cls2 = cls;
                        }
                        propertyNamingStrategy2 = propertyNamingStrategy;
                        linkedHashMap2 = linkedHashMap3;
                        i13 = i2 + 1;
                        map4 = map2;
                        linkedHashMap3 = linkedHashMap2;
                        length = i3;
                        methods = methodArr;
                        cls2 = cls;
                    }
                }
                map3 = map;
                propertyNamingStrategy2 = propertyNamingStrategy;
                linkedHashMap2 = linkedHashMap3;
                i13 = i2 + 1;
                map4 = map2;
                linkedHashMap3 = linkedHashMap2;
                length = i3;
                methods = methodArr;
                cls2 = cls;
            }
            i2 = i13;
            i3 = length;
            methodArr = methods;
            linkedHashMap2 = linkedHashMap3;
            i13 = i2 + 1;
            map4 = map2;
            linkedHashMap3 = linkedHashMap2;
            length = i3;
            methods = methodArr;
            cls2 = cls;
        }
        LinkedHashMap linkedHashMap5 = linkedHashMap3;
        y(cls, map3, propertyNamingStrategy2, linkedHashMap5, cls.getFields());
        return I(cls, z, linkedHashMap5);
    }
}
